#ifndef __RingBuf_h
#define __RingBuf_h

#include "SerIOTypes.h"
      
typedef struct RingBuf
{
int8plus mIn;
int8plus mOut;
#if !defined(__AVR_ARCH__)
int8plus mLFCount;
#endif
Byte mBuf[SERIALBUFLENBYTES];
} RingBuf;

void ringBufInit(RingBuf *rb);


INLINEFUNCTION(int8plus ringBufCount(RingBuf *rb))
   {//SERIALBUFLENBYTES must be power of 2
   return (rb->mIn - rb->mOut) & (SERIALBUFLENBYTES-1);
   }
   
INLINEFUNCTION(int8plus ringBufSpace(RingBuf *rb))
   {//SERIALBUFLENBYTES must be power of 2
   return (SERIALBUFLENBYTES-1)-ringBufCount(rb);
   }
   
#if !defined(__AVR_ARCH__)
INLINEFUNCTION(int8plus ringBufLFCount(RingBuf *rb))
   {//SERIALBUFLENBYTES must be power of 2
   return rb->mLFCount;
   }
#endif
   

int8plus ringBufNext(RingBuf *rb, int8plus *charOut); //returns 0 if no char available


INLINEFUNCTION(int8plus ringBufNext6Bit(RingBuf *rb,int8plus *charOut)) //returns 0 if no char available
{
int8plus success = ringBufNext(rb,charOut);
*charOut &= 0x3f;
return success;
}

int8plus ringBufPeek(RingBuf *rb,int8plus *charOut); //returns 0 if no char available

int8plus ringBufPut(RingBuf *rb, int8plus charIn);  //returns 1 if char added 

int8plus ringBufPuts(RingBuf *rb, const char* strIn);


#endif
