#ifndef _SerIOTypes_h
#define _SerIOTypes_h

#ifdef _WIN32

typedef unsigned short uint16;
typedef short int16; 
typedef unsigned char uint8;
typedef char int8;

typedef int int8plus; //8 bits or more.
typedef unsigned int uint8plus; //8 bits or more.
typedef int8 Bool;
typedef uint8 Byte;
typedef unsigned int uint16plus; //16 bits or more.

#define CAFCHECK(p) _ASSERT(p)

#define INLINEFUNCTION(func) inline func

#define SERIALBUFLENBYTES 128  //must be power of 2 - moved into SerIOTypes.h because needs to be platform dependent.

// ---------------------------------------------------------
#elif defined(__AVR)
 
#include <inttypes.h>

typedef uint16_t uint16;
typedef int16_t int16; 
typedef uint8_t uint8;
typedef int8_t int8;

typedef int8 int8plus; //8 bits or more.
typedef uint8 uint8plus; //8 bits or more.
typedef int8 Bool;
typedef uint8 Byte;
typedef uint16 uint16plus; //16 bits or more.

#ifdef _DEBUG
#define CAFCHECK(p) _ASSERT(p)
#else
#define CAFCHECK(p) 
#endif

#define INLINEFUNCTION(func) inline func

#define SERIALBUFLENBYTES 32  //must be power of 2 - moved into SerIOTypes.h because needs to be platform dependent.
// ---------------------------------------------------------

#else  //ARM CHDK

// gcc ARM compiler needs this incantation to generate inline functions!
#define INLINEFUNCTION(func) func __attribute__((always_inline));  inline extern func

typedef unsigned short uint16;
typedef short int16; 
typedef unsigned char uint8;
typedef signed char int8;

typedef int int8plus; //8 bits or more.
typedef unsigned int uint8plus; //8 bits or more.
typedef int8 Bool;
typedef uint8 Byte;
typedef unsigned int uint16plus; //16 bits or more.

#ifdef _DEBUG
#define CAFCHECK(p) _ASSERT(p)
#else
#define CAFCHECK(p) 
#endif

#define SERIALBUFLENBYTES 128  //must be power of 2 - moved into SerIOTypes.h because needs to be platform dependent.
#endif

#endif
