#ifndef DRAW_PALETTE_H
#define DRAW_PALETTE_H
//-------------------------------------------------------------------
#include "gui.h"

//-------------------------------------------------------------------

#define PALETTE_MODE_DEFAULT    0
#define PALETTE_MODE_SELECT     1

//-------------------------------------------------------------------
extern void gui_palette_init(int mode, color st_color, void (*on_select)(color clr));
extern void gui_palette_kbd_process();
extern void gui_palette_draw();

//-------------------------------------------------------------------
#if CAM_BITMAP_PALETTE==1
#define COLOR_TRANSPARENT	0x00
#define COLOR_WHITE		0x11
#define COLOR_WHITE_P		0x11
#define COLOR_RED		      0x22
#define COLOR_RED_P		0x22
#define COLOR_PINK		0x66
#define COLOR_PINK_P		0xE2
#define COLOR_GREY		0xAF
#define COLOR_GREY_P          0x7F
#define COLOR_GREEN		0xF5
#define COLOR_GREEN_P		0xF5
#define COLOR_BLUE_LT		0xDD
#define COLOR_BLUE_LT_P		0x99
#define COLOR_BLUE		0xDF
#define COLOR_BLUE_P          0xAA
#define COLOR_YELLOW		0xEE
#define COLOR_YELLOW_P		0x66
#define COLOR_BLACK		0xFF
#define COLOR_BLACK_P		0xFF
#define COLOR_BG 		      0x44
#define COLOR_BG_P 		0xDF
#define COLOR_FG 		      COLOR_WHITE
#define COLOR_FG_P 		COLOR_WHITE_P
#define COLOR_SELECTED_BG	COLOR_RED
#define COLOR_SELECTED_BG_P	COLOR_RED_P
#define COLOR_SELECTED_FG	COLOR_WHITE
#define COLOR_SELECTED_FG_P   COLOR_WHITE_P
#define COLOR_ALT_BG 		COLOR_GREY
#define COLOR_ALT_BG_P        COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==2 // G11
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01  
#define COLOR_RED           0x2B
#define COLOR_RED_P	    0x2B // orange
#define COLOR_PINK	    0x1E
#define COLOR_PINK_P        0x1E
#define COLOR_GREY          0x17
#define COLOR_GREY_P        0x19  
#define COLOR_GREEN         0x99
#define COLOR_GREEN_P	    0xCB
#define COLOR_BLUE_LT       0xA9
#define COLOR_BLUE_LT_P	    0xCB // green
#define COLOR_BLUE          0xA1
#define COLOR_BLUE_P        0xCB // green
#define COLOR_YELLOW        0x9A
#define COLOR_YELLOW_P	    0xBE
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x61
#define COLOR_BG_P 	    0x51 // partially transparent ?
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==3
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01        
#define COLOR_RED           0x60
#define COLOR_RED_P	    0x60
#define COLOR_PINK	    0x80
#define COLOR_PINK_P	    0xC8
#define COLOR_GREY          0x17
#define COLOR_GREY_P        0x17        
#define COLOR_GREEN         0x87
#define COLOR_GREEN_P	    0xD2
#define COLOR_BLUE_LT       0x70
#define COLOR_BLUE_LT_P	    0x70
#define COLOR_BLUE          0x78
#define COLOR_BLUE_P        0x78
#define COLOR_YELLOW        0x8F
#define COLOR_YELLOW_P	    0x8F
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x1E
#define COLOR_BG_P 	    0x1E
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P  
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==4
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01      
#define COLOR_RED           0x2B
#define COLOR_RED_P	    0x2B
#define COLOR_PINK	    0x1F
#define COLOR_PINK_P	    0x1F
#define COLOR_GREY          0x17
#define COLOR_GREY_P        0x17      
#define COLOR_GREEN         0x99
#define COLOR_GREEN_P	    0xAC
#define COLOR_BLUE_LT       0x2D
#define COLOR_BLUE_LT_P	    0x2D
#define COLOR_BLUE          0x3B
#define COLOR_BLUE_P        0x3B
#define COLOR_YELLOW        0x9A
#define COLOR_YELLOW_P	    0xAD
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x86
#define COLOR_BG_P 	    0xB1
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P  
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==5
#define COLOR_TRANSPARENT        0x00	   
#define COLOR_WHITE		   0x01	   
#define COLOR_WHITE_P		   0x01	   
#define COLOR_RED       	   0x70	   
#define COLOR_RED_P 		   0x70
#define COLOR_PINK       	   0x70	   
#define COLOR_PINK_P 		   0x70
#define COLOR_GREY 		   0x17	   
#define COLOR_GREY_P         	   0x17	   
#define COLOR_GREEN 		   0xA6	   
#define COLOR_GREEN_P 		   0xc3	   
#define COLOR_BLUE_LT  		   0x79	   
#define COLOR_BLUE_LT_P 	   0x80	   
#define COLOR_BLUE 		   0x87	   
#define COLOR_BLUE_P		   0x96	   
#define COLOR_YELLOW		   0xa7	   
#define COLOR_YELLOW_P		   0x54	   
#define COLOR_BLACK 		   0xff	   
#define COLOR_BLACK_P 		   0xff	   
#define COLOR_BG                 0x1e	   
#define COLOR_BG_P  		   0x1e	   
#define COLOR_FG       		   COLOR_WHITE	   
#define COLOR_FG_P  		   COLOR_WHITE_P	   
#define COLOR_SELECTED_BG 	   COLOR_RED	   
#define COLOR_SELECTED_BG_P 	   COLOR_RED_P	   
#define COLOR_SELECTED_FG 	   COLOR_WHITE	   
#define COLOR_SELECTED_FG_P  	   COLOR_WHITE_P	   
#define COLOR_ALT_BG  		   COLOR_GREY	   
#define COLOR_ALT_BG_P           COLOR_GREY_P	

#elif CAM_BITMAP_PALETTE==6 //S90
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01  
#define COLOR_RED           0xA0
#define COLOR_RED_P	    0x2C 
#define COLOR_PINK	    0xA0
#define COLOR_PINK_P        0x2C
#define COLOR_GREY          0x17
#define COLOR_GREY_P        0x17  
#define COLOR_GREEN         0xA3
#define COLOR_GREEN_P	    0xCB
#define COLOR_BLUE_LT       0xA2
#define COLOR_BLUE_LT_P	    0xCB // green
#define COLOR_BLUE          0xA1
#define COLOR_BLUE_P        0xCB // green
#define COLOR_YELLOW        0x9A
#define COLOR_YELLOW_P	    0xBC
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x5A
#define COLOR_BG_P 	    0xFE
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==7 // SX120
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01  
#define COLOR_RED           0xA0
#define COLOR_RED_P	    0x2B // orange
#define COLOR_PINK	    0x1E
#define COLOR_PINK_P        0x1E
#define COLOR_GREY          0x17
#define COLOR_GREY_P        0x19  
#define COLOR_GREEN         0xAA
#define COLOR_GREEN_P	    0xCB
#define COLOR_BLUE_LT       0xA9
#define COLOR_BLUE_LT_P	    0xCB // green
#define COLOR_BLUE          0xA1
#define COLOR_BLUE_P        0xCB // green
#define COLOR_YELLOW        0x9A
#define COLOR_YELLOW_P	    0xBE
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x61
#define COLOR_BG_P 	    0x51 // partially transparent ?
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==8 // S95
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01  
#define COLOR_RED           0x66
#define COLOR_RED_P	    0xA0 // use  red
#define COLOR_PINK	    0x66 // use red
#define COLOR_PINK_P        0xA0
#define COLOR_GREY          0x16
#define COLOR_GREY_P        0x16  
#define COLOR_GREEN         0x6B
#define COLOR_GREEN_P	    0xA1
#define COLOR_BLUE_LT       0x68 
#define COLOR_BLUE_LT_P	    0xA1 // use green
#define COLOR_BLUE          0x67 
#define COLOR_BLUE_P        0xA2
#define COLOR_YELLOW        0x60
#define COLOR_YELLOW_P	    0x90
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x5A
#define COLOR_BG_P 	    0x93 // partially transparent ?
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#elif CAM_BITMAP_PALETTE==9 //IXUS105
#define COLOR_TRANSPARENT   0x00
#define COLOR_WHITE         0x01
#define COLOR_WHITE_P	    0x01  
#define COLOR_RED           0x66
#define COLOR_RED_P	    0x5C 
#define COLOR_PINK	    0x1E 
#define COLOR_PINK_P        0x2E
#define COLOR_GREY          0x16
#define COLOR_GREY_P        0x16  
#define COLOR_GREEN         0x69
#define COLOR_GREEN_P	    0xA1
#define COLOR_BLUE_LT       0x68 
#define COLOR_BLUE_LT_P	    0xA1 
#define COLOR_BLUE          0x67 
#define COLOR_BLUE_P        0x9F
#define COLOR_YELLOW        0x6C
#define COLOR_YELLOW_P	    0x9C
#define COLOR_BLACK         0xFF
#define COLOR_BLACK_P	    0xFF
#define COLOR_BG            0x62
#define COLOR_BG_P 	    0x62 // partially transparent ?
#define COLOR_FG            COLOR_WHITE
#define COLOR_FG_P 	    COLOR_WHITE_P
#define COLOR_SELECTED_BG   COLOR_RED
#define COLOR_SELECTED_BG_P COLOR_RED_P
#define COLOR_SELECTED_FG   COLOR_WHITE
#define COLOR_SELECTED_FG_P COLOR_WHITE_P
#define COLOR_ALT_BG        COLOR_GREY
#define COLOR_ALT_BG_P      COLOR_GREY_P

#else
#error CAM_BITMAP_PALETTE not defined
#endif

#define FONT_WIDTH 		   8
#define FONT_HEIGHT             16
#define BIG_FONT_WIDTH 		FONT_WIDTH*2
#define BIG_FONT_HEIGHT       FONT_HEIGHT*2
//-------------------------------------------------------------------
extern unsigned int		screen_width, screen_height, screen_size;
extern unsigned int           screen_buffer_width, screen_buffer_height, screen_buffer_size;
//-------------------------------------------------------------------
/*
void draw_pixel_inverted(unsigned int offset, color cl);
void draw_pixel_rotated_left(unsigned int offset, color cl);
void draw_pixel_rotated_right(unsigned int offset, color cl);
*/
void draw_pixel_inverted(coord x,coord y,color cl);
void draw_pixel_rotated_left(coord x,coord y,color cl);
void draw_pixel_rotated_right(coord x,coord y,color cl);
void draw_pixel_double(coord x,coord y,color cl);
void draw_init();
// void draw_set_draw_proc(void (*pixel_proc)(unsigned int offset, color cl));
void draw_set_draw_proc(void (*pixel_proc)(coord x,coord y,color cl));
extern color draw_get_pixel(coord x, coord y);

extern void draw_line(coord x1, coord y1, coord x2, coord y2, color cl);

//draw frame
extern void draw_rect(coord x1, coord y1, coord x2, coord y2, color cl);
//color: hi_byte - BG; lo_byte - FG
extern void draw_filled_rect(coord x1, coord y1, coord x2, coord y2, color cl);

extern void draw_char(coord x, coord y, const char ch, color cl,int m);
extern void draw_string(coord x, coord y, const char *s, color cl, int m);
extern void draw_big_char(coord x, coord y, const char ch, color cl);
extern void draw_big_string(coord x, coord y, const char *s, color cl);
extern void draw_big_string_centre_len(int x, int y, int len, const char *str, color cl); 

extern void draw_txt_rect(coord col, coord row, unsigned int length, unsigned int height, color cl);
extern void draw_txt_rect_exp(coord col, coord row, unsigned int length, unsigned int height, unsigned int exp, color cl);
extern void draw_txt_filled_rect(coord col, coord row, unsigned int length, unsigned int height, color cl);
extern void draw_txt_filled_rect_exp(coord col, coord row, unsigned int length, unsigned int height, unsigned int exp, color cl);
extern void draw_txt_string(coord col, coord row, const char *str, color cl);
extern void draw_txt_char(coord col, coord row, const char ch, color cl);

extern void draw_clear();
extern void draw_restore();

extern void draw_fill(coord x, coord y, color cl_fill, color cl_bound);
extern void draw_circle(coord x, coord y, const unsigned int r, color cl);
extern void draw_ellipse(coord xc, coord yc, unsigned int a, unsigned int b, color cl);
extern void draw_filled_ellipse(coord xc, coord yc, unsigned int a, unsigned int b, color cl);

#if CAM_USES_ASPECT_CORRECTION //nandoide sept-2009 
void draw_set_aspect_xcorrection_proc(unsigned int (*xcorrection_proc)(unsigned int x));
void draw_set_aspect_ycorrection_proc(unsigned int (*ycorrection_proc)(unsigned int y));
unsigned int aspect_xcorrection_games_360(unsigned int x);
unsigned int aspect_ycorrection_games_360(unsigned int y);
void draw_set_environment(unsigned int (*xcorrection_proc)(unsigned int x), 
                                       unsigned int (*ycorrection_proc)(unsigned int y),
                                       int screenx, int screeny );
#endif

//-------------------------------------------------------------------

#endif
