#include "stdlib.h"
#include "keyboard.h"
#include "platform.h"
#include "core.h"
#include "conf.h"
#include "gui.h"
#include "font.h"
#include "draw_palette.h"
// #include "gui_batt.h"
#include "gui_read.h"
#include "kbd.h"

// -------------------------------------------------------------------
// extern void gui_draw_read(int arg);
static int read_file;
static int read_file_size;
static int read_on_screen;
static int read_to_draw;
static coord x, y, h, w;
#define READ_BUFFER_SIZE  100
static char buffer[READ_BUFFER_SIZE+1];
static long last_time;
static int xx, yy;
static int pause;
//static char *fn[15];
static char fn[15];

// -------------------------------------------------------------------
static void gui_read_draw_scroll_indicator() {

#if !defined(CAMERA_tx1)
    draw_txt_char(screen_width/FONT_WIDTH-2, 0, (conf.reader_autoscroll)?((pause)?'\x05':'\x04'):'\x03',(conf.dist_mode || conf.tv_bracket_value)? MAKE_COLOR(COLOR_BLUE, COLOR_WHITE):MAKE_COLOR(COLOR_BLACK, COLOR_WHITE)); //title infoline
#else
    draw_txt_char(screen_width-120/FONT_WIDTH-2, 0, (conf.reader_autoscroll)?((pause)?'\x05':'\x04'):'\x03',(conf.dist_mode || conf.tv_bracket_value)? MAKE_COLOR(COLOR_BLUE, COLOR_WHITE):MAKE_COLOR(COLOR_BLACK, COLOR_WHITE)); //title infoline
#endif
}

// -------------------------------------------------------------------
int gui_read_init(const char* file) {
    static struct stat   st;
    read_file = open(file, O_RDONLY, 0777);
    if (strcmp(file, conf.reader_file)!=0) {
        conf.reader_pos = 0;
        strcpy(conf.reader_file, file);
    }
    read_on_screen = 0;
    read_file_size = (read_file>=0 && stat((char*)file, &st)==0)?st.st_size:0;
    if (read_file_size<=conf.reader_pos) {
        conf.reader_pos = 0;
    }
    pause = 0;
    read_to_draw = 1;
    x=6; 
    y=FONT_HEIGHT;
#if !defined(CAMERA_tx1)
   if(conf.camera_orientation !=1)
     w=screen_width-6-6-8;
   else w=screen_height-6-6-8;
     h=screen_height-y;
 
    last_time = get_tick_count();
    
    draw_filled_rect(0, 0, screen_width-1, y-1, MAKE_COLOR(COLOR_BLACK, COLOR_BLACK));
    draw_filled_rect(0, y, screen_width-1, screen_height-1, MAKE_COLOR((conf.reader_color>>8)&0xFF, (conf.reader_color>>8)&0xFF));
#else
    w=screen_width-120-6-6-8;
    h=screen_height-y;
    last_time = get_tick_count();
    
    draw_filled_rect(0, 0, screen_width-120-1, y-1, MAKE_COLOR(COLOR_BLACK, COLOR_BLACK));
    draw_filled_rect(0, y, screen_width-120-1, screen_height-1, MAKE_COLOR((conf.reader_color>>8)&0xFF, (conf.reader_color>>8)&0xFF));

#endif

 //   gui_read_draw_scroll_indicator();
 //   gui_read_draw_batt();

    return (read_file >= 0);
}

// -------------------------------------------------------------------
static void read_goto_next_line() {
    draw_filled_rect(xx, yy, x+w-1, yy+rbf_font_height()-1, MAKE_COLOR(conf.reader_color>>8, conf.reader_color>>8));
    xx  = x;
    yy += rbf_font_height();
}

// -------------------------------------------------------------------
static int read_fit_next_char(int ch) {
    return (xx+rbf_char_width(ch) < x+w);
}

// -------------------------------------------------------------------
void gui_read_draw() {

int sl = 0;  // string length
    if (conf.reader_autoscroll && !pause && get_tick_count()-last_time >= conf.reader_autoscroll_delay*1000 && (conf.reader_pos+read_on_screen)<read_file_size) {
        conf.reader_pos += read_on_screen;
        read_to_draw = 1;
    }
    if (read_to_draw) {
        int n, i, ii, ll, new_word=1;
        
        xx=x; yy=y;

        lseek(read_file, conf.reader_pos, SEEK_SET);
        read_on_screen=0;

        while (yy<=y+h-rbf_font_height()) {
            n=read(read_file, buffer, READ_BUFFER_SIZE);
            if (n==0) {
                 read_goto_next_line();
                 if (yy < y+h)
                     draw_filled_rect(x, yy, x+w-1, y+h-1, MAKE_COLOR(conf.reader_color>>8, conf.reader_color>>8));
                 break;
            }
            i=0;
            while (i<n && yy<=y+h-rbf_font_height()) {
                switch (buffer[i]) {
                    case '\r':
                        new_word = 1;
                        break;
                    case '\n':
                        read_goto_next_line();
                        new_word = 1;
                        break;
                    case '\t':
                        buffer[i] = ' ';
                        //no break here
                    default:
                        if (conf.reader_wrap_by_words) {
                            if (buffer[i] == ' ') {
                                new_word = 1;
                                if (xx==x) //ignore leading spaces
                                    break;
                            } else if (new_word) {
                                new_word = 0;
                                for (ii=i, ll=0; ii<n && buffer[ii]!=' ' && buffer[ii]!='\t' && buffer[ii]!='\r' && buffer[ii]!='\n'; ++ii) {
                                    ll+=rbf_char_width(buffer[ii]);
                                }
                                if (ii==n) {
                                    memcpy(buffer, buffer+i, n-i);
                                    n=ii=n-i;
                                    read_on_screen+=i;
                                    i=0;
                                    n+=read(read_file, buffer+n, READ_BUFFER_SIZE-n);
                                    for (; ii<n && buffer[ii]!=' ' && buffer[ii]!='\t' && buffer[ii]!='\r' && buffer[ii]!='\n'; ++ii) {
                                        ll+=rbf_char_width(buffer[ii]);
                                    }
                                }
                                if (xx+ll>=x+w && ll<w) {
                                    read_goto_next_line();
                                    continue;
                                }
                            }
                        }
                        if (!read_fit_next_char(buffer[i])) {
                            read_goto_next_line();
                            continue;
                        }
                        xx+=rbf_draw_char(xx, yy, buffer[i], conf.reader_color);
                        break;
                }
                ++i;
                if (xx >= x+w) {
                    xx  = x;
                    yy += rbf_font_height();
                }
            }
            read_on_screen+=i;
        }

       sl = strlen((char *)&conf.reader_file);
       if(((sl>29)&&(sl<32))&& (conf.reader_file[sl-10]=='k')) //probably a stack file !
     {
        if(conf.dist_mode)
       {
        strcpy(fn,(char *)&conf.reader_file[14]);

        sprintf(buffer,"%-24s%s",((char)fn[0]=='m')?"Equal-step bracketing":((char)fn[0]=='a')?"Auto bracketing":"Digiscope bracketing",fn);
       }
       else if(conf.tv_bracket_value)
       {
        if(shooting_get_drive_mode()==1)
         {
         strcpy(fn,(char *)&conf.reader_file[14]);
         sprintf(buffer,"%-24s%s",((char)fn[0]=='t')?"Tv Continuous bracket":"",fn);
         }
        else
         {
          strcpy(fn,(char *)&conf.reader_file[14]);
          sprintf(buffer,"%-24s%s",((char)fn[0]=='t')?"Tv Timer bracket":"",fn);
         }
        } // _else
      }
        else
        {
         strcpy(buffer,(char *)&conf.reader_file);
     //   sprintf(buffer, "(%3d%%) %d/%d  %s", (read_file_size)?(conf.reader_pos*100/read_file_size):0, conf.reader_pos, read_file_size);
        }
#if !defined(CAMERA_tx1)
        buffer[screen_width/FONT_WIDTH]=0;
#else
        buffer[screen_width-120/FONT_WIDTH]=0;
#endif
         draw_filled_rect(0, 0,screen_width,FONT_HEIGHT,MAKE_COLOR(COLOR_BLUE, COLOR_BLUE)); 
         draw_txt_string(0, 0, buffer,MAKE_COLOR(COLOR_BLUE, COLOR_WHITE)); //title infoline


         gui_read_draw_scroll_indicator();

if(conf.camera_orientation != 1)                               // no scrollbar with vertical camera
    {
        // scrollbar
        if (read_file_size) 
       {
            i=h-1 -1;           //full height
            n=i*read_on_screen/read_file_size;           //bar height
            if (n<20) n=20;
            i=(i-n)*conf.reader_pos/read_file_size;   //top pos
            draw_filled_rect(x+w+6+2, y+1,   x+w+6+6, y+1+i,   MAKE_COLOR(COLOR_BLACK, COLOR_BLACK));
            draw_filled_rect(x+w+6+2, y+i+n, x+w+6+6, y+h-1-1, MAKE_COLOR(COLOR_BLACK, COLOR_BLACK));
            draw_filled_rect(x+w+6+2, y+1+i, x+w+6+6, y+i+n,   MAKE_COLOR(COLOR_WHITE, COLOR_WHITE));
        } 
       else
 
        {
            draw_filled_rect((x+w)*FONT_WIDTH+2, y*FONT_HEIGHT+1, 
                             (x+w)*FONT_WIDTH+6, (y+h)*FONT_HEIGHT-1-1, MAKE_COLOR(COLOR_BLACK, COLOR_BLACK));
        }
     }
        read_to_draw = 0;
        last_time = get_tick_count();
    }
}

// -------------------------------------------------------------------
void gui_read_kbd_process() 
{
  //  switch (kbd_get_autoclicked_key()) 
      switch(get_vkey(kbd_get_autoclicked_key()))
    {
        case KEY_ZOOM_OUT:
        case KEY_UP:
        case KEY_LEFT:
            if (conf.reader_pos>0) 
            {
              if(conf.camera_orientation != 1)
                conf.reader_pos -= 45*15;
              else conf.reader_pos -= 13*15;
                if (conf.reader_pos<0) conf.reader_pos=0;
                read_to_draw = 1;
            }
            break;
        case KEY_ZOOM_IN:
        case KEY_DOWN:
        case KEY_RIGHT:
        case KEY_SHOOT_HALF:
            if ((conf.reader_pos+read_on_screen)<read_file_size) {
                conf.reader_pos += read_on_screen;
                read_to_draw = 1;
            }
            break;
        case KEY_SET:
         if(conf.dist_mode)
            {
            if (read_file >= 0) 
              {
                close(read_file);
                read_file=-1;
              }
             gui_draw_read(1);
            }
            break;
        case KEY_DISPLAY:
            pause = !pause;
            gui_read_draw_scroll_indicator();
            last_time = get_tick_count();
            break;
        case KEY_MENU:
            if (read_file >= 0) {
                close(read_file);
                read_file=-1;
            }
            if (!rbf_load(conf.menu_rbf_file))
                rbf_load_from_8x16(current_font);
            rbf_set_codepage(FONT_CP_WIN);
            break;
    }
}

// -------------------------------------------------------------------
