#include "stdlib.h"
#include "platform.h"
#include "core.h"
#include "keyboard.h"
#include "conf.h"
#include "lang.h"
#include "ubasic.h"
#include "histogram.h"
#include "script.h"
#include "gui_lang.h"
#include "motion_detector.h"
#include "math.h"
#include "draw_palette.h"
#if defined(OPT_SERIALIO)
//spinorkit added
#include "serialio.h"
#include "remotecommand.h"
#endif
#if defined(CAMERA_a1000)
#define RECORD 0x1001        
#define PLAYBACK 0x1003      
#define MOVIE 0x105B         
#elif !CAM_HAS_PLAYBACK_PB 
#define RECORD 0x1065
#define PLAYBACK 0x1061
#define MOVIE 0x105B
#elif CAM_HAS_PLAYBACK_PB 
#define RECORD 0x1001
#define PLAYBACK 0x1003
#define MOVIE 0x9A5
#endif
static int keyid_by_name (const char *n);
#define SCRIPT_SLEEP            3
#define SCRIPT_PRESS            4
#define SCRIPT_RELEASE          5
#define SCRIPT_PR_WAIT_SAVE     6
#define SCRIPT_WAIT_SAVE        7
#define SCRIPT_WAIT_FLASH       8
#define SCRIPT_WAIT_EXPHIST     9
#define SCRIPT_PR_WAIT_EXPHIST  10
#define SCRIPT_WAIT_CLICK       11
#define SCRIPT_MOTION_DETECTOR  12
#define SCRIPT_BRACKET_WAIT     13
#define SCRIPT_WFSP             14
#define SCRIPT_TL               15
#define SCRIPT_BLCD             16
#define SCRIPT_USBUP            17
#define SCRIPT_END_PLE          18
#define REFRESH_USB             19
#define RF                      20 
#define SCRIPT_MUSBC            21 
#define SCRIPT_BUSBC            22 
#define SCRIPT_SU               23 
#define SCRIPT_BAFLF            24 
#define SCRIPT_HDRFS            25 
#define SCRIPT_PLAYBACK         26
#define SCRIPT_RECORD           27
#define KBD_STACK_SIZE 24
extern int ttyMasterSlave;
extern int afl,has_refocused,af_all;
extern int playback;
static long kbd_int_stack[KBD_STACK_SIZE];
static int kbd_int_stack_ptr;
extern int gDone_once;
extern int fdtv;                   
extern int fdauto;
extern int fddist;
extern int fddigi;
extern int fdsingle;
extern int fdsun;
extern int put_off_ev96;
#define KBD_STACK_PUSH(v) kbd_int_stack[kbd_int_stack_ptr++] = (v);
#define KBD_STACK_PREV(p) (kbd_int_stack[kbd_int_stack_ptr-(p)])
#define abs(x) ((x) >= 0 ? (x) : -(x))
static char normal_script[32];
static char osdbuf[32];        
static int soft_half_press = 0;
int gPTPsession;                
int kbd_blocked;
static int key_pressed;
static int outline;            
static struct tm *ttm;
int state_kbd_script_run = 0;
int stack_saved = 0;
int cf;                        
int rrm;                       
int su_first;                  
static int afcnt;              
int msstv96=-1;                
unsigned long gDetectUsb;      
int state_kbd_tty_cmd;           //spinorkit added to enable remote use of photo_param_put_off via serial I/O
int gSerialIORemoteShootingOn = 0;
int gDisableSerialIO = 0;
#ifndef OPT_SERIALIO
//Define dummy function to be called from my_kbd_read_keys().
int DoSerialIO()
   {
   return 0;
   }
#endif
static long delay_target_ticks;
static long kbd_last_clicked;
//------ add by Masuji SUTO (start) --------------
static int mvideo,mplay;
static int nSW=0;               
static int nRmt=0;              
static int nWt=0;               
static int nCount=0;            
static int nCa=0;               
static int nCount2=0;           
static int nTxvideo=0;          
static int nTxzoom=0;           
static int nPlyname=KEY_LEFT;   
static int nIntzpos;            
static int nReczoom=0;          
static int nTxtblcr=0;          
static int nConffin=0;
long gEnableScripting;          
int shutter_int=0;              
//Added spinorkit
int gShotsRemaining=0;          //decremented in wait_until_remote_button_is_released().
int init_start = 1;
static int tl_first;            
static int log_status;          
int bracket_running,tl_mod;
#if defined(CAMERA_a450) || defined(CAMERA_a460)
 #define ZOOM_IN KEY_UP
 #define ZOOM_OUT KEY_DOWN
#elif defined(CAMERA_sx200is)
 #define ZOOM_IN KEY_ZOOM_IN_SLOW
 #define ZOOM_OUT KEY_ZOOM_OUT_SLOW
#else
 #define ZOOM_IN KEY_ZOOM_IN
 #define ZOOM_OUT KEY_ZOOM_OUT
#endif
static int nTxzname=ZOOM_IN; 
#if CAM_NEED_HP
static int nFirst=0;
#endif
#if defined(CAMERA_a450)|| defined(CAMERA_a470)|| defined(CAMERA_a480)||defined(CAMERA_ixus40) || defined(CAMERA_ixus50) || defined(CAMERA_ixus55)|| defined(CAMERA_ixus60) || defined(CAMERA_ixus65) || defined(CAMERA_ixus70) || defined(CAMERA_ixus95) || defined(CAMERA_ixus700) || defined(CAMERA_ixus850) || defined(CAMERA_ixus75)||defined(CAMERA_ixus100)
#define ZSTEP_TABLE_SIZE 7
static int nTxtbl[]={0,1,2,3,4,5,6};
#endif
#if defined(CAMERA_s2is) || defined(CAMERA_s3is) || defined(CAMERA_s5is)|| defined(CAMERA_sx10)|| defined(CAMERA_sx1)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,11,25,41,64,86,105,128};
#endif
#if defined(CAMERA_tx1)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,18,43,55,76,93,113,124};
#endif
#if defined(CAMERA_a460) || defined(CAMERA_a530) || defined (CAMERA_a540) || defined(CAMERA_a550) || defined(CAMERA_a560) || defined(CAMERA_a570)  || defined(CAMERA_ixus860)|| defined(CAMERA_ixus960)|| defined(CAMERA_ixus970) || defined(CAMERA_ixus980)|| defined(CAMERA_a590)|| defined(CAMERA_ixus80)|| defined(CAMERA_ixus90)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,1,2,3,4,5,6,7};
#endif
#if defined(CAMERA_a610) ||  defined(CAMERA_a620) || defined(CAMERA_a630) || defined(CAMERA_a640) || defined(CAMERA_ixus800) || defined(CAMERA_ixus950)
#define ZSTEP_TABLE_SIZE 9
static int nTxtbl[]={0,1,2,3,4,5,6,7,8};
#endif
#if defined (CAMERA_a700) || defined(CAMERA_a710) || defined (CAMERA_a720) || defined (CAMERA_a1000)|| defined (CAMERA_a2000)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,2,4,6,8,10,12,14};
#endif
#if defined(CAMERA_a650) || defined(CAMERA_g7)|| defined(CAMERA_g9)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,2,4,6,8,10,12,13};
#endif
#if defined(CAMERA_s90)|| defined(CAMERA_s95)
#define ZSTEP_TABLE_SIZE 10
static int nTxtbl[]={0,1,2,3,4,5,6,7,8,9};
#endif
#if defined(CAMERA_sx100is)|| defined(CAMERA_sx110is) || defined(CAMERA_sx120is)
#define ZSTEP_TABLE_SIZE 8
static int nTxtbl[]={0,3,6,9,13,16,20,22};
#endif
#if defined(CAMERA_sx200is)
#define ZSTEP_TABLE_SIZE 7
static int nTxtbl[]={0,16,32,62,78,102,125};
#endif
#if defined(CAMERA_g11)
#define ZSTEP_TABLE_SIZE 14
static int nTxtbl[]={0,1,2,3,4,5,6,7,8,9,10,11,12,13};
#endif
#if defined(CAMERA_ixus870)||defined(CAMERA_ixus105)
#define ZSTEP_TABLE_SIZE 10
static int nTxtbl[]={0,1,2,3,4,5,6,7,8,9};
#endif
int get_soft_half_press()
{
 return soft_half_press;
}
//------ add by Masuji SUTO (end)   --------------
short int vv;
void presynch(void);
int time_lapse();
 static void kbd_sched_wait()
{
    KBD_STACK_PUSH(SCRIPT_BRACKET_WAIT);
}
static void kbd_sched_wfsp()
{
    KBD_STACK_PUSH(SCRIPT_WFSP);
}
static void kbd_sched_scts()
{
    KBD_STACK_PUSH(20);
    KBD_STACK_PUSH(SCRIPT_SLEEP);
    KBD_STACK_PUSH(KEY_SHOOT_FULL);
    KBD_STACK_PUSH(SCRIPT_RELEASE);
    KBD_STACK_PUSH(500);
    KBD_STACK_PUSH(SCRIPT_SLEEP);
    KBD_STACK_PUSH(KEY_SHOOT_FULL);
    KBD_STACK_PUSH(SCRIPT_PRESS);
}
static void kbd_sched_blcd()
{
    KBD_STACK_PUSH(SCRIPT_BLCD);
}
static void kbd_sched_tl()
{
    KBD_STACK_PUSH(SCRIPT_TL);
}
void kbd_sched_delay(long msec)
{
    KBD_STACK_PUSH(msec);
    KBD_STACK_PUSH(SCRIPT_SLEEP);
}
void kbd_sched_motion_detector(){
    KBD_STACK_PUSH(SCRIPT_MOTION_DETECTOR);
}
void kbd_sched_press(long key)
{
//WARNING stack program flow is reversed
    kbd_sched_delay(20);
    KBD_STACK_PUSH(key);
    KBD_STACK_PUSH(SCRIPT_PRESS);
}
void kbd_sched_release(long key)
{
//WARNING stack program flow is reversed
    kbd_sched_delay(20);
    KBD_STACK_PUSH(key);
    KBD_STACK_PUSH(SCRIPT_RELEASE);
}
void md_kbd_sched_immediate_shoot(int no_release)
{
  
    {
      kbd_sched_release(KEY_SHOOT_FULL);
      kbd_sched_delay(20);
    }
}
static void kbd_sched_click(long key)
{
//WARNING stack program flow is reversed
    kbd_sched_release(key);
    kbd_sched_press(key);
}
static void kbd_sched_wait_click(int timeout)
{
//WARNING stack program flow is reversed
    KBD_STACK_PUSH(timeout);
    KBD_STACK_PUSH(SCRIPT_WAIT_CLICK);
}
void kbd_sched_shoot()
{
//WARNING stack program flow is reversed
    kbd_sched_delay(conf.script_shoot_delay*100);//XXX FIXME find out how to wait to jpeg save finished
    KBD_STACK_PUSH(SCRIPT_WAIT_SAVE);
    KBD_STACK_PUSH(KEY_SHOOT_FULL);
    KBD_STACK_PUSH(SCRIPT_RELEASE);
    kbd_sched_delay(20);
    KBD_STACK_PUSH(KEY_SHOOT_FULL);
    KBD_STACK_PUSH(SCRIPT_PRESS);
  
    KBD_STACK_PUSH(SCRIPT_WAIT_EXPHIST);
    KBD_STACK_PUSH(SCRIPT_PR_WAIT_EXPHIST);
    kbd_sched_delay(10);
    KBD_STACK_PUSH(KEY_SHOOT_HALF);
    KBD_STACK_PUSH(SCRIPT_PRESS);
    KBD_STACK_PUSH(SCRIPT_PR_WAIT_SAVE);
}
void lua_script_exec( char *script )
{
}
void script_start()
{
    int i;
    stack_saved = 0;
    state_kbd_script_run = 1;
    delay_target_ticks = 0;
    outline=conf.outline_mode;  
  
    ft_time.hr=99;              
    kbd_int_stack_ptr = 0;
    kbd_last_clicked = 0;
    kbd_key_release_all();
    ubasic_init(state_ubasic_script);
   if(gPTPsession) conf.synch_enable=0;          
   
    for (i=0; i<SCRIPT_NUM_PARAMS; ++i) 
      {
        ubasic_set_variable(i, conf.ubasic_vars[i]);
      }
   conf_update_prevent_shutdown();
}
void script_end()
{
    ubasic_end();                                                 
    if(tl.running) enable_shutdown();
    enable_shutdown();
    init_start = 1;
    conf.sdm_console=0;
    tl.running=0;
    kbd_key_release_all();
    state_kbd_script_run = 0;
    script_console_clear();
    if(normal_script[0]) script_load(normal_script,0);            
    if(!gPTPsession) conf.synch_enable=1;                         
    conf.tv_override_enable=0;
    conf.user_range_set=0;
    conf.dist_mode=0;
    gDone_once=0;                                                 
    has_refocused=0;
    conf_update_prevent_shutdown();
    vid_bitmap_refresh();
}
void process_script()
{
    long t;
    int j;
    
    if (kbd_int_stack_ptr)
  {
	switch (KBD_STACK_PREV(1))
   {
	case SCRIPT_HDRFS:                            
          if(hdrfs()==0)
           {
	      kbd_int_stack_ptr-=1;                
	     }
	    return;                                
	case SCRIPT_SU:                            
          if(su()==0)
           {
	      kbd_int_stack_ptr-=1;                
	     }
	    return;                                
      case SCRIPT_BAFLF:                        
          if(baflf()==0)
           {
	      kbd_int_stack_ptr-=1;               
	     }
	    return;                                
	case SCRIPT_MOTION_DETECTOR:
	    if(md_detect_motion()==0)
           {
	      kbd_int_stack_ptr-=1;
	     }
	    return;
	case SCRIPT_PRESS:
	    kbd_key_press(KBD_STACK_PREV(2));
	    kbd_int_stack_ptr-=2; //pop op.
	    return;
	case SCRIPT_RELEASE:
	    kbd_key_release(KBD_STACK_PREV(2));
	    kbd_int_stack_ptr-=2; //pop op.
	    return;
	case SCRIPT_SLEEP:
	    t = get_tick_count();
	    
	    if (delay_target_ticks == 0)
           {
		delay_target_ticks = t+KBD_STACK_PREV(2);
	     } 
           else 
           {
		if (delay_target_ticks <= t)
               {
		    delay_target_ticks = 0;
		    kbd_int_stack_ptr-=2; //pop sleep op.
		   }
	      }
	    return;
	case SCRIPT_BRACKET_WAIT:
          if(get_inf_focus()) kbd_int_stack_ptr-=1; //pop wait op
	    return;
	case SCRIPT_WFSP:
          if(get_usb_power(1)) kbd_int_stack_ptr-=1; 
	    return;
	case SCRIPT_BLCD:                                  
         kbd_int_stack_ptr-=1;                           
         j=shooting_get_prop(PROPCASE_DISPLAY_MODE);
       if(j==1)                                         
       {  
           kbd_sched_delay(20);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(20);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_PRESS);                               
           kbd_sched_delay(100);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(20);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_PRESS);
 
        }
     else                                             
        {
           kbd_sched_delay(20);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(20);
           KBD_STACK_PUSH(KEY_DISPLAY);
           KBD_STACK_PUSH(SCRIPT_PRESS);
         }        
	    return;
     case SCRIPT_TL:
          if(time_lapse()==0)
           {
	      kbd_int_stack_ptr-=1;
	     }
          return;
     case SCRIPT_USBUP:                              
	   kbd_int_stack_ptr-=1;                       
         conf.remote_enable = 0;                     
         debug_led(1);
#if defined(CAM_PB_MODE)                             
         KBD_STACK_PUSH(PLAYBACK_MODE);
         KBD_STACK_PUSH(SCRIPT_RELEASE);
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1500);
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1000*usbup_time+1000);
         KBD_STACK_PUSH(PLAYBACK_MODE);
         KBD_STACK_PUSH(SCRIPT_PRESS)               
#else                                               
         KBD_STACK_PUSH(SCRIPT_RECORD);
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1500);
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1000*usbup_time+1000);
         KBD_STACK_PUSH(SCRIPT_PLAYBACK);
#endif	     
         return;
     case SCRIPT_MUSBC:
	   kbd_int_stack_ptr-=1;                      
         conf.remote_enable = 0;                     
         conf.edge_overlay_enable=0;
         if(shooting_can_focus()) cf=lens_get_focus_pos_from_lense(); 
         debug_led(1);
#if defined(CAM_PB_MODE)                             
         KBD_STACK_PUSH(PLAYBACK_MODE);
         KBD_STACK_PUSH(SCRIPT_PRESS)   
#else                                               
         playback_mode();
#endif
         return;
     case SCRIPT_BUSBC:
	   kbd_int_stack_ptr-=1;                      
         debug_led(0);
#if defined(CAM_PB_MODE)                             
         KBD_STACK_PUSH(PLAYBACK_MODE);
         KBD_STACK_PUSH(SCRIPT_RELEASE);
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1500);
         KBD_STACK_PUSH(REFRESH_USB);            
#else                                               
         KBD_STACK_PUSH(RF);                         
         KBD_STACK_PUSH(REFRESH_USB);
         kbd_sched_delay(1500);
         KBD_STACK_PUSH(REFRESH_USB);
#endif
         return;
     case SCRIPT_END_PLE:                           
	    kbd_int_stack_ptr-=1;
#if defined(CAMERA_a480)
          kbd_sched_delay(900);
          kbd_sched_click(KEY_SET);
          kbd_sched_delay(900);
          kbd_sched_click(KEY_PRINT);
          kbd_sched_delay(900);
#elif defined(CAMERA_a2000)
          record_mode();
#else
          playback_mode();
          record_mode();
#endif
          return;
     case REFRESH_USB:
          conf.remote_enable=1;                      
          kbd_int_stack_ptr-=1;                      
          RefreshUSBMode();
          debug_led(0);
          return;
     case RF:                                       
          kbd_int_stack_ptr-=1;                     
          record_mode();
          if(shooting_can_focus()) lens_set_focus_pos(cf+fpd); 
          return;
	case SCRIPT_PR_WAIT_SAVE:
	    state_shooting_progress = SHOOTING_PROGRESS_NONE;
	    state_expos_recalculated = 0;
	    histogram_stop();
	    kbd_int_stack_ptr-=1; 
	    return;
	case SCRIPT_WAIT_SAVE:
        {
	    if (state_shooting_progress == SHOOTING_PROGRESS_DONE)
		kbd_int_stack_ptr-=1; 
	    return;
	   }
	case SCRIPT_WAIT_FLASH:
        {
	    if (shooting_is_flash_ready())
		kbd_int_stack_ptr-=1; 
	    return;
	   }
	case SCRIPT_WAIT_EXPHIST:
         {
	    if (state_expos_recalculated)            
           {
		kbd_int_stack_ptr-=1; 
		state_expos_under = under_exposed;
		state_expos_over = over_exposed;
	     }
	    return;
	   }
	case SCRIPT_PR_WAIT_EXPHIST: 
         {
	    if (shooting_in_progress() || mvideo) 
           {
		state_expos_recalculated = 0;
		histogram_restart();                    
		kbd_int_stack_ptr-=1;                   
	     }
	    return;
	   }
        case SCRIPT_WAIT_CLICK: 
          {
            t = get_tick_count();
	     if (delay_target_ticks == 0)
            {
		delay_target_ticks = t+((KBD_STACK_PREV(2))?KBD_STACK_PREV(2):86400000);
	      } 
          else 
            {
                kbd_last_clicked = kbd_get_clicked_key();
                if (kbd_last_clicked || delay_target_ticks <= t) 
                  {
                    if (!kbd_last_clicked) 
                    kbd_last_clicked=0xFFFF;
        	        delay_target_ticks = 0;
                    kbd_int_stack_ptr-=2; 
                   }
	       }
	       return;
          }
        case SCRIPT_PLAYBACK: 
          {
           kbd_int_stack_ptr-=1; 
           playback_mode();
           return;
          }
        case SCRIPT_RECORD: 
          {
           kbd_int_stack_ptr-=1; 
           record_mode();
           return;
          }
	default:
	    script_end();
	}
    }
    ubasic_run();          
    if (ubasic_finished()) 
    {
      if(!conf.sdm_console)script_console_add_line(lang_str(LANG_CONSOLE_TEXT_FINISHED));
      else console_add_line(lang_str(LANG_CONSOLE_TEXT_FINISHED),3);
	script_end();
    }   
}
void ubasic_camera_press(const char *s)
{
    long k = keyid_by_name(s);
    if (k > 0) {
	kbd_sched_press(k);
    } else {
	ubasic_error = 3;
    }
}
void ubasic_camera_release(const char *s)
{
    long k = keyid_by_name(s);
    if (k > 0) {
	kbd_sched_release(k);
    } else {
	ubasic_error = 3;
    }
}
void ubasic_camera_click(const char *s)
{
    long k = keyid_by_name(s);
    if (k > 0) {
	kbd_sched_click(k);
    } else {
	ubasic_error = 3;
    }
}
void ubasic_camera_wait_click(int timeout)
{
    kbd_sched_wait_click(timeout);
}
int ubasic_camera_is_clicked(const char *s)
{
    if(strcmp("last_pressed",s)==0) return kbd_last_clicked;
    long k = keyid_by_name(s);
    if (k==0xFF) return get_usb_power(1);  
    if (k > 0) {
        return (kbd_last_clicked == k);
    } else {
	ubasic_error = 3;
    }
    return 0;
}
void ubasic_camera_sleep(long v)
{
    kbd_sched_delay(v);
}
void ubasic_bracketing_done()
{
    kbd_sched_wait();
}
void ubasic_wfsp()
{
    kbd_sched_wfsp();
}
void ubasic_scts()
{
 kbd_sched_scts();
}
void ubasic_blcd() 
{
 kbd_sched_blcd();
}
void ubasic_camera_shoot()
{
#if OPT_SERIALIO
  if(!conf.ricoh_ca1_mode)ttyRemoteSynchShoot(); 
  else 
#endif
kbd_sched_shoot();
}
void ubasic_rm()                               
{
 #if defined(CAMERA_a480)
  kbd_sched_click(KEY_SET);
  kbd_sched_click(KEY_PRINT);
#else
 if(!rrm) record_mode();                       
 else if(rrm==1)                               
  {
   KBD_STACK_PUSH(PLAYBACK_MODE);              
   KBD_STACK_PUSH(SCRIPT_RELEASE);
  }
 else if (rrm==2)                             
  {
#if !defined(CAMERA_a1000)
   playback_mode();
#endif
   record_mode();
  }
 else if(rrm==3)                              
  {
   KBD_STACK_PUSH(MOVIE_MODE);
   KBD_STACK_PUSH(SCRIPT_RELEASE);
  }
#endif
}
void ubasic_pm()                               
{
 conf.edge_overlay_enable=0;
 if(shooting_can_focus()) cf=lens_get_focus_pos_from_lense(); 
#if defined CAM_PB_MODE                        
  rrm=1;
  KBD_STACK_PUSH(PLAYBACK_MODE);
  KBD_STACK_PUSH(SCRIPT_PRESS);
#else                                          
 rrm=0;
 playback_mode();
#endif
}
void ubasic_mm()                               
{
#if !defined  CAM_MOVIE_PLE                    
  rrm=3;
  KBD_STACK_PUSH(MOVIE_MODE);
  KBD_STACK_PUSH(SCRIPT_PRESS);
#else
   rrm=2;
  movie_mode();
#endif
}
void ubasic_sm(t)                              
{
#if defined CAM_HAS_VIDEO_PB   
           kbd_sched_delay(100);
           KBD_STACK_PUSH(KEY_VIDEO);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(500);
           KBD_STACK_PUSH(KEY_VIDEO);
           KBD_STACK_PUSH(SCRIPT_PRESS);
           kbd_sched_delay(1000*t+1000);
           KBD_STACK_PUSH(KEY_VIDEO);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(500);
           KBD_STACK_PUSH(KEY_VIDEO);
           KBD_STACK_PUSH(SCRIPT_PRESS);
#elif !defined CAM_MOVIE_PLE                   
           KBD_STACK_PUSH(MOVIE_MODE);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(1000);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(900);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_PRESS);
           kbd_sched_delay(1000*t+1000);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_RELEASE);                               
           kbd_sched_delay(900);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_PRESS);
           kbd_sched_delay(1000);
           KBD_STACK_PUSH(MOVIE_MODE);
           KBD_STACK_PUSH(SCRIPT_PRESS);
#elif defined CAM_MOVIE_PLE                   
           movie_mode();
  
           KBD_STACK_PUSH(SCRIPT_RECORD);
           kbd_sched_delay(2000);
           KBD_STACK_PUSH(SCRIPT_PLAYBACK);
           kbd_sched_delay(2000);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_RELEASE);
           kbd_sched_delay(900);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_PRESS);
           kbd_sched_delay(1000*t+1000);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_RELEASE);                               
           kbd_sched_delay(900);
           KBD_STACK_PUSH(KEY_SHOOT_FULL);
           KBD_STACK_PUSH(SCRIPT_PRESS);
           kbd_sched_delay(1000);
#endif
}
void ubasic_usbupload(t)                        
{
 usbup_time = t;
 KBD_STACK_PUSH(SCRIPT_USBUP);
}
void ubasic_musbc()
{
 KBD_STACK_PUSH(SCRIPT_MUSBC);
}
void ubasic_busbc()
{
 KBD_STACK_PUSH(SCRIPT_BUSBC);
}
void ubasic_hdrfs()                
{
 KBD_STACK_PUSH(SCRIPT_HDRFS);
}
void ubasic_su(int hr, int min)     
{
 st_time.hr=hr;
if(st_time.hr<0)st_time.hr=0;
if(st_time.hr>23)st_time.hr=23;
 st_time.min=min;
if(st_time.min<0)st_time.min=0;
if(st_time.min>59)st_time.min=59;
su_first=1;                         
conf.alt_prevent_shutdown=2;        
 KBD_STACK_PUSH(SCRIPT_SU);
 TurnOffBackLight();
}
void ubasic_baflf(int duration)     
{
 afcnt=shooting_get_tick_count()+(duration*1000);
 KBD_STACK_PUSH(SCRIPT_BAFLF);
}
//remote autostart
void script_autostart()
{
  msleep(500);                                    
  strcpy(normal_script,conf.script_file);        
  const char *fn = "A/CHDK/SCRIPTS/Startup.bas";
FILE *fdstartup = NULL;
fdstartup=fopen(fn,"r");
 if(fdstartup != NULL)                          
   {
    fclose(fdstartup);
    script_load(fn,0);                            
   }
  else 
   {
    fclose(fdstartup);
    script_load(normal_script,0);                 
   }
  
	auto_started = 1;
	kbd_blocked = 1;
	gui_kbd_enter(); 
	script_console_add_line("! Autostart !"); 
      script_start();
}
void exit_alt()
{
 kbd_blocked = 0;
 gui_kbd_leave();
}
int baflf()                                     
{
 static int ls=1;                               
 if(shooting_get_tick_count()>=afcnt)           
 {
   ubasic_set_led(9,0,0);
  ls=1;
  return 0;
 }
 ubasic_set_led(9,ls,0);
 ls = !ls;
 if(!ls) kbd_sched_delay(10);                    
 else kbd_sched_delay(500);                      
 return 1;
}
int hdrfs()                                               
{
 static int current_ev=0;
 static int current_exp=0;
 static int first=1;
 static int dist=0;
 static int initd;                            
 static int cnt=1;                            
 static int scnt=1;                           
 static int deltaev=0;                        
 int far;
 put_off_ev96=deltaev;                        
 if(first==1)                                 
  {
   if(scnt>1)ubasic_shooting_set_focus(initd,SET_LATER); 
   kbd_sched_shoot();
   first=2;
   return 1;
  }
 if(first==2)                                   
  {
   if(scnt==1)initd=lens_get_focus_pos_from_lense(); 
   dist=initd;
   first=3;
  }
   sprintf(osdbuf," Frame %d/%d",scnt,cnt);
   console_add_line(osdbuf,1);
   sprintf(osdbuf,"#Focus %d",dist);
   console_add_line(osdbuf,2);
   sprintf(osdbuf," Shutter speed %s",shooting_get_camera_tv_string());
   console_add_line(osdbuf,3);            
   if(far==dist)far++;                         
   far=shooting_get_farpoint(dist)*1.2; 
   if((far<dist)||(far>65535))                 
     {   
      first=1;                                  
      cnt=1;                                    
      scnt++;                                   
      deltaev+=st_tv_ev;                        
      if(scnt>st_tv_exp)                        
       {
        deltaev=0;                              
        put_off_ev96=0;                         
        return 0;                               
       }
      return 1;                                 
     }
     dist=far;                                  
     ubasic_shooting_set_focus(dist+fpd,SET_LATER); 
     cnt++;
     kbd_sched_shoot();                         
     return 1;
}
int su()                                       
{
 long t;
 char buf[64];
 static long led_time;
 static int led_count = 3;
 t=time(NULL);                                  
 ttm = localtime(&t);                           
 if((ttm->tm_hour==st_time.hr)&& (ttm->tm_min>=st_time.min)) 
 {
  TurnOnBackLight();
  sprintf(buf,"! Wide awake !");               
  console_add_line(buf,1);
  return 0;
 }
  if(su_first)
 {
  led_time=(unsigned long)time(NULL)+60;
  su_first=0;
 }
     if(!(--led_count)) debug_led(0);
     if((unsigned long)time(NULL)==led_time)
     {
      debug_led(1);
      led_count = 3;
      led_time+=60;
     }
 return 1;
}

void init_tl(int a,int b, int c, int d,int e,int f,int g,int h,int i,int j,int k,int l,int m,int n,int p,int q,int r,int s, int t, int u)
{
int ovr_x = 112;
int ovr_y = 5;
tl_first = 1;                                                       
 tl.start_delay = 60*a +b;                                          
 if(tl.start_delay<2)tl.start_delay =2;
 tl.shoot_interval= 60*c + d;                                       
 if(tl.shoot_interval<1)tl.shoot_interval =1;
 tl.num_exposures=e;                                                
 if(tl.num_exposures<1)tl.num_exposures = 1;
 tl.endless_mode=f;
 if(tl.endless_mode<0) tl.endless_mode = 0;
 tl.shoot_mode=g;                                                    
 if(tl.shoot_mode<0) tl.shoot_mode =0;
 if(tl.shoot_mode>3) tl.shoot_mode=1;                                
 if(tl.shoot_mode==3)                                                
 {
  conf.tv_bracket_value=0;                                           
  conf.dist_mode=0;                                                  
 }
 tl.focus_mode = m;                                                   
 tl.ev_steps = l;
  if(tl.ev_steps<1) tl.ev_steps =1;
  if(tl.ev_steps>12) tl.ev_steps=12;
 tl.bracket_type=j;                                                   
 if(tl.bracket_type<0) tl.bracket_type =0;
 if(!tl.bracket_type && (tl.shoot_mode!=3))                           
  {
   conf.tv_bracket_value = tl.ev_steps;
   conf.dist_mode=0;                                                  
  }
 if(tl.bracket_type>=1)                                               
  {
    conf.tv_bracket_value=0;                                          
    if((tl.focus_mode<0)|| (tl.focus_mode>2)) tl.focus_mode=0;        
    conf.dist_mode=tl.focus_mode+1;
    if(tl.focus_mode==1)conf.bracket_type=3;                          
  }
 if(!tl.bracket_type)tl.bkt_exposures=h;                               
 else tl.bkt_exposures=i;                                             
 if(tl.bkt_exposures<3) tl.bkt_exposures=3;    
 if(tl.bkt_exposures>19) tl.bkt_exposures=19;                        
 if((tl.bkt_exposures%2) != 1) tl.bkt_exposures-= 1;                  
 tl.bkt_exposures = ((tl.bkt_exposures+1)/2)+1;
 if((tl.shoot_mode==2)&&(tl.bkt_exposures>9))tl.bkt_exposures=9;       
 conf.bracket_type = tl.bkt_exposures;
 tl.focus_tv_exposures=h;                                             
   if(n<1 || n>5000) conf.subj_dist_bracket_value = 1;                
    else  conf.subj_dist_bracket_value = n; 
   if(p<450) conf.distance_setting = 450;                             
   else if(conf.distance_setting>5000)conf.distance_setting  = 5000;
   else conf.distance_setting = p; 
    if((tl.shoot_mode && tl.shoot_mode<3) && (tl.bracket_type != 2)&&(tl.shoot_interval<(2*tl.bkt_exposures))) tl.shoot_interval=2*tl.bkt_exposures; 
    else if((tl.shoot_mode && tl.shoot_mode<3) && (tl.bracket_type == 2))                   
    {
     if(tl.shoot_interval<(2*tl.bkt_exposures*tl.focus_tv_exposures))tl.shoot_interval=2*tl.bkt_exposures*tl.focus_tv_exposures;
     conf.tv_bracket_value=0;                                           
    }
 if(((tl.shoot_mode==1)||(tl.shoot_mode==2))&&(tl.bracket_type>=1)&&(tl.focus_mode==1)&&(tl.num_exposures==1))tl.shoot_interval=201; 
 tl.exposure_mode=k;                                                     
  if(((tl.bracket_type==0)&& (shooting_get_drive_mode()==CAM_PROPSET+1)))  
  {
   if(tl.exposure_mode<0) tl.exposure_mode=0;
   if(tl.exposure_mode>2) tl.exposure_mode=2;
   conf.bracket_type=tl.exposure_mode;
  }
 tl.sun=t;                                                        
if(!tl.shoot_mode && tl.sun)                                      
 {
   if(tl.exposure_mode<0) tl.exposure_mode=0;
   if(tl.exposure_mode>2) tl.exposure_mode=2;
 }
if(tl.sun && !tl.shoot_mode) tl.num_exposures=conf.sunrise_shots; 
tl.suncsv=u;                                                     
 
 if(!tl.shoot_mode)
 {
  conf.dist_mode=0; 
  tl.bracket_type=0; 
 }
 tl.shutdown=r;
 if(tl.shutdown<0) tl.shutdown=0;
 if(tl.shutdown>2) tl.shutdown=2;
 tl.blank_screen = q; 
 if(tl.blank_screen<0) tl.blank_screen=0;
 log_status=conf.save_auto;                                 
 if(s<=0)conf.save_auto=0;       
 else conf.save_auto=1; 
 tl.target_time = (unsigned long)time(NULL)+tl.start_delay;
 tl.led_time = (unsigned long)time(NULL)+ 30;
 if(!tl.shoot_mode && !shooting_get_drive_mode())                 tl_mod = 0;
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==0))  tl_mod = 1;                     
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==0))  tl_mod = 2;                     
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==1)&&(tl.focus_mode==0))tl_mod = 3;   
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==1)&&(tl.focus_mode==0))tl_mod = 4;   
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==1)&&(tl.focus_mode==1))tl_mod = 5;   
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==1)&&(tl.focus_mode==1))tl_mod = 6;   
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==1)&&(tl.focus_mode==2))tl_mod = 7;   
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==1)&&(tl.focus_mode==2))tl_mod = 8;  
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==2)&&(tl.focus_mode==0))tl_mod = 9; 
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==2)&&(tl.focus_mode==1))tl_mod = 10; 
 else if ((shooting_get_drive_mode()==1)&& (tl.bracket_type==2)&&(tl.focus_mode==2))tl_mod = 11; 
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==2)&&(tl.focus_mode==0))tl_mod = 12; 
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==2)&&(tl.focus_mode==1))tl_mod = 13; 
 else if ((shooting_get_drive_mode()==CAM_PROPSET+1)&& (tl.bracket_type==2)&&(tl.focus_mode==2))tl_mod = 14; 
 unsigned int mmode = mode_get();
 conf.line_length=20;
 bracket_running = 1;
 tl.running=1;        
 kbd_sched_tl();
}
extern volatile long focus_busy;
static int ss;                                                         
int time_lapse()
{
 static int led_count = 20;
 static unsigned long led_time,usb_detect_time,finished_time;
 static int usb_detect = 0;
 static unsigned long prev_time_left;
 static unsigned long current_time_left,auto_start;
 static int usb_2 =0,shot_count;                                       
 static int focus_tv_be;                                               
 static int current_override,start_tv;                                 
 static int tv_bkt_cnt;                                                
 static int ctvoe;                                                     
 static int sd =0;
 static int tldone = 0;							           
 static int pos_x = 16;
 static int pos_y = 50,m;
 static int auto_exposures,alldone;
 color tr = MAKE_COLOR(COLOR_TRANSPARENT,COLOR_GREEN);                  
 color cc = MAKE_COLOR(COLOR_TRANSPARENT,COLOR_RED);                    
 char buf[64];
 static int ls;                                                         
 static int hpd;                                                        
 static int fld;                                                        
 static int burst_time;                                                 
 static long secremain;                                                 
 static long t;                                                         
 static int final_exposure;                                             
 static int delay_done=0;                                               
if(tl_first)
{
 m=mode_get()&MODE_SHOOTING_MASK;
 if(tl.shoot_mode && (tl.shoot_mode<3)) conf.synch_enable=1;            
 if((tl.bracket_type>=1)&& shooting_can_focus()&&(tl.focus_mode!=2)&& shooting_get_drive_mode()) conf.distance_setting=lens_get_focus_pos()-fpd;                                               
 if(tl.shoot_mode && (tl.shoot_mode<3) && (conf.dist_mode==3))          
 {
  shooting_set_zoom(conf.digi_zoom_setting);                            
  allbest_shooting_set_focus(conf.digi_ref_dist+fpd);                   
 }
  if(tl.bracket_type ==2)                                               
  {
    current_override=conf.tv_override;                                  
#if defined(CAMERA_tx1)
  conf.tv_override=shooting_get_tv96_index(shooting_get_tv96());
#else
    if (!(m==MODE_M || m==MODE_TV)) conf.tv_override=shooting_get_tv96_index(shooting_get_tv96()); 
    else if (!((conf.tv_override >=0) && (conf.tv_override <=65) && (conf.tv_override != 19) && conf.tv_override_enable)) conf.tv_override =shooting_get_tv96_index(shooting_get_user_tv96());                           	   
#endif
    start_tv=conf.tv_override;
    ctvoe=conf.tv_override_enable;
    conf.tv_override_enable = 1;                                         
  }
  if(!tl.shoot_mode)                                                     
  {
#if defined(CAMERA_tx1)
    ss=shooting_get_tv96();
#else
    if (!(m==MODE_M || m==MODE_TV))ss=shooting_get_tv96(); 
        else 
          {
	    if (conf.tv_override >=0 && conf.tv_override <=65 && conf.tv_override != 19 && conf.tv_override_enable)ss=shooting_get_tv96();	
           else ss=shooting_get_user_tv96();  
	    }
#endif
  }
  if(!tl.shoot_mode && (shooting_get_prop(PROPCASE_FLASH_MODE)!=2))               
 {
  if((ss>=96) && (tl.shoot_interval<4)) tl.shoot_interval=4;                      
  else if (ss<96 && ss>=0 && tl.shoot_interval < 5)tl.shoot_interval=5;           
  else if (ss<0 && ((ss-192)< shooting_get_tv96_from_shutter_speed((float)tl.shoot_interval)))  tl.shoot_interval = (int)(shooting_get_shutter_speed_from_tv96(ss-192))+2; 
 }
 else if(!tl.shoot_mode && (shooting_get_prop(PROPCASE_FLASH_MODE)==2))           
 {
  if (ss<96 && ss>=0 && tl.shoot_interval < 2)tl.shoot_interval=2;                
  else if(ss<0 && ((ss-192)< shooting_get_tv96_from_shutter_speed((float)tl.shoot_interval)))  tl.shoot_interval = (int)(shooting_get_shutter_speed_from_tv96(ss-192));
 }
 prev_time_left=999999;
 tl.shot_count=0;
 tv_bkt_cnt=1;
 tl.ss = 1;                                                                       
 tl_first=0;
 alldone=0;
 hpd=0;
 fld=0;
 ls = 0;                                                                         
 auto_exposures=tl.num_exposures;                                         
 focus_tv_be=tl.focus_tv_exposures;                                              
                                               
if((!tl.shoot_mode && !shooting_get_focus_mode() && !has_refocused && !af_all) || ((tl.shoot_mode && (tl.shoot_mode<3)) && !shooting_get_focus_mode() && !tl.bracket_type))  
  {
   kbd_sched_delay(100);
   kbd_sched_release(KEY_SHOOT_HALF);
   kbd_sched_delay(2000);
   kbd_sched_press(KEY_SHOOT_HALF);
   hpd=1; 
   return 1;                                                                  
  }
  if(tl.shoot_mode==3)                                                       
  {
   if(tl.num_exposures==1) burst_time=1;                                     
   else 
   {
     burst_time=0;                                                           
     shot_count=get_target_file_num()+tl.num_exposures;                      
   }                                                
  }
  if(conf.save_raw)
    secremain=tl.shoot_interval*GetRawCount();
  else
    secremain=tl.shoot_interval*GetJpgCount();
}
if(tldone)                                                                    
{
 tldone = 0;
 ls=0;                                                                        
 conf.save_auto=log_status;                                                   
 return 0;                                                                    
}
if((tl.shoot_mode==3)&& !hpd && !bracket_running)                            
  {
   if(burst_time &&((unsigned long)time(NULL)==tl.target_time))              
   {
    KBD_STACK_PUSH(KEY_SHOOT_FULL);                                          
    KBD_STACK_PUSH(SCRIPT_RELEASE); 
    hpd=1;                                                                   
   }
   else if (!burst_time)                                                     
   {
     if(get_target_file_num()==shot_count)                                   
      {
        KBD_STACK_PUSH(KEY_SHOOT_FULL);                                      
        KBD_STACK_PUSH(SCRIPT_RELEASE); 
        hpd=1;                                                               
      }
   }
   return 1; 
  } 
if((tl.shoot_mode==3)&& hpd && !bracket_running)                                 
  {
   hpd=0;
   tl_first=1;
   return 0;
  } 
 if(!tl_first && hpd && !fld)                                                  
 {
   hpd=0;
   fld=1;
   DoAFLock();                                                  
   afl=1;                                                       
   return 1;
 }
if(get_usb_power(1) && usb_detect && (tl.shutdown==2)&&((unsigned long)time(NULL)-usb_detect_time>1) )
 {
  usb_2 = 1;
  play_sound(4);
 }
 if((tl.shutdown==2)&& !get_usb_power(1)&& !usb_detect)                   
  {
    console_add_line("# Waiting for USB ",1);
    return 1;        
  }
 if((tl.shutdown==2) && get_usb_power(1) && !usb_detect)                  
  {
   usb_detect = 1;                                                        
   play_sound(4);
   script_console_clear();
   tl.target_time = (unsigned long)time(NULL)+tl.start_delay;
   usb_detect_time= (unsigned long)time(NULL);
   if(tl.blank_screen)TurnOffBackLight();
   return 1;
  }
   if(!tl.num_exposures && (tl.shutdown==1) && tl.shoot_mode && !bracket_running && !sd)          
   { 
    sd=1;
    kbd_sched_delay(2000);
    camera_shutdown_in_a_second();
    return 1;
   }
   if(!tl.num_exposures  && (tl.shutdown==2)&& !sd)                          
   { 
    sd=1;
    kbd_sched_delay(2000);
    #if defined(OPT_SERIALIO)
    if(!conf.ricoh_ca1_mode && gSerialIORemoteShootingOn)
    ttySendTimeLapseShutdownCmd();
    #endif   
    camera_shutdown_in_a_second();
    return 1;
   }
   if(!tl.num_exposures && !bracket_running && !tl.endless_mode && !tl.shoot_mode && (((unsigned long)time(NULL)-auto_start)>3)) 
  {
   if(conf.ricoh_ca1_mode || (!conf.ricoh_ca1_mode && conf.use_af_led  && gSerialIORemoteShootingOn))      
   {
    debug_led(ls);                                                           
   }
   else if(!conf.ricoh_ca1_mode && !conf.use_af_led && gSerialIORemoteShootingOn)                         
   {
     if(ls)ubasic_set_led(9,1,100);                                          
     else ubasic_set_led(9,0,0);
   }
    ls = !ls;
    if(!ls) kbd_sched_delay(30);                                              
    else kbd_sched_delay(3000);                                               
  }
  if((tl.num_exposures<0) && bracket_running)
  {
    sprintf(buf,"! Overrun error !");                                        
    console_add_line(buf,1);
    sprintf(buf,"! Sequence terminated !");                                  
    console_add_line(buf,3);
    tldone = 1;
    tl_first=1;
    kbd_sched_delay(3000);                                                   
  }
 if(bracket_running)                                                              
 { 
   if(tl.endless_mode && (ft_time.hr<24))                                    
   {
    t=time(NULL);                                                            
    ttm = localtime(&t);                                                     
   if((ttm->tm_hour==ft_time.hr)&& (ttm->tm_min>=ft_time.min)&&(ttm->tm_sec>15) ) 
    {
      ft_time.hr=99;                                                         
      debug_led(0);
      conf.save_auto=log_status;
      tl_first=1;
      return 0;
    }
   }
   
   
   
    if((tl.shoot_mode==1)&& shutter_int && (tl.bracket_type!=2))             
    {
      kbd_sched_release(KEY_SHOOT_FULL);                                     
       if(!tl.num_exposures && !alldone)
       {
        alldone=1;
        finished_time=(unsigned long)time(NULL);                             
       }  
      if(!tl.num_exposures && (((unsigned long)time(NULL)-finished_time)>2) )    
      { 
        if(!tl.bracket_type && !shooting_get_focus_mode())                       
         {
           UnlockAF();                                                           
           afl=0;                                                                
         } 
        if(tl.blank_screen)TurnOnBackLight();   
        console_add_line("! Sequence completed",1);
        conf.dist_mode=0;
        conf.tv_bracket_value=0;                                                
        if((tl.focus_mode==1)&&(tl.bracket_type==1))                             
        {
         lens_set_focus_pos(conf.distance_setting+fpd);                          
         sprintf(buf,"# %d stack images",bracketing.shoot_counter+1);            
         console_add_line(buf,2);
        }                                                  
        sprintf(buf,"# Sequence took %3d secs", finished_time-auto_start+1);     
        console_add_line(buf,3);
        usb_detect = 0;
        bracket_running = 0;
        tl.ss=1;                                                                 
        shutter_int=0; 
        tldone = 1;
        tl_first = 1;
        kbd_sched_delay(3000);                                                   
                                                       
      }
        if(tl.num_exposures)
        {
         shutter_int=0;                                                             
         tl.ss=0;                                                                   
        }
      return 1;
    }
    
    
    
    
     if(alldone && (tl.bracket_type==2) && (((unsigned long)time(NULL)-finished_time)>(2+2*final_exposure))&& !tl.num_exposures && !focus_tv_be)
     {
        alldone=0;
        if(tl.blank_screen)TurnOnBackLight();  
        console_add_line("! Sequence completed",1);
        conf.dist_mode=0;                                               
        if((tl.focus_mode==1)&&(tl.bracket_type==1))                                
        {
         lens_set_focus_pos(conf.distance_setting+fpd);
         sprintf(buf,"# %d stack images",bracketing.shoot_counter+1);
         console_add_line(buf,2);
        }                                                
        sprintf(buf,"# Sequence took %3d secs", finished_time-auto_start+1);
        conf.tv_override=current_override;                                           
        conf.tv_override_enable = ctvoe;                                             
        usb_detect = 0;
        bracket_running=0;
        tldone = 1;
        conf.save_auto=log_status;
        tl_first = 1;
        kbd_sched_delay(3000);                                                   
     }
   if((tl.shoot_mode==1)&& shutter_int && (tl.bracket_type==2) && tl.shot_count) 
   {
     ++tv_bkt_cnt;
      if(--focus_tv_be)                                                          
      {
       kbd_sched_press(KEY_SHOOT_FULL);                                        
       kbd_sched_delay(2000);                                                    
       if(!tl.exposure_mode)conf.tv_override-=tl.ev_steps;                       
       if(tl.exposure_mode==1)conf.tv_override+=tl.ev_steps;                     
       if(tl.exposure_mode==2)                                                   
        {
          if(tv_bkt_cnt%2)conf.tv_override=start_tv+(tv_bkt_cnt/2)*tl.ev_steps;
          else conf.tv_override=start_tv-(tv_bkt_cnt/2)*tl.ev_steps;
        }
        if(conf.tv_override==19)conf.tv_override=18;                             
       } 
       final_exposure=(int)shooting_get_shutter_speed_from_tv96(shooting_get_tv96_from_index(conf.tv_override));
      if(!focus_tv_be && tl.num_exposures)                                       
      {
       tl.ss=0;                                                                   
       focus_tv_be = tl.focus_tv_exposures;                                       
       conf.tv_override=start_tv;                                                 
       tv_bkt_cnt=1;
      }                                                                                                                   
      kbd_sched_release(KEY_SHOOT_FULL);                                          
      shutter_int=0;                                                              
       if(!tl.num_exposures && !focus_tv_be && !alldone)                          
       {
        alldone=1;
        finished_time=(unsigned long)time(NULL);
        kbd_sched_release(KEY_SHOOT_FULL);   
       }
      return 1;                    
   }
  if(get_inf_focus() && (tl.shoot_mode==2) && tl.shot_count && (tl.bracket_type==2) && (((unsigned long)time(NULL)-auto_start)>4)) 
   {
     ++tv_bkt_cnt;
      if(--focus_tv_be)                                                           
      {
       auto_start=(unsigned long)time(NULL); 
       kbd_sched_click(KEY_SHOOT_FULL);                                        
       kbd_sched_delay(1000);                                                     
       if(!tl.exposure_mode)conf.tv_override-=tl.ev_steps;                        
       if(tl.exposure_mode==1)conf.tv_override+=tl.ev_steps;                      
       if(tl.exposure_mode==2)                                                    
        {
          if(tv_bkt_cnt%2)conf.tv_override=start_tv+(tv_bkt_cnt/2)*tl.ev_steps;
          else conf.tv_override=start_tv-(tv_bkt_cnt/2)*tl.ev_steps;
        }
        if(conf.tv_override==19)conf.tv_override=18;                             
       } 
      else                                                                         
      {
       tl.shot_count=0;
       tl.ss = 0;                                                                  
       if(tl.num_exposures)                                                        
        {
         focus_tv_be = tl.focus_tv_exposures;                                      
         conf.tv_override=start_tv;                                                
         tv_bkt_cnt=1;
        }
       else                                                                        
        {
          if(tl.blank_screen)TurnOnBackLight();  
          finished_time=(unsigned long)time(NULL);  
          console_add_line("! Sequence completed",1);
          conf.dist_mode=0;                                                                                              
          sprintf(buf,"# Sequence took %3d secs", finished_time-auto_start+1);
          console_add_line(buf,3);
          conf.tv_override=current_override;                                         
          conf.tv_override_enable = ctvoe;                                           
          usb_detect = 0;
          bracket_running=0;                                                              
          tl.shot_count=0;
          tldone = 1;
          tl_first = 1;
          lens_set_focus_pos(conf.distance_setting+fpd);                              
          delay_done=0;
          kbd_sched_delay(3000);                                                     
        }                                                                    
      }                                                                                                                                                     
      return 1;  
   }
  if(get_inf_focus() && (tl.shoot_mode==2) && (tl.bracket_type!=2) && !tl.num_exposures && (((unsigned long)time(NULL)-auto_start)>3)) 
   {
       finished_time=(unsigned long)time(NULL);
       console_add_line("! Sequence completed",1);
       conf.dist_mode=0;
       conf.tv_bracket_value=0;
       if(tl.blank_screen)TurnOnBackLight();  
        if(!tl.bracket_type && !shooting_get_focus_mode())                           
         {
           UnlockAF();
           afl=0;
         } 
       if(tl.bracket_type==1)lens_set_focus_pos(conf.distance_setting+fpd);         
       sprintf(buf,"# Sequence took %3d secs", finished_time-auto_start+1);
       console_add_line(buf,3);
       usb_detect = 0;
       bracket_running = 0;                                                              
       tldone = 1;
       tl_first = 1;
       kbd_sched_delay(3000);                                                       
       return 1;
   } 
   if(!tl.num_exposures && !tl.endless_mode && !tl.shoot_mode) 
    {
     if((!tl.shutdown || ((tl.shutdown==1)&& sd))&& (((unsigned long)time(NULL)-auto_start)>3))                                           
     {
      if(!shutter_int && !(tl.shoot_mode==1))
      {
       if(tl.blank_screen)
       {
       #if defined(OPT_SERIALIO)
        if(!conf.ricoh_ca1_mode && gSerialIORemoteShootingOn)
         ttySendTimeLapseBlankScreenCmd(0,0);
       #endif       
        TurnOnBackLight();                                                
       } 
      }
      usb_detect = 0;
      bracket_running = 0;  
      tl_first = 1;
      if(!shooting_get_focus_mode())                                                         
      {                                                             
       UnlockAF();                                                                           
       afl=0;                                                                                
      }
       return 0;                                                                             
     }  
     else if((tl.shutdown==1)&& !sd)                                                         
     {
      sd=1;                                                                                  
      kbd_sched_delay(2000);
 #if defined(OPT_SERIALIO)
      if(!conf.ricoh_ca1_mode && gSerialIORemoteShootingOn)
      ttySendTimeLapseShutdownCmd();
#endif
      camera_shutdown_in_a_second();
      return 1;
     }                                                                            
    }
   if((shooting_get_prop(PROPCASE_FLASH_MODE)!=2) && shooting_get_drive_mode())              
   {
    play_sound(4); 
    console_add_line("! Flash must be OFF",1);
    console_add_line("# Full-press to finish",2);
    bracket_running = 0;                                                                          
    return 1;
   }
   if(!tl.shoot_mode && shooting_get_drive_mode())                                           
   {
    play_sound(4); 
    console_add_line("! Not single-shot mode",1);
     console_add_line("# Full-press to finish",2);
    bracket_running = 0;                                                                          
    return 1;
   }
   if(((tl.shoot_mode==1)||(tl.shoot_mode==3)) && (shooting_get_drive_mode()!=1))            
   {
    play_sound(4); 
    console_add_line("! Not continuous mode",1);
    console_add_line("# Full-press to finish",2);
    bracket_running = 0;                                                                          
    return 1;
   }
   if((tl.shoot_mode==2) && (shooting_get_drive_mode()!=CAM_PROPSET+1))                      
   {
    play_sound(4); 
    console_add_line("! Not timer mode",1);
    console_add_line("# Full-press to finish",2);
    bracket_running = 0;                                                                          
    return 1;
    }
   
   if((tl.bracket_type>=1) && !shooting_can_focus())                                         
   {
    play_sound(4); 
    console_add_line("! Cannot override focus !",1);
    console_add_line("# Full-press to finish",2);
    bracket_running = 0;                                                                          
    return 1;
    }
if((tl.shoot_interval>=30)&&(tl.shoot_interval!=201)&& tl.blank_screen)          
                                                                                            
    {
     if(!(--led_count)) 
     {
      if(conf.ricoh_ca1_mode || (!conf.ricoh_ca1_mode && conf.use_af_led && gSerialIORemoteShootingOn))      
       debug_led(0);                                                            
      else ubasic_set_led(9,0,0);                                               
     }
     if((unsigned long)time(NULL)==tl.led_time)
     {
      if(conf.ricoh_ca1_mode || (!conf.ricoh_ca1_mode && conf.use_af_led && gSerialIORemoteShootingOn))
       debug_led(1);
      else ubasic_set_led(9,1,100);
      play_sound(4); 
      led_count = 20;
      tl.led_time+=30;
     }
    }
  current_time_left=tl.target_time-(unsigned long)time(NULL);
  if(((unsigned long)time(NULL)==tl.target_time))                               
   {
    if(conf.save_raw)
    secremain=tl.shoot_interval*(GetRawCount()-1);
    else
    secremain=tl.shoot_interval*(GetJpgCount()-1);
     auto_start=(unsigned long)time(NULL);                                      
     if(tl.shoot_mode!=3) tl.target_time+= tl.shoot_interval;
     else
     {
      if(burst_time) tl.target_time+= tl.shoot_interval;                        
      else tl.target_time=0;
      bracket_running=0;                                                             
       KBD_STACK_PUSH(KEY_SHOOT_FULL);
       KBD_STACK_PUSH(SCRIPT_PRESS);
      return 1;
     }                                       
     prev_time_left=tl.shoot_interval;
     if(!tl.endless_mode)                                                       
      {
       if(!(--tl.num_exposures))finished_time=(unsigned long)time(NULL);         
      }
     if(usb_2) tl.num_exposures=0;
     if(!tl.shoot_mode)                                                         
    {
     if(conf.ricoh_ca1_mode)
     {
      KBD_STACK_PUSH(KEY_SHOOT_HALF);
      KBD_STACK_PUSH(SCRIPT_RELEASE);
      kbd_sched_delay(100);
      KBD_STACK_PUSH(KEY_SHOOT_FULL);
      KBD_STACK_PUSH(SCRIPT_RELEASE);
      kbd_sched_delay(100);
      KBD_STACK_PUSH(KEY_SHOOT_FULL);
      KBD_STACK_PUSH(SCRIPT_PRESS);
      if(shooting_get_prop(PROPCASE_FLASH_MODE)!=2)kbd_sched_delay(1800);        
      else kbd_sched_delay(300);
      KBD_STACK_PUSH(KEY_SHOOT_HALF);
      KBD_STACK_PUSH(SCRIPT_PRESS); 
     }
   #if defined(OPT_SERIALIO)
     else if(!conf.ricoh_ca1_mode && gSerialIORemoteShootingOn)                               
        {
        if(tl.blank_screen)
           ttyRemoteSynchShootWithBlankLCD(tl.shoot_interval*kmsPerSec);
        else
           ttyRemoteSynchShoot(); 
        } 
   #endif
    }
    else if(tl.shoot_mode==2)   kbd_sched_click(KEY_SHOOT_FULL);                 
     else if (tl.shoot_mode==1)kbd_sched_press(KEY_SHOOT_FULL);                  
     current_time_left=tl.target_time-(unsigned long)time(NULL);
     ++tl.shot_count;
 }
   if((current_time_left<prev_time_left) && (!tl.blank_screen|| (tl.blank_screen && !tl.shot_count)) && tl.num_exposures) 
   {
   if(tl.endless_mode && (ft_time.hr<24))                                         
    {
        sprintf(buf,"# Current time %2d:%2d:%2d",ttm->tm_hour,ttm->tm_min,ttm->tm_sec);           
        console_add_line(buf,2);
        sprintf(buf,"# Finish time  %2d:%2d:00",ft_time.hr,ft_time.min);                
        console_add_line(buf,3);
    }
    if(!tl.shot_count)
    {
     if(conf.save_raw)
     secremain=tl.shoot_interval*GetRawCount();
     else
     secremain=tl.shoot_interval*GetJpgCount();
    }
    sprintf(buf,"%5d",current_time_left);
    draw_big_string(pos_x,pos_y,buf,tr);
    sprintf(buf,"%5d",(tl.endless_mode)?tl.shot_count:tl.num_exposures);
    draw_big_string(pos_x,pos_y+BIG_FONT_HEIGHT,buf,cc);
    sprintf(buf,"%02d:%02d:%02d:%02d",secremain/86400,(secremain%86400)/3600,((secremain%86400)%3600)/60,((secremain%86400)%3600)%60);
    draw_big_string(pos_x+(7*BIG_FONT_WIDTH),pos_y,buf,tr); 
    sprintf(buf,"%d",(conf.save_raw)?GetRawCount():GetJpgCount());
    draw_big_string(pos_x+(7*BIG_FONT_WIDTH),pos_y+BIG_FONT_HEIGHT,buf,cc); 
    prev_time_left=current_time_left;
   }
    if(tl.blank_screen && tl.shot_count)
   {
 #if defined(OPT_SERIALIO)
    if(!conf.ricoh_ca1_mode && gSerialIORemoteShootingOn)
      {
      
      }
    else
#endif
      TurnOffBackLight();
   } 
  }  
   return 1;
}
void set_key_press(int nSet)
{
	key_pressed = nSet;
	kbd_blocked = nSet;
	nRmt = nSet;
}
//Called from my_kbd_read_keys(). Returns true to override keys (physw_status), false to leave them alone.
long kbd_process()
{
#ifdef OPT_SERIALIO
if(gSerialIORemoteShootingOn)
   {
   int kbdReturnVal;
   if(ttyProcessing(kbd_blocked, &kbdReturnVal))
      return kbdReturnVal;
   } 
#endif
static int nCER=0;
static int nReverseDelay=0;
static long time_full_pressed;         
unsigned int mmode=0;
unsigned int nCrzpos,i;
unsigned int drmode = 0;
   if(conf.ricoh_ca1_mode)
  {
	drmode = shooting_get_drive_mode();
	mmode = mode_get();
	mplay = (mmode&MODE_MASK)==MODE_PLAY;
	mvideo= ((mmode&MODE_SHOOTING_MASK)==MODE_VIDEO_STD || (mmode&MODE_SHOOTING_MASK)==MODE_VIDEO_SPEED || (mmode&MODE_SHOOTING_MASK)==MODE_VIDEO_COMPACT ||(mmode&MODE_SHOOTING_MASK)==MODE_VIDEO_MY_COLORS || (mmode&MODE_SHOOTING_MASK)==MODE_VIDEO_COLOR_ACCENT);
  }
       
        if (key_pressed && !nRmt)
        {
                if (kbd_is_key_pressed(conf.alt_mode_button) ||                                    
                        ((key_pressed >= CAM_EMUL_KEYPRESS_DELAY) && 
                         (key_pressed < CAM_EMUL_KEYPRESS_DELAY+CAM_EMUL_KEYPRESS_DURATION)))
                {
                        if (key_pressed <= CAM_EMUL_KEYPRESS_DELAY+CAM_EMUL_KEYPRESS_DURATION)      
                                key_pressed++;
                        if (key_pressed == CAM_EMUL_KEYPRESS_DELAY)                                 
                                kbd_key_press(conf.alt_mode_button);
                        else if (key_pressed == CAM_EMUL_KEYPRESS_DELAY+CAM_EMUL_KEYPRESS_DURATION) 
                                kbd_key_release(conf.alt_mode_button);
                        return 1;                                                                   
                } 
                else                                                                                
                if (kbd_get_pressed_key() == 0)                                                     
                {
                        if (key_pressed != 100 && (key_pressed < CAM_EMUL_KEYPRESS_DELAY))
                        {
                          kbd_blocked = 1-kbd_blocked;                                              
                          if (kbd_blocked) gui_kbd_enter(); else gui_kbd_leave();                   
                        }
                        key_pressed = 0;                                                            
                        return 1;                                                                   
                }
                return 1;
        }                 
        
        if (kbd_is_key_pressed(conf.alt_mode_button))
        {
                if (conf.ricoh_ca1_mode && conf.remote_enable) conf.synch_enable=1;
                key_pressed = 1;
                kbd_key_release_all();          
                return 1;
        }
        
        if (kbd_blocked && nRmt==0)
        {
	  if (kbd_is_key_pressed(KEY_SHOOT_FULL))                                   
           {
	      key_pressed = 100;
	      if (!state_kbd_script_run)
             {
               script_console_clear();
               conf.cs=1;                                                       
		   script_start();
	       } 
            else                                             
             {
               if(!conf.sdm_console) script_console_add_line(lang_str(LANG_CONSOLE_TEXT_INTERRUPTED));
               else console_add_line(lang_str(LANG_CONSOLE_TEXT_INTERRUPTED),3);
		   script_end();
	       }
	      }
                if (state_kbd_script_run) process_script(); 
                else gui_kbd_process();
        }  
 
      else        
        
  {
    if(conf.ricoh_ca1_mode && (shooting_get_tick_count()>5000))
     {
if(nWt>0) {nWt--;return 1;}
#if CAM_NEED_HP
#if defined(CAMERA_g9)
if((nConffin==1)&& conf.script_startup && (shooting_get_tick_count()>8000)) {nConffin=0;nFirst=1;}    
else if((nConffin==1) && !conf.script_startup){nConffin=0;nFirst=1;}
#else
if(nConffin==1){nConffin=0;nFirst=1;}
#endif
if(nFirst==1)
{
    if(nSW==0)
    {
        nSW=1;
#if !defined(CAMERA_g9)
        nWt=10;
#else
        nWt=30;
#endif
        kbd_key_release_all();
        kbd_key_press(KEY_SHOOT_HALF); 
        soft_half_press = 1;
        set_key_press(1);
        return 1;
    }
    else if(nSW==1)
    {
        nSW=2;
        nWt=10;
        kbd_key_release(KEY_SHOOT_HALF); 
        soft_half_press = 0;
        set_key_press(1);
        gEnableScripting=shooting_get_tick_count(); 
        return 1;
    }
    else if(nSW==2)
    {
        set_key_press(0);
        nWt=10;
        nSW=0;
        nFirst=0;
        return 1;
    }
}
#endif
if (kbd_is_key_pressed(KEY_SHOOT_FULL)) conf.synch_enable=0;
	if (kbd_is_key_pressed(KEY_SHOOT_HALF) && nTxzoom>0) 
          {
		nCount2=0;
		nTxzoom=0;
		nReczoom=0;
		nTxvideo=0;
		debug_led(0);
	    }
	if (mplay && (kbd_is_key_pressed(KEY_LEFT) || kbd_is_key_pressed(KEY_RIGHT)))
           {
		nPlyname=KEY_LEFT;
		if(kbd_is_key_pressed(KEY_RIGHT)) nPlyname=KEY_RIGHT;
		}
	if (kbd_is_key_pressed(KEY_VIDEO))
          {
		nCount2=0;
		nTxzoom=0;
		nReczoom=0;
		nTxvideo++;
		if(nTxvideo<50)
                 {
			kbd_key_release_all();
			debug_led(1);
		     }
		else {
			debug_led(0);
			return 0;
		     }
	      return 1;
	    }
	else if(nTxvideo>49) nTxvideo=0;
    if(conf.remote_zoom_enable>0 && ((mmode&MODE_MASK)==MODE_REC))     
    {
	if (kbd_is_key_pressed(KEY_ZOOM_IN) || kbd_is_key_pressed(KEY_ZOOM_OUT))
         {
		nCount2=0;
		nTxvideo=0;
		if(kbd_is_key_pressed(KEY_ZOOM_IN))                       
                 {
			if(nTxzname==KEY_ZOOM_IN) nTxzoom++;
			else nTxzoom=1;
			nTxzname=KEY_ZOOM_IN;
			}
		else {
			if(nTxzname==KEY_ZOOM_OUT) nTxzoom++;              
			else nTxzoom=1;
			nTxzname=KEY_ZOOM_OUT;
			}
		if(nTxzoom<50)                                          
                 {
			kbd_key_release_all();
			debug_led(1);
			}
		else {                                                  
			debug_led(0);
			return 0;
			}
		return 1;
		}
     }
	if(!get_usb_power(1) && nSW<100 && nCount==0 && nTxzoom>0) 
           {
		nCount2++;                                            
		if(nCount2>conf.zoom_timeout*100)                     
                 {
			 if(nTxzoom>0)
                       {
				nTxzoom=0;
				nReczoom=0;
				debug_led(0);                             
				}
			 nCount2=0;
			}
		return 1;
		}
	if(get_usb_power(1) && nSW<100 && nCount==0)                                                         
        {
         nCount2=0;
         kbd_key_release_all();
         conf.synch_enable=1; 
        } 
       if(get_usb_power(1) && conf.dist_mode && !shooting_get_drive_mode()&& (shooting_get_prop(PROPCASE_FLASH_MODE)==2))
        {
         if(((unsigned long)time(NULL))>(gDetectUsb+conf.lockout_time))                                    //outside lock-out time and flash off
          {
           nCa=2;
	     nSW=115;
	     nWt=2;
           shutter_int=0;                                                                                 
           if(!(srf && !conf.srb))kbd_key_press(KEY_SHOOT_FULL);                                          
           set_key_press(1);
	     nCount=0;                                                                                      
           gDetectUsb=(unsigned long)time(NULL);                                                          
	     return 1;                                                                                      
          }
        else                                                                                              
          {
           set_key_press(0);
           nWt=50;
	     nSW=0;
	     nCa=0;
           nCount=0; 
     
	     return 1; 
          }
        }                                                                                                 
	if(get_usb_power(1) && nSW<100 && nCount<6)                                                         
            {
		nCount++;
		return 1;                                                                                     
		}
	if(nCount>0 && nSW<100)                                                                             
          {
		if(mplay)                                                                                                                                                                        
                {
			if(get_usb_power(1)) return 1;                                                          
			kbd_key_release_all();                                                                  
                  if(playback) kbd_key_press(KEY_SET);                                                    
			else kbd_key_press(nPlyname);                                                                                                                      
			set_key_press(1);                                                                       
			nCount=0;                                                                                                                                                              
			nCa=2;                                                                                  
			nSW=101;
			nWt=5;
			return 1;                                                                               
		    }                                                                                         
		   if(nTxvideo>49) nTxvideo=0;
		   if(nCount<5) nCa=1;		                                                                
		   else nCa=2;				                                                          
		   nCount=0;                                                                                  
		   nSW=109;                                                                                   
		}
	if(nCa==2)
         {
     		if(nSW==101)
                {
			kbd_key_release_all();                                                                 
			set_key_press(0);
			nWt=50;
			nSW=0;
			nCa=0;
			return 1;                                                                              
		    } 
		if(nSW==109)
                {
			nCER=0;
                 
			if(nTxzoom>0)                                                                                   
                      {
				if(nTxzoom<100)                                                                           
                            {
					nIntzpos=lens_get_zoom_point();                                                     
					for(i=0;i<ZSTEP_TABLE_SIZE;i++)                                                     
                                  {
						if(nIntzpos<=nTxtbl[i])                                                       
                                         {
							if(i>0)                                                                 
                                               {
								if(abs(nTxtbl[i]-nIntzpos)<=abs(nTxtbl[i-1]-nIntzpos)) nTxtblcr=i; 
								else nTxtblcr=i-1;                                                 
							     }
							  else nTxtblcr=i;                                                       
							  i=ZSTEP_TABLE_SIZE;                                                    
							}
					    }
					      if(nTxzname==ZOOM_IN)                                                          
                                  {
						nTxtblcr++;                                                                    
						if(nTxtblcr>(ZSTEP_TABLE_SIZE-1)) nTxtblcr=(ZSTEP_TABLE_SIZE-1);               
					    }
					  else                                                                               
                                  {                                                                                
					     nTxtblcr--;                                                                    
					     if(nTxtblcr<0) nTxtblcr=0;                                                     
					    }
					nSW=108;                                                                            
					return 1;                                                                           
				   } 
                                                                                                                  
				  nTxzoom=0;                                                                              
				  nReczoom=0;                                                                             
			    }                                                                                           
                   
			if(nTxvideo>0) {nSW=121;return 1;}                                                              
                  
                                  
                    if((((conf.dist_mode||conf.tv_bracket_value)&&state_kbd_script_run))&&!mvideo)                                                                                                        
                  {
                    nSW=114;
                    nWt=2;
                    kbd_key_release_all();                                                                      
                    set_key_press(1);
                    return 1;                                                                                   
                  }
                  nSW=110;
			nWt=2;
			kbd_key_release_all();                                                                        
			if(!(srf && !conf.srb))kbd_key_press(KEY_SHOOT_HALF);                                         
                  soft_half_press = 1;
                  set_key_press(1);
			return 1;                                                                                     
	          } 
			if(nTxzoom>0 && nSW==108)                                                           
                {
				nCrzpos=lens_get_zoom_point();                                                
				if(nIntzpos!=nCrzpos) {nReczoom=0;}                                           
				if(nIntzpos==nCrzpos && nCER>50)                                              
                             {
					if(!get_usb_power(1))                                                   
                                   {
						kbd_key_release_all();                                           
						set_key_press(0);
						nTxzoom=1;                                                       
						nSW=0;                                                           
						nCount=0;                                                        
						nWt=10;
						nReczoom=1;                                                      
						return 1;                                                        
						}
					}
				if(nReczoom==0 && ((nTxzname==ZOOM_IN && nCrzpos>=nTxtbl[nTxtblcr]) || (nTxzname==ZOOM_OUT && nCrzpos<=nTxtbl[nTxtblcr])))
                              {
					if(get_usb_power(1))                                                   
                                    {
						i=1;
						if(nTxzname==ZOOM_IN)                                            
                                         {
							nTxtblcr++;                                                
							if(nTxtblcr>(ZSTEP_TABLE_SIZE-1))                          
                                            {
                                             nReverseDelay++;                                        
                                             if(conf.remote_zoom_enable==1)                          
                                              {
                                               if(nReverseDelay>100)                                 
                                                {
                                                 nTxtblcr=(ZSTEP_TABLE_SIZE-1);                      
                                                 nTxzname=ZOOM_OUT;                                  
                                                 nReverseDelay=0;                                    
                                                }
                                               else 
                                                {
                                                 nTxtblcr--;                                         
                                                 kbd_key_release_all();                              
                                                }
                                              }
                                               else i=0;                                             
                                             }
							}
						    else                                                         
                                          {
							 nTxtblcr--;                                               
							 if(nTxtblcr<0)                                            
                                            {
                                             nReverseDelay++;                                        
                                             if(conf.remote_zoom_enable==1)                          
                                              {
                                               if(nReverseDelay>100)                                 
                                                {
                                                 nTxtblcr=0;                                         
                                                 nTxzname=ZOOM_IN;
                                                 nReverseDelay=0;                                    
                                                }
                                               else nTxtblcr++;                                      
                                               kbd_key_release_all();                                
                                              }       
                                             else i=0;                                               
                                            } 
						       }
						    if(i==1) return 1;                                           
					        }                                                              
					        kbd_key_release_all();                                         
					        set_key_press(0);                                              
					        nTxzoom=1;                                                     
					        nSW=120;
					        nWt=5;
					        return 1;                                                      
					  }
				      kbd_key_release_all();                                                
				      kbd_key_press(nTxzname); 
				      set_key_press(1);
				      nCER++;
				      return 1;                                                             
		     }  
				
		if(nTxvideo>0 && nSW==121)                      
                {
			if(!get_usb_power(1))                     
                       {
				nWt=10;                             
				kbd_key_press(KEY_VIDEO);           
				set_key_press(1);
				nSW=122;                            
				}
			return 1;
			}
		if(nTxvideo>0 && nSW==122)                                 
                 {
			nWt=10;                                              
			kbd_key_release(KEY_VIDEO);                          
			set_key_press(1);
			nSW=123;                                             
			return 1;                                            
			}
		if(nTxvideo>0 && nSW==123)                                 
                 {
			set_key_press(0);
			nWt=50;                                              
			nSW=0;                                               
			nCa=0;                                               
			nTxvideo=0;                                          
			debug_led(0);                                        
			return 1;                                            
			}
		if(nSW==110)
                  {
                    if (shooting_in_progress() || mvideo || nCER>100) 
                      {
				state_expos_recalculated = 0;
				histogram_restart();                           
				nCER=0;
				nSW=111;
			    }
			  else {nCER++;return 1;}
			}
		if(nSW==111)
                  {
			if (state_expos_recalculated || nCER>100)            
                     {
				state_expos_under = under_exposed;
				state_expos_over = over_exposed;
				nCER=0;
				nSW=112;
			    }
			else {nCER++;return 1;}
			}
		if(nSW==112)
                  {
		    if (shooting_is_flash_ready() || nCER>10)
                      {
				nCER=0;
				nSW=113;
			    }
			else {nCER++;return 1;}
			}
		if(nSW==113)
                 {
                  if(get_usb_power(1)) nCount++;                  
                  if(kbd_is_key_pressed(KEY_SHOOT_HALF)|| (conf.dc && nCount && (nCount<40) && !get_usb_power(1))) 
                   {
                    kbd_key_release(KEY_SHOOT_HALF);
                    nCount=0;                                      
                    set_key_press(0);
                    nWt=50;                                        
                    nSW=0;
                    nCa=0;
                    return 1;                                      
                   }
                  else if(conf.dc && get_usb_power(1) && (nCount >=40) && !mvideo) 
                   {
                    nCount=0;
                    nSW=114;
                   } 
                  else if(!conf.dc && get_usb_power(1) && !mvideo) nSW=114;  
                  else if(!get_usb_power(1) && mvideo) nSW=114;              
                  else return 1;                                             
		     }
		if(nTxzoom>0 && nSW==120)                                            
                  {
			nCrzpos=lens_get_zoom_point();                                 
			if((nTxzname==ZOOM_IN && nCrzpos<=nTxtbl[nTxtblcr]) || (nTxzname==ZOOM_OUT && nCrzpos>=nTxtbl[nTxtblcr]))
                       {
				kbd_key_release_all();                                  
				set_key_press(0);
				nTxzoom=1;                                              
				lens_set_zoom_speed(100);
				nSW=0;
				nCount=0;                                               
				nWt=10;
				return 1;                                              
				}
			  lens_set_zoom_speed(5);
			  kbd_key_release_all();                                     
			  if(nTxzname==ZOOM_IN) kbd_key_press(ZOOM_OUT);
			  else kbd_key_press(ZOOM_IN);
			  set_key_press(1);
			  return 1;                                                  
			}
		if(nSW==114)
                 {
			nSW=115;
			nWt=2;
                  shutter_int=0;
			if(!(srf && !conf.srb))
                   {
                    kbd_key_press(KEY_SHOOT_FULL);                        
                    time_full_pressed=(unsigned long)time(NULL);          
                   }
                  set_key_press(1);
			nCount=0;                                               
			return 1;                                               
			}
		if(nSW==115)
                  {
                   if(drmode==1 && (!shutter_int && (((conf.bracket_type>2)&& conf.tv_bracket_value)||conf.dist_mode)))               
                    {
			   return 1;
			  }
                    else if(drmode==1 && !shutter_int && !conf.tv_bracket_value && !conf.dist_mode && (conf.bracket_type<=2))         
                    {
                     return 1;
                    }
                    else if(drmode==1 && !shutter_int && !conf.tv_bracket_value && !conf.dist_mode && (conf.bracket_type>2)&& !(get_usb_power(1)&&(((unsigned long)time(NULL)-time_full_pressed)>1))) 
                    {
                     return 1;
                    }
			nSW=116;
			nWt=2;
			if(!(srf && !conf.srb))kbd_key_release(KEY_SHOOT_FULL); 
                  set_key_press(1);
                  soft_half_press = 0;
			return 1;                                                
			}
		if(!get_usb_power(1) && nSW==116)                           
                 {
                  set_key_press(0);
			nWt=50;
			nSW=0;
			nCa=0;
			return 1;                                             
			}
		}
	if(nCa==1)
         {
		if(get_usb_power(1) && nSW>108 && nSW<120)                
                 {
			nCount++;                                           
			}
		if(nSW==109)
                {
			nCER=0;
                 
			if(nTxzoom>0)                                      
                       {
				if(nTxzoom<100)                                                             
                             {
					nIntzpos=lens_get_zoom_point();                 
					for(i=0;i<ZSTEP_TABLE_SIZE;i++)         
                                   {
						if(nIntzpos<=nTxtbl[i])           
                                         {
							if(i>0)                     
                                                {
								if(abs(nTxtbl[i]-nIntzpos)<=abs(nTxtbl[i-1]-nIntzpos)) nTxtblcr=i; 
								else nTxtblcr=i-1;                                                 
								}
							 else nTxtblcr=i;                                                        
							 i=ZSTEP_TABLE_SIZE;                                                     
							}
						}
					    if(nTxzname==ZOOM_IN)                                                  
                                    {
						nTxtblcr++;                                                          
						if(nTxtblcr>(ZSTEP_TABLE_SIZE-1))                                    
                                        nTxtblcr=(ZSTEP_TABLE_SIZE-1);
						}
					  else{                                                                                                                                        
						nTxtblcr--;
						if(nTxtblcr<0)                                                       
                                       nTxtblcr=0;
						}
					nSW=113;                                                                   
					return 1;
					}
				nTxzoom=0;                                                                       
				nReczoom=0;
				}
                  
			    if(nTxvideo>0) {nSW=121;return 1;}                                                                                                  
                   
if((((conf.dist_mode||conf.tv_bracket_value)&&state_kbd_script_run))&&!mvideo)
                   
                       {
                        nSW=113;
                        nWt=2;
                        nCount=10;
                        kbd_key_release_all();                                                          
                        return 1;
                       }
                      nSW=110;
			    nWt=2;
			    kbd_key_release_all();                                                           
			    if(!(srf && !conf.srb))kbd_key_press(KEY_SHOOT_HALF); 
                      soft_half_press = 1;
                      set_key_press(1);
			    return 1;
		   }
		if(nTxvideo>0 && nSW==121)                                                                
                  {
			if(get_usb_power(1))                                                                
                       {
				nWt=10;
				kbd_key_press(KEY_VIDEO);                                                     
				set_key_press(1);
				nSW=122;
				}
			return 1;
			}
		if(nTxvideo>0 && nSW==122)                                     
                 {
			nWt=10;
			kbd_key_release(KEY_VIDEO);                              
			set_key_press(1);
			nSW=123;
			return 1;
			}
		if(nTxvideo>0 && nSW==123)                                     
                 {
			set_key_press(0);
			nWt=100;
			nCount=0;
			nSW=0;
			nCa=0;
			nTxvideo=0;                                              
			debug_led(0);
			return 1;
			}
		if(nSW==110)
                  {
			if (shooting_in_progress() || mvideo || nCER>100) 
                      {
				state_expos_recalculated = 0;
				histogram_restart();                               
				nCER=0;
				nSW=111;
			    }
			  else {nCER++;return 1;}
			}
		if(nSW==111)
                  {
			if (state_expos_recalculated || nCER>100)                
                       {
				state_expos_under = under_exposed;
				state_expos_over = over_exposed;
				nCER=0;
				nSW=112;
			     }
			 else {nCER++;return 1;}
			}
		if(nSW==112)
                  {
		      if (shooting_is_flash_ready() || nCER>10)
                      {
				nCER=0;
				nSW=113;
			    }
			else {nCER++;return 1;}
			}
		if(nTxzoom>0 && nSW==114)                                 
                  {
			nCrzpos=lens_get_zoom_point();
			if(nIntzpos!=nCrzpos) {nReczoom=0;}
			if(nIntzpos==nCrzpos && nCER>50)                     
                       {
				if(nCount>0)
                            {
					kbd_key_release_all();
					set_key_press(0);
					nTxzoom=1;                               
					nSW=0;
					nCount=0;
					nWt=10;                                   
					nReczoom=1;
					return 1;
				     }
				}
			if(nReczoom==0 && ((nTxzname==ZOOM_IN && nCrzpos>=nTxtbl[nTxtblcr]) || (nTxzname==ZOOM_OUT && nCrzpos<=nTxtbl[nTxtblcr])))
                        {
				if(nCount==0)
                              {
					i=1;                                       
					if(nTxzname==ZOOM_IN)                                            
                                   {
						nTxtblcr++;                                                    
						if(nTxtblcr>(ZSTEP_TABLE_SIZE-1)) 
                                      {
                                       nTxtblcr=(ZSTEP_TABLE_SIZE-1);
                                       if(conf.remote_zoom_enable==1) nTxzname=ZOOM_OUT;         
                                       else i=0;
                                      }
						}
					  else{                                                                        
						nTxtblcr--;                          
						if(nTxtblcr<0)
                                      {
                                      nTxtblcr=0;
                                       if(conf.remote_zoom_enable==1) nTxzname=ZOOM_IN;                      
                                       else i=0;
                                      }
					       }
					    if(i==1) return 1;                                           
					}
				      kbd_key_release_all();                                           
				      set_key_press(0);
				      nTxzoom=1;                                                      
				      nSW=115;
				      nWt=5;                                                          
				      return 1;
				  } 
			           kbd_key_release_all();
			           kbd_key_press(nTxzname);                                         
			           set_key_press(1);
			           nCER++;                                      
			           return 1;
			  } 
		if(nTxzoom>0 && nSW==115)                                    
                 {
			if(nCount==0) return 1;                                                                   
			nCrzpos=lens_get_zoom_point();                          
			if((nTxzname==ZOOM_IN && nCrzpos<=nTxtbl[nTxtblcr]) || (nTxzname==ZOOM_OUT && nCrzpos>=nTxtbl[nTxtblcr]))
                       {
				kbd_key_release_all();                           
				set_key_press(0);
				nTxzoom=1;                                       
				lens_set_zoom_speed(100);
				nSW=0;                                            
				nCount=0;
				nWt=10;
				return 1;
				}
			 lens_set_zoom_speed(5);                                
			 kbd_key_release_all();                                 
			 if(nTxzname==ZOOM_IN) kbd_key_press(ZOOM_OUT);          
			 else kbd_key_press(ZOOM_IN); 
			 set_key_press(1);                                                                             
			 return 1;
			}
		if(get_usb_power(1))                                     
                  {
			return 1;
			}
		if(nCount>0 && nSW==113)
                  {
			if(nCount<9)                                     
                        {
				if(nTxzoom>0)                              
                             {
					kbd_key_release_all();
					set_key_press(0);
					nTxzoom=0;                           
					nReczoom=0;
					nSW=0;                               
					nCa=0;                               
					nCount=0;                            
					nWt=10;
					debug_led(0);                        
					return 1;
					}
				   nSW=125;                                
				   nWt=10;
				   if(!(srf && !conf.srb))kbd_key_release(KEY_SHOOT_HALF);        
                           soft_half_press = 0;
	                     set_key_press(1);
				   nCount=0;                               
				   return 1;
				}
			  else{                                          
				if(nTxzoom>0)                              
                             {
					nCount=0;
					nSW=114;
					return 1;
					}
				  nSW=124;
				  nWt=2;
                          shutter_int=0;
				  if(!(srf && !conf.srb))
                           {
                            kbd_key_press(KEY_SHOOT_FULL);        
                           }
                          set_key_press(1);
				  nCount=0;
				  return 1;
				}
			}
		if(nSW==124)
                  {
                    if((drmode==1) && !shutter_int && (((conf.bracket_type>2)&& conf.tv_bracket_value)||conf.dist_mode)) 
                    {
			   return 1;
			  }
                    else if(drmode==1 && !shutter_int && !conf.tv_bracket_value && !conf.dist_mode && (conf.bracket_type<=2))           
                    {
                     return 1;
                    }
			 nSW=125;
			 nWt=2;
			 if(!(srf && !conf.srb))kbd_key_release(KEY_SHOOT_FULL);  
                   soft_half_press = 0;
                   set_key_press(1);
			 return 1;
			}
		if(!get_usb_power(1) && nSW==125)      
                 {
                  set_key_press(0);
			nWt=50;                          
			nSW=0;
			nCa=0;
			return 1;
			}                  
		} 
//------ add by Masuji SUTO (end)   --------------
} 
                if (conf.use_zoom_mf && kbd_use_zoom_as_mf()) 
                {
                  return 1;
                }
        }
        return kbd_blocked;
}
void conf_restore_finished()
{
 if(conf.extend_lens==1) nConffin=1;	
}
static const struct Keynames {
    int keyid;
    char *keyname;
} keynames[] = {
#if defined(CAMERA_sx200is)
    { KEY_ZOOM_IN_SLOW, "zoom_in_slow"},
    { KEY_ZOOM_OUT_SLOW, "zoom_out_slow"},
#endif
    { KEY_UP,           "up"         },
    { KEY_DOWN,         "down"       },
    { KEY_LEFT,         "left"       },
    { KEY_RIGHT,        "right"      },
    { KEY_SET,          "set"        },
    { KEY_SHOOT_HALF,   "shoot_half" },
    { KEY_SHOOT_FULL,   "shoot_full" },
    { KEY_ZOOM_IN,      "zoom_in"    },
    { KEY_ZOOM_OUT,     "zoom_out"   },
    { KEY_MENU,         "menu"       },
    { KEY_DISPLAY,      "display"    },
    { KEY_PRINT,        "print"      },
    { KEY_ERASE,        "erase"      },
    { KEY_ISO,          "iso"        },
    { KEY_FLASH,        "flash"      },
    { KEY_MF,           "mf"         },
    { KEY_MACRO,        "macro"      },
    { KEY_VIDEO,        "video"      },
    { KEY_TIMER,        "timer"      },
    { KEY_EXPO_CORR,    "expo_corr"  },
    { KEY_MICROPHONE,   "fe"         },
    { 0xFF,             "remote"     },
    { 0xFFFF,           "no_key"     },
    { MOVIE_MODE,       "movie_mode"},
    { TV_MODE,          "tv_mode"},
    { PLAYBACK_MODE,    "playback_mode"},
};
static int keyid_by_name (const char *n)
{
    int i;
    for (i=0;i<sizeof(keynames)/sizeof(keynames[0]);i++)
	if (strcmp(keynames[i].keyname,n) == 0)
	    return keynames[i].keyid;
    return 0;
}
static const int vkeys[4][4]= {{KEY_UP,KEY_LEFT,KEY_RIGHT,KEY_DOWN},
                               {KEY_DOWN,KEY_RIGHT,KEY_LEFT,KEY_UP},
                               {KEY_LEFT,KEY_DOWN,KEY_UP,KEY_RIGHT},
                               {KEY_RIGHT,KEY_UP,KEY_DOWN,KEY_LEFT}};
int get_vkey(int key)
{
 if((key-KEY_UP)>3) return key;
 short row,col;
 row=key-KEY_UP;
 col=conf.camera_orientation;
 if(col==2)col=3;
 if((col==1)&&conf.camera_rotation)col=2;
 return vkeys[row][col];
}
#if !defined(OPT_SERIALIO)
const char* key_name_from_id(int keyId)
{
int i;
for (i=0;i<sizeof(keynames)/sizeof(keynames[0]);i++)
   if (keyId == keynames[i].keyid)
      return keynames[i].keyname;
return 0;
}
#endif
int kbd_is_blocked() 
{
  return kbd_blocked;
}
