#include "platform.h"
#include "core.h"
#include "conf.h"
#include "keyboard.h"
#include "stdlib.h"
#include "gui.h"
#include "histogram.h"
#include "raw.h"
#include "motion_detector.h"
#include "draw_palette.h"
#include "edgeoverlay.h"
static int raw_need_postprocess;
static volatile int spytask_can_start;
char *imgbuf = 0;
int imgbuf_size=0;
extern int previous_focus,inf_focus,bls;
extern long gEnableScripting;
int edge_count=0;
#define PAIRS_MODE 1
#define GRAY_MODE 2
#define COLOR_MODE 3
static int clip(int v) 
{
if (v<0) v=0;
if (v>255) v=255;
return v;
}
static int clips(int v) 
{
if (v<-127) v=-127;
if (v>127) v=127;
return v;
}
void allocate_imgbuf()
{
int x;
 if(!imgbuf)
 {
#if defined(CAMERA_ixus100)
  imgbuf_size = 360 * 160 *3;                                          
#elif defined(CAMERA_g11)|| defined(CAMERA_s90)|| defined(CAMERA_s95)|| defined(CAMERA_ixus105)
  imgbuf_size = 720 * 240 * 3;
#else
  imgbuf_size = 360 * 240 *3;                                         
#endif
  imgbuf = malloc(imgbuf_size);                                       
  if(imgbuf)memset(imgbuf,COLOR_TRANSPARENT,imgbuf_size);             
 }      
}
void invert()
{
 int x;
 unsigned char* tmp;
 static int cnt=0; 
 static unsigned char *pb_img;
 static unsigned char *pb_img2; 
 static int phase=0;                                                  
 if(!pb_img)pb_img=vid_get_viewport_fb_d();                           
 else if(!pb_img2)                                                    
  {
   tmp=vid_get_viewport_fb_d();
   if(tmp && (tmp!=pb_img))pb_img2=tmp;                               
  }
 
 if(conf.invert_playback &&((mode_get()&MODE_MASK) == MODE_PLAY))     
 {
  if(!imgbuf)allocate_imgbuf();                                       
  if(imgbuf && pb_img)                                                
  {
   if(!cnt)tmp=pb_img;                                                
   else tmp=pb_img2;                                                  
   if(!((pb_img[0]==255)&&(pb_img[1]==254)&&(pb_img[2]==253))&& tmp)  
    {
   if(!phase)                                                         
    {  
     memset(imgbuf,COLOR_TRANSPARENT,imgbuf_size);                    
     for(x=0;x<imgbuf_size/2;x+=6)                                    
      { 
       imgbuf[x]  =tmp[imgbuf_size-x-6];                              
       imgbuf[x+1]=tmp[imgbuf_size-x-1];
       imgbuf[x+2]=tmp[imgbuf_size-x-4];
       imgbuf[x+3]=tmp[imgbuf_size-x-2];
       imgbuf[x+4]=tmp[imgbuf_size-x-3];
       imgbuf[x+5]=tmp[imgbuf_size-x-5];
      }
      phase=1;                                                        
      return;
     }
    else                                                              
     {
       for(x=imgbuf_size/2;x<imgbuf_size;x+=6)                        
      { 
       imgbuf[x]  =tmp[imgbuf_size-x-6];                              
       imgbuf[x+1]=tmp[imgbuf_size-x-1];
       imgbuf[x+2]=tmp[imgbuf_size-x-4];
       imgbuf[x+3]=tmp[imgbuf_size-x-2];
       imgbuf[x+4]=tmp[imgbuf_size-x-3];
       imgbuf[x+5]=tmp[imgbuf_size-x-5];
      }
       phase=0; 
       memcpy(tmp,imgbuf,imgbuf_size);                                
       tmp[0] = 255;                                                  
       tmp[1] = 254;
       tmp[2] = 253;                                                  
       cnt=1-cnt;                                                     
     }
    }  
   }  
 } 
}   
void stereo_pair() 
{
  int x, y;
  int ry, yd, ru, rv, vd, lu, lv;
 static unsigned char *img;
 static int viewport_height;
 static int viewport_width;
 static int iw;
 static int stereonum = 0;
 if(!conf.stereo_mode) return;
#if defined(CAM_USE_SET_BUTTON) 
img=((mode_get()&MODE_MASK) == MODE_PLAY)?vid_get_viewport_fb_d():((kbd_is_key_pressed(KEY_SET))?vid_get_viewport_fb():vid_get_viewport_live_fb());
#elif defined(CAMERA_sx200is) || defined(CAMERA_sx10)
img=((mode_get()&MODE_MASK) == MODE_PLAY)?vid_get_viewport_fb_d():((kbd_is_key_pressed(KEY_UP))?vid_get_viewport_fb():vid_get_viewport_live_fb());
#else
img=((mode_get()&MODE_MASK) == MODE_PLAY)?vid_get_viewport_fb_d():((kbd_is_key_pressed(KEY_SHOOT_HALF))?vid_get_viewport_fb():vid_get_viewport_live_fb());
#endif
if (img==NULL) img = vid_get_viewport_fb();
#if defined(CAMERA_ixus980)
viewport_width = screen_width * 3/2;
#elif defined(CAMERA_sx200is)|| defined(CAMERA_g11)|| defined(CAMERA_s90)|| defined(CAMERA_s95)|| defined(CAMERA_ixus90)|| defined(CAMERA_ixus95)
viewport_width= vid_get_viewport_width()*3;
#else
viewport_width = screen_width * 3;
#endif
viewport_height = vid_get_viewport_height();
iw = viewport_width / 4;
 if(((mode_get()&MODE_MASK) == MODE_PLAY)&& !conf.camera_orientation) 
 {
#if defined(CAM_USE_SET_BUTTON) 
   if (kbd_is_key_pressed(KEY_SET)) 
#elif defined(CAMERA_sx200is)|| defined(CAMERA_sx10)
   if (kbd_is_key_pressed(KEY_UP))
#else
    if (kbd_is_key_pressed(KEY_SHOOT_HALF)) 
#endif
    {
     play_sound(4);
       if(imgbuf == 0)allocate_imgbuf() ;                             
       if(stereonum == 0) 
       {
         if((img[0] == 255) && (img[1] == 254) && (img[2] == 253)) return;
         if(imgbuf) 
           {
             if(conf.stereo_mode == PAIRS_MODE) 
             {
             for(y=0;y<viewport_height;y++) 
               {
                memcpy(imgbuf + y * viewport_width,
                img + y * viewport_width + iw, 
                viewport_width/2);
               }
             }
             else memcpy(imgbuf,img,imgbuf_size);
                 img[0] = 255;
                 img[1] = 254;
                 img[2] = 253;
                 stereonum = 1;   
           } 
             return;
       }  
      if(stereonum == 1) 
      {
        if(imgbuf) 
        {
          if((img[0] == 255) && (img[1] == 254) && (img[2] == 253)) return;
          if(conf.stereo_mode == PAIRS_MODE) 
           {
            for(y=0;y<viewport_height;y++) 
             {
               memcpy(imgbuf + y * viewport_width + viewport_width/2,
               img + y * viewport_width + iw, viewport_width/2);
             }
           }
            stereonum = 2;
            return;
        }
          return;
     } 
       if(stereonum == 2) 
       {
          if(conf.stereo_mode == PAIRS_MODE) memcpy(img, imgbuf,imgbuf_size);
        else if(conf.stereo_mode == GRAY_MODE)
          {
             for(x = 0; x < imgbuf_size; x+=6)
            {
              ry = img[x + 1];
              yd = ry - imgbuf[x + 1];
              img[x + 1] = (1225 * imgbuf[x + 1] + 2871 * ry) / 4096;           
              img[x] = (signed char)clips((692 * yd)/4096);                     
              img[x + 2] = (signed char)clips(-yd/2);                           
              img[x + 3] = (1225 * imgbuf[x + 3] + 2871 * img[x + 3]) / 4096;   
              img[x + 4] = (1225 * imgbuf[x + 4] + 2871 * img[x + 4]) / 4096;   
              img[x + 5] = (1225 * imgbuf[x + 5] + 2871 * img[x + 5]) / 4096;   
            }
        }
       else
       {
         for(x = 0; x < imgbuf_size; x+=6)
           {
             ry = img[x + 1];
            yd = ry - imgbuf[x + 1];
            ru = (signed char) img[x];
            rv = (signed char) img[x + 2];
            lu = (signed char) imgbuf[x];
            lv = (signed char) imgbuf[x + 2];
           vd = rv - lv;
           img[x] = (signed char)clips(ru + (971 * vd + 692 * yd) / 4096);           
           img[x + 2] = (signed char)clips(-yd/2 + (2871 * lv + 1225 * rv) / 4096);  
           img[x + 1] = clip((1225 * imgbuf[x + 1] + 2871 * ry - 1712 * vd) / 4096); 
           img[x + 3] = clip((1225 * imgbuf[x + 3] + 2871 * 
           img[x + 3] - 1712 * vd) / 4096);                                          
           img[x + 4] = clip((1225 * imgbuf[x + 4] + 2871 * 
           img[x + 4] - 1712 * vd) / 4096);                                          
           img[x + 5] = clip((1225 * imgbuf[x + 5] + 2871 * 
          img[x + 5] - 1712 * vd) / 4096);                                           
         }
     }
           img[0] = 255;
           img[1] = 254;
           img[2] = 253;
           for(y=0;y<screen_height;y++) 
#if defined(CAMERA_ixus980)
            for(x = 0; x < screen_width/2;x++) 
#else
            for(x = 0; x < screen_width;x++) 
#endif
             draw_pixel(x,y,0);                                                      
           stereonum = 0;
           return;
     } 
   } 
} 
return;
}
void core_hook_task_create(void *tcb)
{
}
void core_hook_task_delete(void *tcb)
{
char *name = (char*)(*(long*)((char*)tcb+0x34));
 if (strcmp(name,"tInitFileM")==0) core_spytask_can_start();
}
long core_get_noise_reduction_value()
{
    return conf.raw_nr;
}
static volatile long raw_data_available;
/*called from another process */
void core_rawdata_available()
{
    raw_data_available = 1;
}
void core_spytask_can_start() {
        spytask_can_start = 1;
}
void core_spytask()
{
    const char *fn ="A/CHDK/SCRIPTS/Startup.bas";
    int cnt = 1,x,y;
    int i=0;
    static int nCER=0;
    raw_need_postprocess = 0;
    spytask_can_start=0;
    while((i++<400) && !spytask_can_start) msleep(10);
    mkdir("A/CHDK");
    mkdir("A/CHDK/TEXTS");
    mkdir("A/CHDK/FONTS");
    mkdir("A/CHDK/SCRIPTS");
    mkdir("A/CHDK/LANG");
    mkdir("A/CHDK/STACKS");
    mkdir("A/CHDK/GRIDS");
    mkdir("A/CHDK/EDGES");
    mkdir("A/CHDK/PARAMS");                                         
    mkdir("A/DCIM");
    wia();
    auto_started=0;
#if defined(CAM_USES_EXMEM)
msleep(500);
exmem_malloc_init();                                               
char *dummy = malloc(1024*1024*4);                                 
#endif
    started();
    conf_restore();                                                
#if !defined(CAM_NEED_HP)
   gEnableScripting=shooting_get_tick_count();
#endif
    conf_restore_finished();                                       
    finished();
    gui_init();                                                    
    md_init();   
if (conf.script_startup) 
 {
  script_autostart();                                       
 } 
 
    while (1)
   {
    if (conf.script_startup && !auto_started  && ((shooting_get_tick_count()-gEnableScripting)>10000) && ((shooting_get_tick_count()-gEnableScripting)<10500)) script_autostart(); 
       if(shooting_get_drive_mode()&& shooting_can_focus() && conf.dist_mode && conf.user_range_set)conf.user_range_set=0; 
     if (state_kbd_script_run && (!bls || (tl.blank_screen && tl.shot_count)))TurnOffBackLight();   
     if(!get_sd_status() && ((conf.dist_mode==3)|| tl.running)) disable_shutdown();   
 if (raw_data_available)
        {
          raw_need_postprocess = raw_savefile();
     hook_raw_save_complete();
     raw_data_available = 0;
          if((shooting_get_drive_mode()==1)&& conf.raw_strip_mode && (state_shooting_progress == SHOOTING_PROGRESS_PROCESSING))
           {
            ubasic_set_led(9,1,100);
            msleep(10);                       
            ubasic_set_led(9,0,0);       
           } 
     continue;
   }
#if defined(CAMERA_g9)
      if(auto_started && !state_kbd_script_run) 
       { 
         const char *myfn = "A/PS.FI2";
         reboot(myfn);
       }
#endif
	if (state_shooting_progress != SHOOTING_PROGRESS_PROCESSING) 
      {
	    if (((cnt++) & 3) == 0)
	        gui_redraw();       
          invert();
     histogram_process();
          
        if (!conf.user_range_set && shooting_can_focus() && (conf.dist_mode==3)&& ((shooting_get_drive_mode()==1)||(shooting_get_drive_mode()== CAM_PROPSET+1)))
         {
            if(lens_get_focus_pos_from_lense()<440 && ((cnt & 127)==0))
            {
             lens_set_focus_pos(conf.digi_ref_dist+fpd);
            }
          }
         if(conf.show_osd && conf.edge_overlay_thresh && conf.outline_mode) edge_overlay();
         if(conf.stereo_mode) stereo_pair();
  }
 if ((state_shooting_progress == SHOOTING_PROGRESS_PROCESSING) && (!shooting_in_progress())) 
       {
          
         if((shooting_get_drive_mode()==1)||(shooting_get_drive_mode()== CAM_PROPSET+1)) 
          {
           if(shooting_can_focus()&& (conf.dist_mode>0))lens_set_focus_pos(previous_focus+fpd);
           if((conf.tv_bracket_value && !conf.dist_mode)||(shooting_can_focus()&& (conf.dist_mode>0)))inf_focus = 0;
          }
          if(conf.outline_mode && imgbuf && !conf.edge_overlay_lock) ++edge_count;
          if((edge_count==2)&& imgbuf && !conf.edge_overlay_lock)
          {
           for(x = 0; x < imgbuf_size;x++) imgbuf[x]=0;
           edge_count=0;
          }          
     state_shooting_progress = SHOOTING_PROGRESS_DONE;
          if (raw_need_postprocess) raw_postprocess();
        }
 msleep(20);
    }
}
