#include "platform.h"
#include "conf.h"
#include "stdlib.h"
#include "raw.h"
#include "draw_palette.h"
#include "gui.h"
#include "keyboard.h"
#include "dng.h"
#define RAW_TARGET_DIRECTORY    "A/DCIM/%03dCANON"
#define RAW_TARGET_FILENAME     "ST%s_%04d.CRW"
#define RAW_BRACKETING_FILENAME "%04d_%03d%s"
#define STEREO_TARGET_DIRECTORY    "A/DCIM/%03dCANON"
#define STEREO_TARGET_FILENAME     "%04d.%s"
extern float realfl,max_distance,deviation,percent_deviation,coc,fov,my_max_deviation;
extern long myav,fp,sensor_width;
extern Conf conf;
extern int shift,myfl,myhyp;
extern char script_title[36];
extern char *imgbuf;
static const char* modes[]={ "65\"","50\"", "40\"", "30\"", "25\"","20\"","15\"","13\"","10\"","8\"","6\"","5\"","4\"","3.2\"","2.5\"","2\"","1.6\"","1.3\"","1\"","Off","0.8","0.6","0.5","0.4","0.3","1/4","1/5","1/6","1/8","1/10","1/13","1/15","1/20","1/25","1/30","1/40","1/50","1/60","1/80", "1/100","1/125","1/160","1/200","1/250","1/320","1/400","1/500","1/640","1/800", "1/1000","1/1250","1/1600","1/2000", "1/2500","1/3200","1/4000", "1/5000", "1/6400", "1/8000", "1/10000", "1/12800", "1/16000", "1/20000", "1/26000","1/32000","1/40000"};
static const char* tv_modes[]={ "Off", "1/3 EV","2/3 EV", "1 EV", "4/3 EV", "5/3 EV", "2 EV"};
extern int two_shot,hs,zs;
extern int gDebug;
#if defined(OPT_OMNI) && defined(DNG_SUPPORT)
int gBracketingCounter; 
#endif
int gDngFinish,gDngStart;
void wia();
void save_prop_ids();
static char fn[64];
static char dir[32];
int delay_status;
int delay_user_value;
void save_viewport() 
{
#if !defined(CAMERA_tx1)
int viewport_size = vid_get_viewport_height() * screen_width;
#else
int viewport_size = vid_get_viewport_height() * (screen_width-120);
#endif
   int fd;
   char fn[64];
static char *imgbuf;
imgbuf = vid_get_viewport_fb();
if(imgbuf == 0) return;
   mkdir("A/CHDK/VPDATA");
   sprintf(fn, "A/CHDK/VPDATA/EdgeData_%d",get_target_file_num());
    fd = open(fn, O_WRONLY|O_CREAT, 0777);                
    if (fd>=0) {
      write(fd, imgbuf, viewport_size *3);
      close(fd);
      }
   return;
}
void save_bitmap() 
{
}
void postsynch()
    {
       if(conf.synch_enable && shooting_will_use_flash() ) 
       shooting_set_prop(PROPCASE_FLASH_OVERRIDE,0);    
       conf.synch_delay_enable = delay_status;
       conf.synch_delay_value = delay_user_value;
    }
int raw_savefile() 
{
    int fd,m=(mode_get()&MODE_SHOOTING_MASK);
    static struct utimbuf t;
#if defined(OPT_OMNI) && defined(DNG_SUPPORT)
    static int slitfd;
#endif
    if(conf.distance_setting == 65535) save_prop_ids(); 
    if (!tl.running && !(!shooting_get_drive_mode()&&(conf.dist_mode==3))) postsynch(); 
     xml_savefile();
    if(conf.outline_mode && two_shot) 
    {
     conf.show_histo=hs;
     conf.zebra_draw=zs;
     two_shot=0;
    }
 
    shooting_bracketing();

#if defined(DNG_SUPPORT)
if(conf.raw_strip_mode && shooting_get_drive_mode())
     {
        if(state_shooting_progress != SHOOTING_PROGRESS_PROCESSING)
            gBracketingCounter = 1;               
        else if(gBracketingCounter && (state_shooting_progress == SHOOTING_PROGRESS_PROCESSING))
            gBracketingCounter++;
        if((gBracketingCounter==conf.strip_images)&&conf.raw_strip_mode)play_sound(4);
     }
    else
     {
        gDngStart=get_tick_count();
        gBracketingCounter=0;
     }
#endif
 if(!shooting_get_drive_mode())gDngStart=get_tick_count();   
    state_shooting_progress = SHOOTING_PROGRESS_PROCESSING; 

    if (conf.save_raw) 
   {
        long v;
        t.actime = t.modtime = time(NULL);
        static int file_num,dir_num;
      
      
        mkdir("A/DCIM"); 
        sprintf(dir, RAW_TARGET_DIRECTORY,get_target_dir_num());                       
        mkdir(dir);
#if defined(DNG_SUPPORT)  
        if(gBracketingCounter==1)                                                       
        {
         file_num=get_target_file_num();
         dir_num=get_target_dir_num();                                                  
         gDngStart=get_tick_count();
        }
        if(!(conf.strip_offset && conf.raw_strip_mode && shooting_get_drive_mode()))    
         {
          sprintf(dir+strlen(dir),"/CRW");                                              
          mkdir(dir);                                                            
         }
                                                                                        
        else                                                                            
         { 
 gDebug=1;
          sprintf(dir, RAW_TARGET_DIRECTORY"/%04d",dir_num,file_num);                   
          mkdir(dir);
          sprintf(dir, RAW_TARGET_DIRECTORY"/%04d/LEFT",dir_num,file_num);              
          mkdir(dir);
          sprintf(dir, RAW_TARGET_DIRECTORY"/%04d/RIGHT",dir_num,file_num);             
          mkdir(dir);
         }
        
        struct t_data_for_exif* exif_data = NULL;  
        char *thumbnail_buf = NULL;
    
    
      if(!shooting_get_drive_mode()||(shooting_get_drive_mode()&& !conf.raw_strip_mode))  
        {
         exif_data=capture_data_for_exif(1);
         sprintf(fn,"%s/ST%s_%04d.HDR",dir,(conf.camera_position)?"R":"L",get_target_file_num());
         fd = open(fn, O_WRONLY|O_CREAT, 0777);
         if (fd>=0) 
          {
              create_dng_header(exif_data,1);
              if (get_dng_header())
              {
               write(fd, get_dng_header(), get_dng_header_size());
               close(fd);
               free_dng_header();
              }
           } 
        } 
            
       int raw_start,row_start_left,row_start_right,half_width;
       if(conf.raw_strip_mode && ((conf.strip_images>1)||((conf.strip_images==1)&&(gBracketingCounter==1)))&& gBracketingCounter)               
        {
gDebug=2;
         if(gBracketingCounter<=conf.strip_images)
         {
          if(conf.strip_width%2) conf.strip_width-=1;                                      
          half_width=CAM_ACTIVE_AREA_Y1 + ((CAM_ACTIVE_AREA_Y2 - CAM_ACTIVE_AREA_Y1)/2);
          if(conf.strip_offset)                                                            
          row_start_left=half_width-(half_width*conf.strip_offset/100);
          else
          row_start_left=half_width-(conf.strip_width/2);                                  
          if(row_start_left%2)row_start_left-=1;                                           
          raw_start=row_start_left*CAM_RAW_ROWPIX*CAM_SENSOR_BITS_PER_PIXEL/8;
          if(conf.strip_offset)                                                            
           {
            if(!conf.camera_rotation)                                                      
            sprintf(fn, RAW_TARGET_DIRECTORY"/%04d/LEFT/",dir_num,file_num);               
            else                                                                           
            sprintf(fn, RAW_TARGET_DIRECTORY"/%04d/RIGHT/",dir_num,file_num);              
            sprintf(fn+strlen(fn), RAW_BRACKETING_FILENAME,file_num,gBracketingCounter,".RAW");
           }
           
          else if ((gBracketingCounter==1)&& !conf.strip_offset)                           
           {
            sprintf(fn,"%s/%04d.CRW",dir,file_num);                                        
           }
           if(conf.strip_offset ||(!conf.strip_offset &&(gBracketingCounter==1)))          
           {
gDebug=3;
            slitfd = open(fn, O_WRONLY|O_CREAT, 0777);                                     
           }
           if(conf.strip_offset)                                                           
           { 
            if(slitfd>=0)                                                                  
             {
gDebug=4;
              write(slitfd, hook_raw_image_addr()+raw_start, CAM_RAW_ROWPIX*conf.strip_width*CAM_SENSOR_BITS_PER_PIXEL/8);
              close(slitfd);
             }
else gDebug=5;
           }
           else                                                                             
           {
            write(slitfd, hook_raw_image_addr()+raw_start, CAM_RAW_ROWPIX*conf.strip_width*CAM_SENSOR_BITS_PER_PIXEL/8); 
           }
          if(conf.strip_offset)
           {
            row_start_right=half_width+(half_width*conf.strip_offset/100)-conf.strip_width;
            if(row_start_right%1)row_start_right-=1;                                        
            raw_start=row_start_right*CAM_RAW_ROWPIX*CAM_SENSOR_BITS_PER_PIXEL/8;
            if(!conf.camera_rotation)                                                       
            sprintf(fn, RAW_TARGET_DIRECTORY"/%04d/RIGHT/",dir_num,file_num);               
            else                                                                            
            sprintf(fn, RAW_TARGET_DIRECTORY"/%04d/LEFT/",dir_num,file_num);                
            sprintf(fn+strlen(fn), RAW_BRACKETING_FILENAME,file_num,gBracketingCounter,".RAW");
            slitfd = open(fn, O_WRONLY|O_CREAT, 0777);    
            if(slitfd>=0)                                                                   
             {
              write(slitfd, hook_raw_image_addr()+raw_start, CAM_RAW_ROWPIX*conf.strip_width*CAM_SENSOR_BITS_PER_PIXEL/8);
              close(slitfd);
             }
            }
           if(conf.blank_jpg)                                                              
           memset((unsigned char*)hook_raw_image_addr(),COLOR_BLACK,hook_raw_size());      
          }
          else                                                                             
          { 
           gDngFinish=get_tick_count();
           if(!conf.strip_offset)                                                           
           gBracketingCounter=0;
          } 
        }
      
      
       if(((gBracketingCounter==1)&& conf.raw_strip_mode)&& shooting_get_drive_mode())
      {
         exif_data=capture_data_for_exif(0);                                
         if(conf.strip_offset)                                              
          {
           sprintf(dir, RAW_TARGET_DIRECTORY"/%04d/LEFT",dir_num,file_num);                                                                             
           sprintf(fn, "%s/", dir);                                         
           sprintf(fn+strlen(fn),"STRIPS.HDR"); 
          }
         else
          {
           sprintf(fn, "%s/", dir);                                         
           sprintf(fn+strlen(fn),"%04d.HDR",file_num);                      
          }
         fd = open(fn, O_WRONLY|O_CREAT, 0777);
         if (fd>=0) 
          {
             create_dng_header(exif_data,0);
             if (get_dng_header())
              {
               write(fd, get_dng_header(), get_dng_header_size());
               close(fd);
              }
          }
          if(conf.strip_offset)                                             
          {
           sprintf(dir, RAW_TARGET_DIRECTORY"/%04d/RIGHT",dir_num,file_num);    
           sprintf(fn, "%s/", dir);
           sprintf(fn+strlen(fn),"STRIPS.HDR"); 
           fd = open(fn, O_WRONLY|O_CREAT, 0777);
           if (fd>=0) 
           {
            write(fd, get_dng_header(), get_dng_header_size());
            close(fd);
           }
          } 
         if(!conf.strip_offset && (gBracketingCounter==conf.strip_images)) 
         gBracketingCounter=0;
         free_dng_header();
     }
      
      
      
      if(!shooting_get_drive_mode()||(shooting_get_drive_mode()&& !conf.raw_strip_mode))
       { 
#endif
        started();
        sprintf(fn, "%s/", dir);                                                                                  
        sprintf(fn+strlen(fn), RAW_TARGET_FILENAME,(conf.camera_position)?"R":"L",get_target_file_num()); 
        fd = open(fn, O_WRONLY|O_CREAT, 0777);
        if (fd>=0) 
           {
            write(fd,(int)hook_raw_image_addr(),hook_raw_size());  
            close(fd);
            utime(fn, &t);
           }
         if(conf.blank_jpg)
            memset((unsigned char*)hook_raw_image_addr(),COLOR_BLACK,hook_raw_size());            
         finished();
         gDngFinish=get_tick_count();
         return (fd >= 0);
 #if defined(OPT_OMNI) && defined(DNG_SUPPORT)     
       }
#endif
   } 
    return 0;
}
void raw_postprocess() 
{
}
void wia()
{
 sprintf(dir, RAW_TARGET_DIRECTORY,100);
 mkdir(dir);
 sprintf(fn, "%s/ST%s_0001.CRW", dir,(conf.camera_position)?"R":"L");  
 int fd = open(fn, O_WRONLY|O_CREAT, 0777);                            
   if (fd>=0)                                                          
    {
     sprintf(dir,"WIA Loader\n");
     write(fd,dir,11);
     close(fd);                        
    }
}
void save_prop_ids()
{
#if 0
int i,fd;
static char mybuf[80];
char *p = mybuf;
static int filenum = 1;
static struct utimbuf t;
t.actime = t.modtime = time(NULL);
sprintf(dir,"A/CHDK/PROP_ID");                                                
mkdir(dir);
sprintf(fn, "%s/", dir);
sprintf(fn+strlen(fn),"PROP%03d.txt",filenum);
 fd = open(fn, O_WRONLY|O_CREAT, 0777);  
 
 if (fd>=0)                              
  { 
    for(i=0;i<301;i++)                   
       {
        sprintf(mybuf,"                ");       
        sprintf(mybuf,"%3d %11d\n",i,shooting_get_prop(i));     
        write(fd,mybuf,16);                               
       }
       close(fd);                        
       filenum++;                    
  }
 #endif
}
void xml_savefile() 
{
#if defined OPT_XML
    int fd;
    static char mybuf[80];
    char *p = mybuf;
    static struct utimbuf t;
    static long last_saved_xml_number = 0;
    
    if (conf.save_xml_file && last_saved_xml_number!=get_file_next_counter()) 
    {
        long v;
        last_saved_xml_number = get_file_next_counter();       
        started();
        t.actime = t.modtime = time(NULL);
       if(conf.save_same_dir) sprintf(dir,"A/DCIM/%03dCANON",get_target_dir_num()); 
       else sprintf(dir,"A/DCIM/SDM");                                                
    
        mkdir(dir);
    
        mkdir(dir);
        sprintf(fn, "%s/", dir);
        sprintf(fn+strlen(fn), STEREO_TARGET_FILENAME, get_target_file_num(), "xml");
        fd = open(fn, O_WRONLY|O_CREAT, 0777);
        if (fd>=0) 
       {
         sprintf(mybuf,"<?xml-stylesheet type=\"text/xsl\" href=\"stereo_data.xsl\"?>\n");
         write(fd,mybuf,58);
        sprintf(mybuf,"<StereoInfo>\n");
        write(fd,mybuf,13);
         sprintf(mybuf,"<Link>IMG_%04d.jpg</Link>\n",get_target_file_num());
        write(fd,mybuf,26);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Deviation as percentage of max.acceptable</name>\n");
       write(fd,mybuf,55);
       sprintf(mybuf,"<value>%3d</value>\n",(int)(deviation*100000/(sensor_width/conf.stereo_deviation)));
       write(fd,mybuf,19);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Far-point distance for max.deviation</name>\n");
       write(fd,mybuf,50);
  
       if(max_distance < INFINITY) sprintf(mybuf,"<value>%5d</value>\n",(int)max_distance);
       else sprintf(mybuf,"<value>  INF</value>\n");
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Hyperfocal distance</name>\n");
       write(fd,mybuf,33);
       sprintf(mybuf,"<value>%5d</value>\n",myhyp);
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Focal length</name>\n");
       write(fd,mybuf,26);
       sprintf(mybuf,"<value>%2d.%d</value>\n",myfl/1000,myfl%1000/100);
       write(fd,mybuf,20);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Equivalent focal length</name>\n");
       write(fd,mybuf,37);
       sprintf(mybuf,"<value>%2d</value>\n",(int)(36000*realfl/sensor_width));
       write(fd,mybuf,18);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Aperture</name>\n");
       write(fd,mybuf,22);
       sprintf(mybuf,"<value>%d.%02d</value>\n",myav/100,myav%100);
       write(fd,mybuf,20);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Equivalent Aperture</name>\n");
       write(fd,mybuf,33);
       sprintf(mybuf,"<value>%2d</value>\n",(int)360*myav/sensor_width);
       write(fd,mybuf,18);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Nearpoint factor</name>\n");
       write(fd,mybuf,30);
       sprintf(mybuf,"<value>%5d</value>\n",conf.minimum_dist_factor);
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Camera spacing</name>\n");
       write(fd,mybuf,28);
       sprintf(mybuf,"<value>%5d</value>\n",conf.stereo_spacing);
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Camera shift</name>\n");
       write(fd,mybuf,26);
       sprintf(mybuf,"<value>%5d</value>\n",shift);
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Sensor width</name>\n");
       write(fd,mybuf,26);
       sprintf(mybuf,"<value>%d.%02d</value>\n",sensor_width/1000,sensor_width%1000/10);
       write(fd,mybuf,20);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Circle-of-confusion</name>\n");
       write(fd,mybuf,33);
       sprintf(mybuf,"<value>%0d.%04d</value>\n",(int)coc,(int)(coc*10000));
       write(fd,mybuf,22);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Acceptable deviation</name>\n");
       write(fd,mybuf,34);
       sprintf(mybuf,"<value>%0d.%02d</value>\n",(int)my_max_deviation,(int)(my_max_deviation*100));
       write(fd,mybuf,20);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Sensor deviation</name>\n");
       write(fd,mybuf,30);
       sprintf(mybuf,"<value>%0d.%02d</value>\n",(int)(deviation),(int)(deviation*100));
       write(fd,mybuf,20);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Deviation factor</name>\n");
       write(fd,mybuf,30);
       sprintf(mybuf,"<value>%5d</value>\n",conf.stereo_deviation);
       write(fd,mybuf,21);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
    if(conf.outline_mode)
      {
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Edge threshold</name>\n");
       write(fd,mybuf,28);
       sprintf(mybuf,"<value>%2d</value>\n",conf.edge_overlay_thresh);
       write(fd,mybuf,18);
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
      }
       sprintf(mybuf,"<property>\n");
       write(fd,mybuf,11);
       sprintf(mybuf,"<name>Current script</name>\n");
       write(fd,mybuf,28);
       sprintf(mybuf,"<value>%s</value>\n",script_title);
       write(fd,mybuf,16+strlen(script_title));
       sprintf(mybuf,"</property>\n");
       write(fd,mybuf,12);
       sprintf(mybuf,"</StereoInfo>\n");
       write(fd,mybuf,14);
       close(fd);
       utime(fn, &t);
       finished();    
    }
  }
#endif
}
// -------------------------------------------------------------------
