#ifndef CONF_H
#define CONF_H

#include "gui.h"
#include "script.h"



typedef struct {
    unsigned short  x, y;
} OSD_pos;

typedef struct {
    int save_raw;
    int raw_in_dir;
    int raw_prefix;
    int raw_ext;
    int raw_save_first_only; //for series shooting
    int raw_nr;

    int show_osd;
    int script_shoot_delay;
    int show_histo;
    int ubasic_vars[SCRIPT_NUM_PARAMS];
    char script_file[100];

    int show_dof;
    int batt_volts_max;
    int batt_volts_min;
    int batt_step_25;
    int batt_perc_show;
    int batt_volts_show;
    int batt_icon_show;
    int show_clock;

    int zoom_value;

    int show_state;
    int show_values;
    int show_overexp;

    int histo_mode;
    int histo_auto_ajust;
    int histo_ignore_boundary;
    int histo_layout;

    int zebra_draw;
    int zebra_mode;
    int zebra_restore_screen;
    int zebra_restore_osd;
    int zebra_over;
    int zebra_under;
    int zebra_draw_osd;

    OSD_pos histo_pos;
    OSD_pos dof_pos;
    OSD_pos batt_icon_pos;
    OSD_pos batt_txt_pos;
    OSD_pos mode_state_pos;
    OSD_pos values_pos;
    OSD_pos zoom_pos;
    OSD_pos increment_pos;
    OSD_pos clock_pos;

    color histo_color;
    color histo_color2; //markers/border
    color osd_color;
    color batt_icon_color;
    color menu_color;
    color reader_color;
    color zebra_color; //under/over
    color grid_color;

    int font_cp;
    char menu_rbf_file[100];

    char lang_file[100];

    char reader_file[100];
    int  reader_pos;
    int  reader_autoscroll;
    int  reader_autoscroll_delay;
    char reader_rbf_file[100];
    int  reader_codepage;
    int  reader_wrap_by_words;

    int sokoban_level;

    int flashlight;
    int splash_show;

    int use_zoom_mf;
    long alt_mode_button; //for S-series
    int alt_prevent_shutdown;

    int show_grid_lines;
    char grid_lines_file[100];
    int grid_force_color;

    int video_mode;
    int video_quality;
    int video_bitrate;  
    int tv_override;
    int ns_enable_memdump;
    int script_startup;			// remote autostart
    int remote_enable;			// remote enable
    int main_flash;                 // enables preflash but disables secondary
    int synch_enable;
    int synch_delay_enable;
    int synch_delay_value;
    int synch_delay_coarse_value;
    int synch_delay_range;
    int rangefinder_near;
    int rangefinder_far;
    int rangefinder_far_inf;
    int av_override_value;
    int tv_bracket_value;	      
    int subj_dist_bracket_value;
    int bracket_type;
    int dist_step_size;
// ************************************
    int cam_spacing;
    int deviation_factor;
    int stereo_spacing;
    int stereo_deviation;
    int minimum_dist_factor;
    int save_csv_file;
    int save_xml_file;
    int csv_extension;
    int save_same_dir;
    int user_range;
    int user_range_set;
    int distance_setting; // Mr.Bubble
    int focus_mode;
    int show_stereo;
    int stereo_display_mode;
    int layout_mode;
    int camera_position;
    int camera_orientation;
    int camera_rotation;
    OSD_pos stereo_osd_pos;
    OSD_pos synch_pos;
    int dof_dist_from_lens;
    int manual_far;
    int flash_dim_value;
    int flash_override_value;
    int nd_filter_state;
    int unlock_optical_zoom_for_video;
    int ricoh_ca1_mode;
    int zebra_multichannel;
    int outline_mode;
    int stereo_mode;
    int save_viewport;
    int edge_overlay_thresh;  // name change
    int mute_on_zoom; 
    int expert_menu_enable;
    int computed_distance;
    int osd_page_index;
    int custom_timer_synch;
    int synch_user_delay;
    int tv_override_enable;
    int add_synch_delays;
    int remote_zoom_enable;
    int zoom_timeout;
    int disable_deviation_guideline;
    int nd_constant_exposure;
    int heading1;
    int heading2;
    int heading3;
    int heading4;
    int heading5;
    int heading6;
    int heading7;
    int heading8;
    int heading9;
    int heading10;
    int heading11;
    int heading12;
    int heading13;
    int heading14;
    int heading15;
    int heading16;
    int heading17;
    int heading18;
    int heading19;
    int extend_lens;
    int disable_overrides;
    OSD_pos overrides_pos;
    int digi_obj_diam;
    int digi_scope_fl;
    int digi_ep_fl;
    int digi_zoom_setting;
    int digi_factor;
    int digi_ref_dist;
    int save_digi;
    int save_auto;
    int dist_mode;
    int digi_step;
    int compact;
    int cs;        // console scrolling
    int sdm_console;
    int num_lines;
    int line_length;
    int edge_overlay_enable;
    color edge_overlay_color;
    int edge_overlay_play;
    int edge_overlay_lock;
    int edge_overlay_zoom;
    int sunrise;
    int sunrise_tv96;
    int sunrise_repeats;
    int sunrise_shots;
    int srb;            // sunrise burst mode
    int sunrise_kf_1;
    int sunrise_kf_2;
    int sunrise_kf_3;
    int sunrise_tv96_2;
    int sunrise_tv96_3;
    int script_param_set;
    int script_param_save;
    int edge_and_osd;
    int bw;                // serial comms '0' bit width
    int md;                // tweak factor for accurate msec delay
    int invert_playback;
    int enable_yaw_guideline;
    int yaw;
    int dc;                   // double-click mode for focus cacelling
    int use_af_led;           // for serial comms
    int zf_size;			// large font zoom value
    int lockout_time;         // lockout time for pulses in FAST mode
    int slave_flash;
    int focus_pos;
    int zoom_point;
    int fpd;
    int bright_screen;
#if defined(OPT_SERIALIO)
    int show_sio;         // show serial i/o errors and rate
    OSD_pos sio_pos;
#endif
#if OPT_OMNI
    int raw_strip_mode;
    int strip_width;
    int strip_images;
    int strip_offset;
    int rotation_distance;
#endif
    int blank_jpg;
    int script_set;  // for SDM NG
    int shortcut_lang;
} Conf;

extern Conf conf;
#define ALT_PREVENT_SHUTDOWN_NO         0
#define ALT_PREVENT_SHUTDOWN_ALT        1
#define ALT_PREVENT_SHUTDOWN_ALT_SCRIPT 2
#define ALT_PREVENT_SHUTDOWN_ALWAYS     3

#define SHOOTING_PROGRESS_NONE          0
#define SHOOTING_PROGRESS_STARTED       1
#define SHOOTING_PROGRESS_PROCESSING    2
#define SHOOTING_PROGRESS_DONE          3

extern int state_kbd_script_run;
extern int state_shooting_progress;
// extern int state_save_raw_nth_only;
extern int state_expos_recalculated;
extern int state_expos_under;
extern int state_expos_over;

//--------- added by spinorkit start ---
extern int state_kbd_tty_cmd; //spinorkit added to enable remote use of photo_param_put_off via serial I/O
extern int gSerialIORemoteShootingOn;
extern int gDisableSerialIO;
extern int gShotsRemaining; //decremented in wait_until_remote_button_is_released().

//Values for conf.bracket_type
enum
   {
   kBracketMinus = 0,
   kBracketPlus,
   kBracketAlternate,
   kBracketAlt3, //Alternate to max of 3 shots
   kBracketAlt5, //Alternate to max of 5 shots
   kBracketAlt7,                                   //Alternate to max of 7 shots
   kBracketAlt9,                                   //Alternate to max of 9 shots
   kBracketAlt11,                                  //Alternate to max of 11 shots
   kBracketAlt13,                                  //Alternate to max of 13 shots
   kBracketAlt15,                                  //Alternate to max of 15 shots
   kBracketAlt17,                                  //Alternate to max of 17 shots
   kBracketAlt19,                                  //Alternate to max of 19 shots
   };

//values for conf.dist_mode   
enum
   {
   kDistModeOff,
   kDistModeManual,
   kDistModeAuto,
   kDistModeDigiScope,
   };   

//--------- added by spinorkit end  ---

// extern int state_debug1;
extern int debug_propcase_show;
extern int debug_propcase_page;
extern int debug_vals_show;

extern void script_autostart();				// remote autostart
extern void conf_save();
extern void conf_restore();
extern void conf_load_defaults();
extern int shutter_int;
extern void conf_update_prevent_shutdown(void); 
#endif
