#ifndef PLATFORM_H
#define PLATFORM_H

#include "camera.h"

#define SSID_INVALID (-32767)
#define ASID_INVALID (-32767)

#define MODE_MASK               0x0300
#define MODE_REC                0x0100
#define MODE_PLAY               0x0200

#define MODE_SHOOTING_MASK      0x00FF

#if CAM_PROPSET == 1

 #define PROPCASE_DRIVE_MODE   6
 #define PROPCASE_FOCUS_MODE  12
 #define PROPCASE_MANUAL_FOCUS 12 // 0 = auto, 1 = manual
 #define PROPCASE_FLASH_MODE  16
 #define PROPCASE_CURTAIN     20
 #define PROPCASE_FLASH_OVERRIDE 28
 #define PROPCASE_FLASH_FIRED 78 
 #define PROPCASE_FLASH_MANUAL_OUTPUT 29
 #define PROPCASE_FLASH_FIRE  79
 #define PROPCASE_FLASH_ADJUST_MODE 15
 #define PROPCASE_METERING_MODE  9 
 #define PROPCASE_WB_ADJ     100
 #define PROPCASE_TV		40
 #define PROPCASE_USER_TV     40
 #define PROPCASE_CAMERA_TV	69
 #define PROPCASE_MIN_AV      77
 #define PROPCASE_AV		39
 #define PROPCASE_USER_AV     39
 #define PROPCASE_ALLBEST_AV	68
 #define PROPCASE_ISO		21
 #define PROPCASE_ISO_MODE    21
 #define PROPCASE_SV          73
 #define PROPCASE_DELTA_SV    70
 #define PROPCASE_SV_MARKET   72
 #define PROPCASE_BV          71
 #define PROPCASE_SUBJECT_DIST1 65
 #define PROPCASE_SUBJECT_DIST2 66
 #define PROPCASE_SHOOTING	205
 #define PROPCASE_WILL_USE_FLASH 221
 #define PROPCASE_OVEREXPOSURE 76
// #define PROPCASE_MF_ACTIVE    12 // should be 67 ?
 #define PROPCASE_FOCUS_OK     67   // 0 = not focused, non-zero = focused
 #define PROPCASE_SHOOTING_MODE 0
 #define PROPCASE_QUALITY      23 
 #define PROPCASE_RESOLUTION   24 
 #define PROPCASE_IS_MODE	229
 #define PROPCASE_EV_CORRECTION_1 25
 #define PROPCASE_EV_CORRECTION_2 26
 #define PROPCASE_ORIENTATION_SENSOR 37
 #define PROPCASE_DIGITAL_ZOOM_STATE 58
 #define PROPCASE_DIGITAL_ZOOM_POSITION  57
 #define PROPCASE_DISPLAY_MODE          181
 #define PROPCASE_OPTICAL_ZOOM_POSITION        99 // tested a540, sd400

#elif CAM_PROPSET == 2 
 #define PROPCASE_DRIVE_MODE  102
 #define PROPCASE_FOCUS_MODE   133
 #define PROPCASE_MANUAL_FOCUS 133 // 0 = auto, 1 = manual
 #define PROPCASE_FLASH_MODE   143
 #define PROPCASE_CURTAIN     64     
 #define PROPCASE_FLASH_OVERRIDE 127
 #define PROPCASE_FLASH_FIRED 122 
 #define PROPCASE_FLASH_MANUAL_OUTPUT 141
 #define PROPCASE_FLASH_FIRE  122
 #define PROPCASE_FLASH_ADJUST_MODE 121
 #define PROPCASE_METERING_MODE 155
 #define PROPCASE_WB_ADJ      269 
 #define PROPCASE_TV		264
 #define PROPCASE_USER_TV     264
 #define PROPCASE_CAMERA_TV	262
 #define PROPCASE_MIN_AV      25
 #define PROPCASE_AV		26
 #define PROPCASE_USER_AV     26
 #define PROPCASE_ALLBEST_AV	23
 #define PROPCASE_BV          34
 #define PROPCASE_SUBJECT_DIST1  245
 #define PROPCASE_SUBJECT_DIST2   65
 #define PROPCASE_ISO		149
 #define PROPCASE_ISO_MODE    149
 #define PROPCASE_SV          247
 #define PROPCASE_DELTA_SV     79
 #define PROPCASE_SV_MARKET   246
 #define PROPCASE_SHOOTING	206
 #define PROPCASE_WILL_USE_FLASH   208
 #define PROPCASE_OVEREXPOSURE 103
 #define PROPCASE_FOCUS_OK     115 // ready to shoot, focus OK
 #define PROPCASE_SHOOTING_MODE 49
 #define PROPCASE_QUALITY       57 
 #define PROPCASE_RESOLUTION   218 
 #define PROPCASE_IS_MODE	 145
 #define PROPCASE_EV_CORRECTION_1  107
 #define PROPCASE_EV_CORRECTION_2  207
 #define PROPCASE_ORIENTATION_SENSOR 219
 #define PROPCASE_DIGITAL_ZOOM_STATE  94
 #define PROPCASE_DIGITAL_ZOOM_POSITION 95
 #define PROPCASE_DISPLAY_MODE         105
 #define PROPCASE_TIMER_MODE          223 
 #define PROPCASE_OPTICAL_ZOOM_POSITION        195

#elif CAM_PROPSET == 3
#define PROPCASE_DRIVE_MODE			102
#define PROPCASE_FOCUS_MODE			133
#define PROPCASE_MANUAL_FOCUS             133
#define PROPCASE_FLASH_MODE    		143
#define PROPCASE_CURTAIN                   64
#define PROPCASE_FLASH_OVERRIDE           127 // not confirmed, added for compilation
#define PROPCASE_FLASH_FIRED		      122
#define PROPCASE_FLASH_MANUAL_OUTPUT      141
#define PROPCASE_FLASH_FIRE               122
#define PROPCASE_FLASH_ADJUST_MODE        121
#define PROPCASE_METERING_MODE		155
#define PROPCASE_WB_ADJ                   270
#define PROPCASE_TV	        		266 // this is CHDK PROPCASE_USER_TV
#define PROPCASE_USER_TV       		266
#define PROPCASE_CAMERA_TV	            264 // this is CHDK PROPCASE_TV
#define PROPCASE_MIN_AV       		 25
#define PROPCASE_AV            		 26 // this is CHDK PROPCASE_USER_AV
#define PROPCASE_USER_AV      		 26
#define PROPCASE_ALLBEST_AV	             23 // this is CHDK PROPCASE_AV
#define PROPCASE_BV            		 34
#define PROPCASE_SUBJECT_DIST1 		247
#define PROPCASE_SUBJECT_DIST2 		 65
#define PROPCASE_ISO		    	      149
#define PROPCASE_ISO_MODE		    	149
#define PROPCASE_SV            		249
#define PROPCASE_DELTA_SV      		 79
#define PROPCASE_SV_MARKET     		248
#define PROPCASE_SHOOTING      		208
#define PROPCASE_WILL_USE_FLASH           210
#define PROPCASE_OVEREXPOSURE 		103
#define PROPCASE_FOCUS_OK                 115   // guessed, for compiling only
#define PROPCASE_SHOOTING_MODE		 49
#define PROPCASE_QUALITY			 57
#define PROPCASE_RESOLUTION			220
#define PROPCASE_IS_MODE			145
#define PROPCASE_EV_CORRECTION_1		107
#define PROPCASE_EV_CORRECTION_2		209
#define PROPCASE_ORIENTATION_SENSOR		221
#define PROPCASE_DIGITAL_ZOOM_STATE        94
#define PROPCASE_DIGITAL_ZOOM_POSITION     95
#define PROPCASE_DISPLAY_MODE             105
#define PROPCASE_TIMER_MODE               225
/* NOT USED BY SDM                         */
#define PROPCASE_FLASH_MANUAL_OUTPUT      141
#define PROPCASE_FLASH_ADJUST_MODE       	121
#define PROPCASE_BRACKET_MODE              29
#define PROPCASE_ASPECT_RATIO             294
#define PROPCASE_OPTICAL_ZOOM_POSITION    197

#elif CAM_PROPSET == 4
#define PROPCASE_ALLBEST_AV			 23
#define PROPCASE_MIN_AV				 25
#define PROPCASE_AV				 26
#define PROPCASE_USER_AV			 26
#define PROPCASE_BRACKET_MODE			 29
#define PROPCASE_BV				 34
#define PROPCASE_FOCUS_OK                 115   // guessed, for compiling only
#define PROPCASE_SHOOTING_MODE		 49
#define PROPCASE_QUALITY			 57
#define PROPCASE_FLASH_SYNC_CURTAIN		 64
#define PROPCASE_SUBJECT_DIST2		 65
#define PROPCASE_DELTA_SV			 79
#define PROPCASE_DIGITAL_ZOOM_STATE		 94
#define PROPCASE_DIGITAL_ZOOM_POSITION     95
#define PROPCASE_DRIVE_MODE			102
#define PROPCASE_WILL_USE_FLASH           212
#define PROPCASE_OVEREXPOSURE 		103
#define PROPCASE_DISPLAY_MODE			105
#define PROPCASE_EV_CORRECTION_1		107
#define PROPCASE_FLASH_ADJUST_MODE       	121
#define PROPCASE_FLASH_FIRE			122
#define PROPCASE_FOCUS_MODE			133
#define PROPCASE_FLASH_MODE			143
#define PROPCASE_FLASH_MANUAL_OUTPUT    	141
#define PROPCASE_IS_MODE			145
#define PROPCASE_ISO_MODE		    	149
#define PROPCASE_ISO		    		149
#define PROPCASE_FLASH_OVERRIDE           127  // not confirmed, added for compilation

// changes for S95
#define PROPCASE_METERING_MODE		157
#define PROPCASE_OPTICAL_ZOOM_POSITION	199
#define PROPCASE_EV_CORRECTION_2		211
#define PROPCASE_RESOLUTION			222
#define PROPCASE_ORIENTATION_SENSOR		223
#define PROPCASE_TIMER_MODE			227
#define PROPCASE_SUBJECT_DIST1		249
#define PROPCASE_SV_MARKET			250
#define PROPCASE_SV				251
#define PROPCASE_CAMERA_TV			266
#define PROPCASE_TV				268
#define PROPCASE_USER_TV                  268
#define PROPCASE_WB_ADJ				272
#define PROPCASE_ASPECT_RATIO			300
#define PROPCASE_SHOOTING			303

#else
 #error unknown camera processor

#endif


//Optical & digital zoom status constants, see zoom_status variable
#define ZOOM_OPTICAL_MIN         1
#define ZOOM_OPTICAL_MAX         2
#define ZOOM_OPTICAL_MEDIUM      3
#define ZOOM_OPTICAL_IN          4
#define ZOOM_OPTICAL_OUT         5
#define ZOOM_OPTICAL_REACHED_MIN 7

#define ZOOM_DIGITAL_MAX         9
#define ZOOM_DIGITAL_MEDIUM      10
#define ZOOM_DIGITAL_IN          11
#define ZOOM_DIGITAL_OUT         12
#define ZOOM_DIGITAL_REACHED_MAX 13

//Keyboard repeat and initial delays   only used by ixus65 ?
#define KBD_REPEAT_DELAY  140
#define KBD_INITIAL_DELAY 300

#define SET_NOW      1
#define SET_LATER    0
#define INFINITY 65500

typedef struct {
    short tv96;
    short dtv96;
    short tv96_step;
    short subj_dist;
    short dsubj_dist;
    short subj_dist_step;
    short shoot_counter;
    short type;
} EXPO_BRACKETING_VALUES;

typedef struct {
    short av96;
    short tv96;
    short sv96;
    short subj_dist;
    short nd_filter;
} PHOTO_PARAM;

typedef struct {
    int led_num;
    int action;
    int brightness;
    int blink_count;
} LED_CONTROL;

enum {
MODE_AUTO               =1,
MODE_P                  ,
MODE_TV                 ,
MODE_AV                 ,
MODE_M                  ,
MODE_PORTRAIT           ,
MODE_NIGHT              ,
MODE_LANDSCAPE          ,
MODE_VIDEO_STD          ,
MODE_VIDEO_SPEED        ,
MODE_VIDEO_COMPACT      ,
MODE_VIDEO_MY_COLORS    ,
MODE_VIDEO_COLOR_ACCENT ,
MODE_STITCH             ,
MODE_MY_COLORS          ,
MODE_SCN_WATER          ,
MODE_SCN_NIGHT          ,
MODE_SCN_CHILD          ,
MODE_SCN_PARTY          ,
MODE_SCN_GRASS          ,
MODE_SCN_SNOW           ,
MODE_SCN_BEACH          ,
MODE_SCN_FIREWORK       ,
MODE_SCN_COLOR_ACCENT   ,
MODE_SCN_COLOR_SWAP     ,
MODE_VIDEO_HIRES        ,
MODE_SCN_AQUARIUM       ,
MODE_COLOR_ACCENT       ,
MODE_SCN_NIGHT1         ,
MODE_SCN_ISO_3200       ,
MODE_SCN_SPORT          ,
MODE_SCN_KIDS_PETS      ,
MODE_INDOOR             ,
MODE_KIDS_PETS          ,
MODE_NIGHT_SNAPSHOT     ,
MODE_SCN_NIGHT_SNAPSHOT ,
MODE_LONG_SHUTTER       , // "long shutter" mode on cameras without true manual mode. Allows manual shutter >= 1 second, uses manual shutter value propcase. Usually found under func menu in "manual" mode.
MODE_SCN_LANDSCAPE      ,
MODE_DIGITAL_MACRO      ,
MODE_SCN_FOLIAGE        ,
MODE_VIDEO_TIME_LAPSE   ,
MODE_SCN_INDOOR         ,
MODE_SUPER_MACRO        , 
MODE_COLOR_SWAP         ,
MODE_SCN_PORTRAIT       ,
MODE_VIDEO_MANUAL       ,       
MODE_VIDEO_COLOR_SWAP   ,   
MODE_VIDEO_STITCH       ,       
MODE_VIDEO_PORTRAIT     ,     
MODE_VIDEO_NIGHT        ,        
MODE_VIDEO_INDOOR       ,       
MODE_VIDEO_FOLIAGE      ,      
MODE_VIDEO_SNOW         ,         
MODE_VIDEO_BEACH        ,        
MODE_VIDEO_AQUARIUM     ,
MODE_VIDEO_SUPER_MACRO  ,
MODE_SPORTS             ,
MODE_QUICK  		,
MODE_SCN_SUNSET         , 
MODE_SCN_UNDERWATER     ,
MODE_EASY               ,
MODE_SCN_DIGITAL_MACRO  ,
MODE_SCN_STITCH         ,
MODE_SCN_NIGHT_SCENE    ,
MODE_SCN_LONG_SHUTTER   , 
MODE_LOWLIGHT           ,
MODE_SCN_NOSTALGIC      , // s90
};

#define MODE_SCREEN_MASK        0x0C00
#define MODE_SCREEN_OPENED      0x0400
#define MODE_SCREEN_ROTATED     0x0800

#define MODE_IS_VIDEO(m)   (((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_STD || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_SPEED ||  \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_COMPACT || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_MY_COLORS || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_COLOR_ACCENT || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_COLOR_SWAP || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_TIME_LAPSE || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_PORTRAIT || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_NIGHT || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_INDOOR || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_FOLIAGE || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_SNOW  || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_BEACH || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_AQUARIUM || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_SUPER_MACRO || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_STITCH || \
                            ((m)&MODE_SHOOTING_MASK)==MODE_VIDEO_MANUAL)

typedef struct {
    short int id; // hacks id
    short int prop_id; // Canons id
    char name[8];
    short int shutter_dfs_value; // shutter speed to use dark frame substraction
} ISOTable;

typedef struct {
    short int id; // hacks id
    short int prop_id; // Canons id
    char name[8];
    long usec;
} ShutterSpeed;

typedef struct {
    short int id; // hacks id
    short int prop_id; // Canons id
    char name[8];
} ApertureSize;

int get_focal_length(int zp);
int get_effective_focal_length(int zp);
int get_zoom_x(int zp);
int get_fov(int zp);
int get_mav(int zp);
int get_xav(int zp);
long get_tick_count();
void remount_filesystem();
long get_parameter_data(long id, void *buf, long bufsize);
long set_parameter_data(long id, void *buf, long bufsize);
long get_property_case(long id, void *buf, long bufsize);
long set_property_case(long id, void *buf, long bufsize);
long get_file_counter();
long get_file_next_counter();
long get_target_dir_num();
long get_target_file_num();
long get_physw_copy(int x);
void kbd_key_press(long key);
void kbd_key_release(long key);
void kbd_key_release_all();
long kbd_is_key_pressed(long key);
long kbd_is_key_clicked(long key);
long kbd_get_pressed_key();
long kbd_get_clicked_key();
long kbd_get_autoclicked_key();
void kbd_reset_autoclicked_key();
long kbd_use_zoom_as_mf();
void kbd_set_alt_mode_key_mask(long key);
void wait_until_remote_button_is_released(void);
long vid_is_bitmap_shown();
void *vid_get_bitmap_fb();
long vid_get_bitmap_width();
long vid_get_bitmap_height();
long vid_get_bitmap_screen_width(); 
long vid_get_bitmap_screen_height(); 
long vid_get_bitmap_buffer_width(); 
long vid_get_bitmap_buffer_height(); 
void *vid_get_viewport_fb();
void *vid_get_viewport_fb_d();
void *vid_get_viewport_live_fb();
void vid_bitmap_refresh();
long vid_get_viewport_height();
long vid_get_viewport_width();
void *hook_raw_fptr();
void *hook_raw_ret_addr();
void reverse_bytes_order(char* start, int count); 
char *hook_raw_image_addr();
long hook_raw_size();
void hook_raw_install();
void hook_raw_save_complete();
long lens_get_zoom_pos();
void lens_set_zoom_pos(long newpos);
long lens_get_zoom_point();
void lens_set_zoom_point(long newpt);
void lens_set_zoom_speed(long newspd); //for S-series
int  is_zoom_busy();
long lens_get_focus_pos();
void lens_set_focus_pos(long newpos);
long lens_get_target_distance();
int shooting_in_progress();
int get_inf_focus();
int shooting_is_flash_ready();
extern int fpd;
int shooting_get_tv();
char* shooting_get_tv_str();
char* shooting_get_camera_tv_string();
int shooting_get_tv96_index(int v);
int shooting_get_tv96_from_index(int v);
short shooting_get_svm96();
void shooting_set_sv96(short sv96, short is_now);
short shooting_get_sv96();
void ubasic_shooting_set_focus(int v, short is_now);
void allocate_imgbuf();
void set_camera_tv_override(int v);
int shooting_get_luminance();
void shooting_set_tv(int v);
void shooting_set_tv_rel(int v);
const ShutterSpeed *shooting_get_tv_line();
const ShutterSpeed *shooting_get_camera_tv_line();
int shooting_get_av();
char* shooting_get_av_str();
void shooting_set_av(int v);
void shooting_set_av_rel(int v);
int shooting_get_real_av();
int shooting_get_day_seconds();
int shooting_get_tick_count();
void shooting_set_prop(int id, int v);
int shooting_get_prop(int id);
short shooting_get_canon_overexposure_value();
extern const int zoom_points;
int shooting_get_zoom();
void shooting_set_zoom(int v);
void shooting_set_zoom_rel(int v);
void shooting_set_zoom_speed(int v);
int shooting_get_focus();
void shooting_set_focus(int v);
int shooting_get_iso();
short shooting_get_canon_iso_mode();
short shooting_get_iso_from_sv96(short sv96);
short shooting_get_iso_real();
short shooting_get_iso_market();
const  ISOTable *shooting_get_iso_line();
void shooting_set_iso(int v);
void shooting_set_iso_direct(int v);
void shooting_video_bitrate_change(int v);
extern int auto_started;
void tv_bracketing(int stage);
short shooting_get_real_aperture();
short shooting_get_aperture_sizes_table_size();
short shooting_get_aperture_sizes_table_prop_id(short i);
short shooting_get_max_aperture_sizes_table_prop_id();
short shooting_get_aperture_from_av96(short av96);
void  shooting_set_av96_direct(short v, short is_now);
short shooting_get_av96_override_value();
short shooting_get_av96();
short shooting_get_tv96();
int shooting_get_user_av_id();
short shooting_get_user_av96();
int shooting_get_user_tv_id();
int my_shooting_get_tv_override_value();
short shooting_get_tv96_from_shutter_speed(float t);
float shooting_get_shutter_speed_from_tv96(short tv);
short shooting_get_user_tv96();
void shooting_set_av96_direct(short v,short is_now);
void shooting_set_av96(short v,short is_now);
void shooting_set_user_av_by_id(int v);
void shooting_set_user_av_by_id_rel(int v);
void shooting_set_user_av96(short v);
void shooting_set_nd_filter_state(short v, short is_now);
void shooting_set_user_tv_by_id(int v);
void shooting_set_user_tv_by_id_rel(int v);
void shooting_set_user_tv96(short v);
void shooting_set_tv96(short v, short is_now);
void shooting_set_tv96_direct(short v, short is_now);
short shooting_get_drive_mode();
short shooting_get_focus_mode();
void shooting_bracketing(void);
void shooting_subject_distance_bracketing(void);
void shooting_subject_distance_auto_bracketing();
int shooting_get_subject_distance_bracket_value();
int shooting_get_subject_distance();
long lens_get_focus_pos();
int shooting_get_hyperfocal_distance();
int shooting_get_near_limit_from_subj_dist(int s);
int shooting_get_farpoint(int distance);
short shooting_get_min_real_aperture();

int shooting_set_mode_canon(int mode);

// returns 0 if in play, nonzero if rec
int rec_mode_active(void); 

void ExitTask(void);
void allbest_shooting_set_focus(int v);
short shooting_can_focus();
void TurnOnBackLight(void);
void TurnOffBackLight(void);
void DoAFLock(void); 
void UnlockAF(void); 
int shooting_get_flash_status();
int shooting_will_use_flash();
void wr_kbd_read_keys_r2(void *status);
int lens_to_focal_plane_width; 
long lens_get_focus_pos_from_lense();
int shooting_get_lens_to_focal_plane_width(); 
int get_bracketing_counter();
int mode_get();
long stat_get_vbatt();
long get_vbatt_min();
long get_vbatt_max();
void ubasic_camera_set_raw(int mode);
void ubasic_camera_set_nr(int mode);
int ubasic_camera_get_nr();
int ubasic_camera_script_autostart();
void script_start();
void ubasic_camera_set_script_autostart();
void ubasic_camera_set_tv_override(int mode);
int ubasic_camera_get_tv_override();
void exit_alt();
void camera_shutdown_in_a_second(void);
int get_sd_status();
void disable_shutdown();
void enable_shutdown();
void JogDial_CW(void);
void JogDial_CCW(void);
void change_video_tables(int a, int b);
void set_camera_tv(short int v);
int Get_JogDial(void);
long get_jogdial_direction(void);
char * get_pbb();
int review_fullscreen_mode(void);
int get_usb_power(int edge);
long get_sensor_width();
#ifdef CAMERA_s95
void exmem_malloc_init(void);
#endif
void swap_partitions(void);
int get_part_count(void);
// void create_partitions(void);
extern char * camera_jpeg_count_str();
void get_target_dir_name(char *out);
unsigned int GetJpgCount(void);
unsigned int GetRawCount(void);
unsigned int GetFreeCardSpaceKb(void);
unsigned int GetTotalCardSpaceKb(void);
extern int recreview_hold;
extern int canon_menu_active;  
extern char canon_shoot_menu_active;  
extern EXPO_BRACKETING_VALUES bracketing;
void __attribute__((noreturn)) shutdown();
void debug_led(int state);
#ifdef MOVIE_SYNCH
void blink_led(int x);
#endif
#define started() debug_led(1)
#define finished() debug_led(0)
void play_sound(short sound);
void draw_spm_logo(int x, int y);
void RefreshUSBMode(void);
void PostLogicalEventForNotPowerType(int mode);
void  PostLogicalEventToUI(unsigned event, unsigned unk);
void DisableNotificationPTP(void);
void movie_mode();
void record_mode();
void playback_mode();
int hdrfs();
void ubasic_rm();
void ubasic_pm();
void ubasic_mm();
void ubasic_musbc();
void ubasic_busbc();
void ubasic_set_led(int led, int state, int bright);

//Added spinorkit
int IsUSBHigh();                                     //returns !=0 if USB power line high now
int SerialIOWaitForBit(int state);                   //state 0 or 1
void sio_led(int state);
void OnWaitForRemote(int state_shooting_progress); //Call back from wait_until_remote_button_is_released().

//Constants returned by shooting_get_drive_mode()
enum  
   {
   kDriveSingleShot = 0,
   kDriveContinuous = 1,
   kDriveTimer = CAM_PROPSET+1,
   };
//Added spinorkit end


#if defined(PTP_ENABLED)
typedef struct {
    int code;
    int sess_id;
    int trans_id;
    int num_param;
    int param1;
    int param2;
    int param3;
    int param4;
    int param5;
} PTPContainer;

typedef struct {
    int handle;
    int (*send_data)(int handle, const char *buf, int part_size, int total_size, int, int, int); // (0xFF9F525C), total_size should be 0 except for the first call
    int (*recv_data)(int handle, char *buf, int size, int, int); // (0xFF9F5500)
    int (*send_resp)(int handle, PTPContainer *resp); // (0xFF9F5688)
    int (*get_data_size)(int handle); // (0xFF9F5830)
    int (*send_err_resp)(int handle, PTPContainer *resp); // (0xFF9F5784)
    int unknown1; // ???
    int (*f2)(); // ??? (0xFF8D5B24)
    int (*f3)(); // ??? (0xFF8D5B5C)
    // more??
} ptp_data;

typedef int (*ptp_handler)(int, ptp_data*, int, int, int, int, int, int, int, int);

int add_ptp_handler(int opcode, ptp_handler handler, int unknown);

#endif // PTP_ENABLED



void ExitTask();
#endif

void shutdown_soft();

#if !CAM_DRYOS
void reboot(int);  // 
#else
void reboot(char *fw_update); // fw_update == NULL implies normal reboot
#endif
void switch_mode(int mode); // 0 = playback, 1 = record; only call while USB connected






 





