/**
 * Copyright (c) 2006, Adam Dunkels
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#ifndef __TOKENIZER_H__
#define __TOKENIZER_H__

typedef enum {
  TOKENIZER_ERROR,
  TOKENIZER_ENDOFINPUT,
  TOKENIZER_NUMBER,
  TOKENIZER_STRING,
  TOKENIZER_VARIABLE,
  TOKENIZER_LET,
  TOKENIZER_PRINT_SCREEN,
  TOKENIZER_PRNT,
  TOKENIZER_IF,
  TOKENIZER_THEN,
// 10
  TOKENIZER_ELSE,
  TOKENIZER_ENDIF,
  TOKENIZER_FOR,
  TOKENIZER_TO,
  TOKENIZER_NEXT,
  TOKENIZER_STEP,
  TOKENIZER_GOTO,
  TOKENIZER_DO,
  TOKENIZER_UNTIL,
  TOKENIZER_WHILE,
// 20
  TOKENIZER_WEND,
  TOKENIZER_GOSUB,
  TOKENIZER_RETURN,
  TOKENIZER_CALL,
  TOKENIZER_REM,
  TOKENIZER_END,
  TOKENIZER_CLS,
  TOKENIZER_COMMA,
  TOKENIZER_SEMICOLON,
  TOKENIZER_PLUS,
// 30
  TOKENIZER_MINUS,
  TOKENIZER_AND,
  TOKENIZER_OR,
  TOKENIZER_XOR,
  TOKENIZER_ASTR,
  TOKENIZER_SLASH,
  TOKENIZER_MOD,
  TOKENIZER_LEFTPAREN,
  TOKENIZER_RIGHTPAREN,
  TOKENIZER_LT,
// 40
  TOKENIZER_PERIOD,
  TOKENIZER_GT,
  TOKENIZER_EQ,
  TOKENIZER_NE,
  TOKENIZER_LE,
  TOKENIZER_GE,
  TOKENIZER_LNOT,
  TOKENIZER_LAND,
  TOKENIZER_LOR,
  TOKENIZER_CR,
  TOKENIZER_LABEL,
// 50
  TOKENIZER_SLEEP,
  TOKENIZER_CLICK,
  TOKENIZER_PRESS,
  TOKENIZER_RELEASE,
  TOKENIZER_SHOOT,
  TOKENIZER_SET_TV96_DIRECT,
  TOKENIZER_SET_TV,
  TOKENIZER_SET_AV,
  TOKENIZER_SET_FOCUS,
  TOKENIZER_GET_DAY_SECONDS,
  TOKENIZER_GET_TICK_COUNT,
  TOKENIZER_SET_ZOOM,
  TOKENIZER_SET_ZOOM_SPEED,
  TOKENIZER_SET_ZOOM_REL,
  TOKENIZER_SET_ISO,
  TOKENIZER_GET_PROP,
  TOKENIZER_SET_PROP,
  TOKENIZER_WAIT_CLICK,
  TOKENIZER_IS_KEY,
  TOKENIZER_MD_DETECT_MOTION,
  TOKENIZER_MD_GET_CELL_DIFF,
  TOKENIZER_MEM_DUMP,
  TOKENIZER_SET_RAW,
  TOKENIZER_GET_SHOOTING,
  TOKENIZER_BLUE_OFF,
  TOKENIZER_BLUE_ON,
  TOKENIZER_WHEEL_RIGHT,
  TOKENIZER_WHEEL_LEFT,
  TOKENIZER_SCRIPT_AUTOSTART,
  TOKENIZER_SET_SCRIPT_AUTOSTART,
  TOKENIZER_GET_USB_POWER,
  TOKENIZER_EXIT_ALT,
  TOKENIZER_SET_ND_FILTER, 
  TOKENIZER_SET_SYNC,
  TOKENIZER_GET_SYNC,
//  TOKENIZER_DISABLE_MAIN_FLASH,
//  TOKENIZER_ENABLE_MAIN_FLASH,
  TOKENIZER_GET_USER_TV_ID,
  TOKENIZER_GET_FLASH_MODE,
  TOKENIZER_DISABLE_USB_DOWNLOAD,
  TOKENIZER_ENABLE_USB_DOWNLOAD,
  TOKENIZER_GET_VIDEO_BUTTON,
  TOKENIZER_GET_MODE,
  TOKENIZER_PLAY_SOUND, 
  TOKENIZER_BEEP, 
  TOKENIZER_GET_RESOLUTION, 
  TOKENIZER_GET_QUALITY, 
  TOKENIZER_SET_RESOLUTION, 
  TOKENIZER_SET_QUALITY,
  TOKENIZER_GET_ZOOM,
  TOKENIZER_GET_ZOOM_STEPS,
  TOKENIZER_MOVIE,
  TOKENIZER_RECORD,
  TOKENIZER_PLAYBACK,
  TOKENIZER_SHOOT_MOVIE,
  TOKENIZER_USBUP,
  TOKENIZER_SLEEP_M,
  TOKENIZER_SLEEP_S,
  TOKENIZER_MUSBC,
  TOKENIZER_BUSBC,
  TOKENIZER_GET_MAX_SPT,
  TOKENIZER_SET_MAX_SPT,
 // TOKENIZER_END_UPLOAD,
  TOKENIZER_SHUT_DOWN,
  TOKENIZER_BRACKETING,
  TOKENIZER_SET_BE,
  TOKENIZER_SET_FS,
  TOKENIZER_SET_FR,
  TOKENIZER_SS,
  TOKENIZER_GET_FR,
  TOKENIZER_MFB,
  TOKENIZER_AFB,
  TOKENIZER_DB,
  TOKENIZER_SSB,
  TOKENIZER_BL,
  TOKENIZER_BD,
  TOKENIZER_BA,
  TOKENIZER_SCSEQ,
  TOKENIZER_ECSEQ,
  TOKENIZER_WUD,
  TOKENIZER_WFSP,
  TOKENIZER_SCTSEQ,
  TOKENIZER_BLCD,
  TOKENIZER_TL,
  TOKENIZER_USBD,
  TOKENIZER_LA,
  TOKENIZER_UA,
  TOKENIZER_SET_AFLOCK,
  TOKENIZER_SET_BACKLIGHT,
  TOKENIZER_TBN,
  TOKENIZER_TBF,
  TOKENIZER_SDMCN,
  TOKENIZER_SDMCF,
  TOKENIZER_SDMCL,
  TOKENIZER_SDMCLL,
  TOKENIZER_SLEEP_UNTIL,
  TOKENIZER_FT,
  TOKENIZER_SYNC_ON,
  TOKENIZER_SYNC_OFF,
  TOKENIZER_SD,
  TOKENIZER_DR,
  TOKENIZER_UP,
  TOKENIZER_GET_FREE_DISK_SPACE,
  TOKENIZER_AFLF,
  TOKENIZER_AFLO,
  TOKENIZER_AFLOFF,
  TOKENIZER_MSS,
  TOKENIZER_NDFO,
  TOKENIZER_NDFI,
  TOKENIZER_NDFF,
  TOKENIZER_GET_FOCUS,
  TOKENIZER_CAMPOS,
  TOKENIZER_UB,
  TOKENIZER_GET_LUMINANCE,
  TOKENIZER_SWS,
  TOKENIZER_SWNM,
  TOKENIZER_SSPD,
  TOKENIZER_AP,
  TOKENIZER_LINE_ONE,
  TOKENIZER_LINE_TWO,
  TOKENIZER_LINE_THREE,
  TOKENIZER_CEV,
  TOKENIZER_HDR_STACK,
  TOKENIZER_TUP,
  TOKENIZER_UAFL,
  TOKENIZER_UPL,
  TOKENIZER_OVERLAY_ON,
  TOKENIZER_OVERLAY_OFF,
  TOKENIZER_LOAD_OVERLAY,
  TOKENIZER_SET_LED,
  TOKENIZER_GET_FOV,
  TOKENIZER_RESET,
  TOKENIZER_SAVE_FOCUS,
  TOKENIZER_SAVE_ZOOM,
  TOKENIZER_RESTORE_FOCUS,
  TOKENIZER_RESTORE_ZOOM,
  TOKENIZER_AF_FIRST,
  TOKENIZER_AF_ALL
} ubasic_token;

void tokenizer_init(const char *program);
void tokenizer_next(void);
int tokenizer_token(void);
int tokenizer_num(void);
int tokenizer_variable_num(void);
void tokenizer_string(char *dest, int len);
void tokenizer_label(char *dest, int len);

int tokenizer_line_number(void);

int tokenizer_finished(void);
void tokenizer_error_print(void);

#endif /*__TOKENIZER_H__ */
