#include "platform.h"
#include "lolevel.h"
#include "gui.h"
#include "..\\..\\core\\draw_palette.h"

static char*    frame_buffer[2];


void shutdown()
{
    volatile long *p = (void*)0xc022012C; // from S90

    asm(
         "MRS     R1, CPSR\n"
         "AND     R0, R1, #0x80\n"
         "ORR     R1, R1, #0x80\n"
         "MSR     CPSR_cf, R1\n"
         :::"r1","r0");

    *p = 0x44;

    while(1);
}


#define LED_GREEN 0xc0220130

void debug_led(int state)
{
    if (state)
		*((long*) LED_GREEN) = 0x46;
    else
		*((long*) LED_GREEN) = 0x44;
}
void ubasic_set_led(int led, int state, int bright)
{
  static char led_table[7]={0,0,1,1,1,9,9};
 if(led >=4 && led <= 10)
  _LEDDrive(led_table[(led-4)%sizeof(led_table)], state<=1 ? !state : state);
}

/*
void ubasic_set_led(int led, int state, int bright) 
{
	static char led_table[4]={0,1,9,10};

    _LEDDrive(led_table[led%sizeof(led_table)], state<=1 ? !state : state);
}
*/

// TODO - check this
int get_flash_params_count(void){
	return 130;
}

/*
// Phil changes should make the screen draw and refresh work better
void vid_bitmap_refresh()
{
	extern int full_screen_refresh;
	extern void _LockAndRefresh();
	extern void _ScreenUnlock();

	full_screen_refresh |= 3;
	_LockAndRefresh();
	_ScreenUnlock();
}
*/

void vid_bitmap_refresh()
{
	 extern int enabled_refresh_physical_screen; // screen lock counter
	 extern void _ScreenUnlock();

	_ScreenLock();
	enabled_refresh_physical_screen=1;
	_ScreenUnlock();
}

void shutdown_soft()
{
   _PostLogicalEventForNotPowerType(0x1005,0);
}


void reboot(char *fw_update)
{
  if ( fw_update == 0 )
  {
    // sequence taken from reboot_fw_update
    // removed here due to unknown s95 addresses
    /*
    ((void (*)()) 0xFF94F7B8)();
    ((void (*)()) 0xFF842480)();
    ((void (*)()) 0xFF841594)();
    ((void (*)()) 0xFF8704F4)();
    ((void (*)(int)) 0xFF8293DC)(0);
    */
  } else {
    _reboot_fw_update(fw_update);
  }
}


void switch_mode(int mode)
{
  if ( mode == 0 )
  {
    _Rec2PB();
    _set_control_event(0x80000902); // 0x10A5 ConnectUSBCable
  } else if ( mode == 1 )
  {
    _set_control_event(0x902); // 0x10A6 DisconnectUSBCable
    _PB2Rec();
  }
}
