#include "lolevel.h"
#include "platform.h"
#include "core.h"

#define RAWDATA_AVAILABLE (1)
#define RAWDATA_SAVED (2)

#define NR_ON (2)
#define NR_OFF (1)

static long raw_save_stage;
volatile long shutter_open_time=0; // for DNG EXIF creation
void capt_seq_hook_raw_here()
{
    raw_save_stage = RAWDATA_AVAILABLE;
    core_rawdata_available();
    while (raw_save_stage != RAWDATA_SAVED){
	_SleepTask(10);
    }
}

void hook_raw_save_complete()
{
    raw_save_stage = RAWDATA_SAVED;
}


void capt_seq_hook_set_nr()
{
    long *nrflag = (long*)0xE21C;

    switch (core_get_noise_reduction_value()){
    case NOISE_REDUCTION_AUTO_CANON:
	// leave it alone
	break;
    case NOISE_REDUCTION_OFF:
	*nrflag = 1;
	break;
   case NOISE_REDUCTION_ON:
	*nrflag = 2;
	break;
    };
   shutter_open_time=_time((void*)0); 
}
// FF931550_my
void __attribute__((naked,noinline)) sub_FF933C64_my(){ 
 asm volatile(
                "STMFD   SP!, {R0-R10,LR}\n"
                "MOV     R6, #0\n"
                "MOV     R4, R0\n"
                "BL      sub_FF934790\n"
                "MVN     R1, #0\n"		//MOVL    R1, 0xFFFFFFFF\n"
                "BL      sub_FF828E88\n"
                "MOV     R2, #4\n"
                "ADD     R1, SP, #8\n"
                "MOV     R0, #0x8A\n"
                "BL      sub_FF869828\n"
                "TST     R0, #1\n"
                "LDRNE   R1, =0x20A\n"
                "LDRNE	 R0, =0xFF933E38\n"
                "BLNE    sub_FF81BFC8\n"
                "LDR     R8, =0x1DBA8\n"
                "LDR     R5, =0x1DAF4\n"
                "LDRSH   R1, [R8,#0xE]\n"
                "LDR     R0, [R5,#0x7C]\n"
                "BL      sub_FF8F1988\n"
                "BL      sub_FF846CA8\n"
                "LDR     R2, =0xE220\n"
                "ADD     R3, R4, #0x8C\n"
                "STRH    R0, [R4,#0x88]\n"
 //               "STRD    R2, [SP]\n"
                "STR     R2, [SP]\n"
                "STR     R3, [SP,#4]\n"
                "MOV     R1, R0\n"
                "LDRH    R0, [R5,#0x54]\n"
                "LDRSH   R2, [R8,#0xC]\n"
                "LDR     R3, =0xE21C\n"
                "BL      sub_FF934C84\n"
                "BL      wait_until_remote_button_is_released\n"
                "BL      capt_seq_hook_set_nr\n"
                "B       sub_FF933CD8\n"
 );
}
// FF85C054
void __attribute__((naked,noinline)) sub_FF85C3B0_my() //#fs
{
	asm volatile (
                "STMFD   SP!, {R4-R6,LR}\n"
                "LDR     R4, [R0,#0xC]\n"
                "LDR     R6, =0x1DAF4\n"
                "LDR     R0, [R4,#8]\n"
                "MOV     R5, #0\n"
                "ORR     R0, R0, #1\n"
                "STR     R0, [R4,#8]\n"
                "LDR     R0, [R6,#0x24]\n"
                "CMP     R0, #0\n"
                "MOVEQ   R0, #2\n"
                "BLEQ    sub_FF856A0C\n"
                "BL      sub_FF9325E8\n"
                "LDR     R0, [R6,#0x24]\n"
                "CMP     R0, #0\n"
                "BNE     loc_FF85C430\n"
                "MOV     R0, R4\n"
                "BL      sub_FF932A7C\n"
                "TST     R0, #1\n"
                "MOVNE   R2, R4\n"
                "LDMNEFD SP!, {R4-R6,LR}\n"
                "MOVNE   R1, #1\n"
                "BNE     sub_FF85A89C\n"
                "BL      sub_FF947168\n"
                "BL      sub_FF8699B8\n"
                "STR     R0, [R4,#0x14]\n"
                "MOV     R0, R4\n"
                "BL      sub_FF933B7C\n"
                "BL      sub_FF934624\n"
                "MOV     R0, R4\n"
                "BL      sub_FF933C64_my\n"        // sub_FF931550-------------->
                "BL      capt_seq_hook_raw_here\n"  //-------------->
                "MOV     R5, R0\n"
                "B       loc_FF85C440\n"
	"loc_FF85C430:\n"
                "LDR     R0, =0x5648\n"
                "LDR     R0, [R0,#4]\n"
                "CMP     R0, #0\n"
                "MOVNE   R5, #0x1D\n"
	"loc_FF85C440:\n"
                "MOV     R2, R4\n"
                "MOV     R1, #1\n"
                "MOV     R0, R5\n"
                "BL      sub_FF85A89C\n"
                "BL      sub_FF93406C\n"
                "CMP     R0, #0\n"
                "LDRNE   R0, [R4,#8]\n"
                "ORRNE   R0, R0, #0x2000\n"
                "STRNE   R0, [R4,#8]\n"
                "LDMFD   SP!, {R4-R6,PC}\n"
 );
}

void __attribute__((naked,noinline)) task_CaptSeqTask_my() //#fs
{
	asm volatile (
                "STMFD   SP!, {R3-R9,LR}\n"
                "LDR     R6, =0x1DAF4\n"
                "LDR     R5, =0x5648\n"
                "MOV     R9, #1\n"
                "MOV     R7, #0\n"
	"loc_FF85C080:\n"
                "LDR     R0, [R5,#0xC]\n"
                "MOV     R2, #0\n"
                "MOV     R1, SP\n"
                "BL      sub_FF8290D8\n"
                "TST     R0, #1\n"
                "BEQ     loc_FF85C0AC\n"
                "LDR     R1, =0x43F\n"
                "LDR	 R0, =0xFF85BE04\n"    // aSsshoottask_c ; SsShootTask.c
                "BL      sub_FF81BFC8\n"
                "BL      sub_FF81BD80\n"
                "LDMFD   SP!, {R3-R9,PC}\n"
	"loc_FF85C0AC:\n"
                "LDR     R0, [SP]\n"
                "LDR     R1, [R0]\n"
                "CMP     R1, #0x17\n"
                "ADDLS   PC, PC, R1,LSL#2\n"
                "B       loc_FF85C29C\n"
	"loc_FF85C0C0:\n"
                "B       loc_FF85C120\n"
	"loc_FF85C0C4:\n"
                "B       loc_FF85C188\n"
	"loc_FF85C0C8:\n"
                "B       loc_FF85C190\n"
	"loc_FF85C0CC:\n"
                "B       loc_FF85C1A8\n"
	"loc_FF85C0D0:\n"
                "B       loc_FF85C19C\n"
	"loc_FF85C0D4:\n"
                "B       loc_FF85C1B0\n"
	"loc_FF85C0D8:\n"
                "B       loc_FF85C1B8\n"
	"loc_FF85C0DC:\n"
                "B       loc_FF85C1C0\n"
	"loc_FF85C0E0:\n"
                "B       loc_FF85C218\n"
	"loc_FF85C0E4:\n"
                "B       loc_FF85C224\n"
	"loc_FF85C0E8:\n"
                "B       loc_FF85C22C\n"
	"loc_FF85C0EC:\n"
                "B       loc_FF85C234\n"
	"loc_FF85C0F0:\n"
                "B       loc_FF85C23C\n"
	"loc_FF85C0F4:\n"
                "B       loc_FF85C244\n"
	"loc_FF85C0F8:\n"
                "B       loc_FF85C24C\n"
	"loc_FF85C0FC:\n"
                "B       loc_FF85C254\n"
	"loc_FF85C100:\n"
                "B       loc_FF85C25C\n"
	"loc_FF85C104:\n"
                "B       loc_FF85C268\n"
	"loc_FF85C108:\n"
                "B       loc_FF85C270\n"
	"loc_FF85C10C:\n"
                "B       loc_FF85C278\n"
	"loc_FF85C110:\n"
                "B       loc_FF85C280\n"
	"loc_FF85C114:\n"
                "B       loc_FF85C28C\n"
	"loc_FF85C118:\n"
                "B       loc_FF85C294\n"
	"loc_FF85C11C:\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C120:\n"
                "BL      sub_FF93260C\n"
                "BL      tv_override\n"    // +
                "BL      sub_FF85A2F0\n"
                "LDR     R0, [R6,#0x24]\n"
                "CMP     R0, #0\n"
                "BEQ     loc_FF85C2A8\n"
                "BL      sub_FF85BAD0\n"
                "MOV     R4, R0\n"
                "LDR     R0, [R6,#0x24]\n"
                "CMP     R0, #0\n"
                "BEQ     loc_FF85C168\n"
                "MOV     R0, #0xC\n"
                "BL      sub_FF85F1A4\n"
                "TST     R0, #1\n"
                "STRNE   R9, [R5,#4]\n"
                "LDRNE   R0, [R4,#8]\n"
                "ORRNE   R0, R0, #0x40000000\n"
                "STRNE   R0, [R4,#8]\n"
                "BNE     loc_FF85C2A8\n"
	"loc_FF85C168:\n"
                "BL      sub_FF947168\n"
                "BL      sub_FF8699B8\n"
                "STR     R0, [R4,#0x14]\n"
                "MOV     R0, R4\n"
                "BL      sub_FF933C64\n"
                "TST     R0, #1\n"
                "STRNE   R9, [R5,#4]\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C188:\n"
                "BL      sub_FF85C3B0_my\n"		//------------------->
                "B       loc_FF85C1A0\n"
	"loc_FF85C190:\n"
                "MOV     R0, #1\n"
                "BL      sub_FF9327B0\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C19C:\n"
                "BL      sub_FF9322A8\n"
	"loc_FF85C1A0:\n"
                "STR     R7, [R6,#0x24]\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C1A8:\n"
                "BL      sub_FF9325D8\n"
                "B       loc_FF85C1A0\n"
	"loc_FF85C1B0:\n"
                "BL      sub_FF9325E0\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C1B8:\n"
                "BL      sub_FF9326D0\n"
                "B       loc_FF85C21C\n"
	"loc_FF85C1C0:\n"
                "LDR     R4, [R0,#0xC]\n"
                "BL      sub_FF9325E8\n"
                "MOV     R0, R4\n"
                "BL      sub_FF932DFC\n"
                "TST     R0, #1\n"
                "MOV     R8, R0\n"
                "BNE     loc_FF85C200\n"
                "BL      sub_FF8699B8\n"
                "STR     R0, [R4,#0x14]\n"
                "MOV     R0, R4\n"
                "BL      sub_FF933B7C\n"
                "MOV     R0, R4\n"
                "BL      sub_FF9340CC\n"
                "MOV     R8, R0\n"
                "LDR     R0, [R4,#0x14]\n"
                "BL      sub_FF869BCC\n"
	"loc_FF85C200:\n"
                "BL      sub_FF9325D8\n"
                "MOV     R2, R4\n"
                "MOV     R1, #8\n"
                "MOV     R0, R8\n"
                "BL      sub_FF85A89C\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C218:\n"
                "BL      sub_FF93272C\n"
	"loc_FF85C21C:\n"
                "BL      sub_FF85A2F0\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C224:\n"
                "BL      sub_FF9325D8\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C22C:\n"
                "BL      sub_FF933068\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C234:\n"
                "BL      sub_FF933220\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C23C:\n"
                "BL      sub_FF9332B0\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C244:\n"
                "BL      sub_FF933364\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C24C:\n"
                "BL      sub_FF93354C\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C254:\n"
                "BL      sub_FF93359C\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C25C:\n"
                "MOV     R0, #0\n"
                "BL      sub_FF933620\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C268:\n"
                "BL      sub_FF933760\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C270:\n"
                "BL      sub_FF9337F4\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C278:\n"
                "BL      sub_FF9338B4\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C280:\n"
                "BL      sub_FF9328D4\n"
                "BL      sub_FF825B44\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C28C:\n"
                "BL      sub_FF933420\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C294:\n"
                "BL      sub_FF93348C\n"
                "B       loc_FF85C2A8\n"
	"loc_FF85C29C:\n"
                "LDR     R1, =0x523\n"
                "LDR	 R0, =0xFF85BE04\n"   // aSsshoottask_c ; SsShootTask.c
                "BL      sub_FF81BFC8\n"
	"loc_FF85C2A8:\n"
                "LDR     R0, [SP]\n"
                "LDR     R1, [R0,#4]\n"
                "LDR     R0, [R5,#8]\n"
                "BL      sub_FF828E54\n"
                "LDR     R4, [SP]\n"
                "LDR     R0, [R4,#8]\n"
                "CMP     R0, #0\n"
                "LDREQ	 R0, =0xFF85BE04\n"   // aSsshoottask_c ; SsShootTask.c
                "MOVEQ   R1, #0xFC\n"
                "BLEQ    sub_FF81BFC8\n"
                "STR     R7, [R4,#8]\n"
                "B       loc_FF85C080\n"
    );
} //#fe
